package jhdz.difusion.data.data.login;

import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.android.volley.*;
import com.android.volley.Request;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;

import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import jhdz.cultural.R;
import jhdz.difusion.constantes.URL_API;
import jhdz.difusion.data.cultural.DetailsActivity;
import jhdz.difusion.data.menu_activity.Menu_Activity;

public class LoginActivity extends AppCompatActivity {

    EditText txtUsername, txtPassword;
    Button btnLogin;
    TextView registro,link_recupera;
    Session session;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        session =new Session(LoginActivity.this);

        btnLogin=(Button)findViewById(R.id.btn_login);

        txtUsername = (EditText) findViewById(R.id.input_email);
        txtPassword = (EditText) findViewById(R.id.input_password);
        registro =(TextView)findViewById(R.id.link_signup);
        link_recupera =(TextView)findViewById(R.id.link_recupera);

        link_recupera.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent activity = new Intent(getApplicationContext(), DetailsActivity.class);
                startActivity(activity);

            }
        });

        registro.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                startActivity(new Intent(getApplicationContext(),RegistroActivity.class));
            }
        });


        btnLogin.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Login();
            }


        });
    }

    public void Login() {

        final ProgressDialog progressDialog = new ProgressDialog(LoginActivity.this,
                ProgressDialog.STYLE_HORIZONTAL);
        progressDialog.setIndeterminate(true);
        progressDialog.setCancelable(false);
        progressDialog.show();




        new Handler().postDelayed(new Runnable(){
            public void run(){

        if (Validacion() ==false) {

            LoginFailed();
            progressDialog.dismiss();
        }
        if(Validacion()==true) {

            StringRequest stringRequest = new StringRequest(Request.Method.POST, URL_API.LOGIN,
                    new Response.Listener<String>() {
                        @Override
                        public void onResponse(String response) {
                            progressDialog.dismiss();


                            Pattern pat = Pattern.compile(".*error.*");
                            Matcher mat = pat.matcher(response);
                            if (mat.find()) {

                                Toast.makeText(LoginActivity.this,response+"Usuario o contraseña incorrectos.",Toast.LENGTH_LONG).show();

                            } else {

                                 Intent activity = new Intent(LoginActivity.this,Menu_Activity.class);
                                 startActivity(activity);
                                 session.createLoginSession(txtUsername.getText().toString());
                                 finish();
                            }



                        }
                    },
                    new Response.ErrorListener() {
                        @Override
                        public void onErrorResponse(VolleyError error) {
                            Log.d("",error.toString());
                            Toast.makeText(getApplicationContext(),"Error al intentar conectarse.",Toast.LENGTH_LONG).show();
                            progressDialog.dismiss();
                        }
                    }) {
                @Override
                protected Map<String, String> getParams() {
                    Map<String, String> params = new HashMap<String, String>();
                    params.put("correo", txtUsername.getText().toString());
                    params.put("contrasena", txtPassword.getText().toString());

                    return params;
                }

            };

            RequestQueue requestQueue = Volley.newRequestQueue(LoginActivity.this);
            requestQueue.add(stringRequest);

        }


            };
        }, 1500);

    }
    public  void LoginFailed(){
        btnLogin.setEnabled(true);
    }



    public boolean Validacion() {



        String email = txtUsername.getText().toString();
        String password = txtPassword.getText().toString();

        if (email.isEmpty() ) {
            txtUsername.setError("Introduce una direción valida");
            return   false;
        } else {
            txtPassword.setError(null);
        }

        if( !android.util.Patterns.EMAIL_ADDRESS.matcher(email).matches()){
            return false;
        }

        if (password.isEmpty() || password.length() < 7 ) {
            txtPassword.setError("Tu contraseña debe contener minimo 8 caraacteres");
           return false;
        } else {
            txtPassword.setError(null);
        }

        return true;
    }

    @Override
    public void onBackPressed() {

        finish();

        }

}


