package jhdz.difusion.data.data.login;

/**
 * Created by core on 19/02/18.
 */

import java.util.HashMap;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;

import jhdz.difusion.data.menu_activity.Menu_Activity;


public class Session {


    SharedPreferences pref;
    Editor editor;

    Context context;

    int PRIVATE_MODE = 0;

    // nombre del archivo preference
    private static final String DATA_USER = "culturalUser";

    // llave principal
    private static final String IS_LOGIN = "login";

    public static final String KEY_NAME = "";


    public static final String KEY_EMAIL = "";
    public static final String KEY_ID_USER= "";

    public static final String KEY_PASSWORD= "";

    // Constructor
    public Session(Context context){
        this.context = context;
        pref = this.context.getSharedPreferences(DATA_USER, PRIVATE_MODE);
        editor = pref.edit();
    }

    /**
     * Crear session
     * */
    public void createLoginSession(String correo){

        editor.putBoolean(IS_LOGIN, true);
        editor.putString(KEY_NAME, correo);

        editor.commit();

    }


    public void checkLogin(){

        if(!this.isLoggedIn()) {
            /*
            * Reedireción al login en caso de no haber datos
            * */
            Intent i = new Intent(context, LoginActivity.class);
            i.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
            i.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            context.startActivity(i);

        }else{

            /*
            * Redireción por splash
            * */
            Intent i = new Intent(context, Menu_Activity.class);
            i.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
            i.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            context.startActivity(i);

        }
    }



    /**
     * Get stored session data
     * */
    public HashMap<String, String> getUserDetails(){
        HashMap<String, String> user = new HashMap<String, String>();
        // user name
        user.put(KEY_NAME, pref.getString(KEY_NAME, null));

        user.put(KEY_ID_USER, pref.getString(KEY_ID_USER, null));
        // user email id
        user.put(KEY_EMAIL, pref.getString(KEY_EMAIL, null));

        // return user
        return user;
    }

    /**
     * Clear session details
     * */
    public void logoutUser(){
        // Clearing all data from Shared Preferences
        editor.clear();
        editor.commit();

        Intent i = new Intent(context, LoginActivity.class);
        // cerrar actividades anteriores
        i.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);

        // agregar una nueva activity
        i.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        context.startActivity(i);


    }

    /**
     * Revisar logeo
     * **/
    //
    public boolean isLoggedIn(){
        return pref.getBoolean(IS_LOGIN, false);
    }
}
