package jhdz.difusion.data.evento;

/**
 * Created by core on 19/02/18.
 */


import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.Volley;
import com.squareup.picasso.Picasso;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import jhdz.cultural.R;
import jhdz.difusion.constantes.URL_API;


public class AdaptadorEventos extends ArrayAdapter {


        private RequestQueue requestQueue;
        JsonObjectRequest jsArrayRequest;

        private static final String TAG = "AdaptadorEventos";
        List<Datos> items;

        public AdaptadorEventos(Context context,String ID_CATEGORIA) {
            super(context,0);


            /*
            * Petición de datos por metodo get
            * */
            requestQueue= Volley.newRequestQueue(context);


            jsArrayRequest = new JsonObjectRequest(
                    Request.Method.GET,
                    URL_API.EVENTO+ID_CATEGORIA,
                    null,
                    new Response.Listener<JSONObject>() {
                        @Override
                        public void onResponse(JSONObject response) {
                            items = parseJson(response);
                            notifyDataSetChanged();
                        }
                    },
                    new Response.ErrorListener() {
                        @Override
                        public void onErrorResponse(VolleyError error) {
                            Log.d(TAG, "Error Respuesta en JSON: " + error.getMessage());

                        }
                    }
            );


            requestQueue.add(jsArrayRequest);
        }

        @Override
        public int getCount() {
            return items != null ? items.size() : 0;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {

            LayoutInflater layoutInflater = LayoutInflater.from(parent.getContext());


            View listItemView;


            listItemView = null == convertView ? layoutInflater.inflate(
                    R.layout.tarjeta_eventos,
                    parent,
                    false) : convertView;


            Datos item = items.get(position);




            TextView textoTitulo = (TextView) listItemView.
                    findViewById(R.id.textoTitulo);

            TextView textoDescripcion = (TextView) listItemView.
                    findViewById(R.id.textoDescripcion);

            final ImageView imagenPost = (ImageView) listItemView.
                    findViewById(R.id.imagenPost_);

            TextView fecha_inicial = (TextView)listItemView.
                    findViewById(R.id.fecha_inicial);

            TextView fecha_final = (TextView)listItemView.
                    findViewById(R.id.fecha_final);

            TextView lugar = (TextView)listItemView.
                    findViewById(R.id.url);

            textoTitulo.setText(item.getEvento_nombre());
            fecha_inicial.setText("Inicia: "+item.getEvento_fecha_inicio());
            fecha_final.setText("Finaliza: "+item.getEvento_fecha_final());
            textoDescripcion.setText(item.getEvento_descripcion());
            lugar.setText("Ubicación: "+item.getEvento_ubicacion());

            Picasso.with(getContext())
                    .load(URL_API.SOURCE+item.getEvento_img())
                    .centerCrop()
                    .fit()
                    .error(R.drawable.ic_build_black_24dp)
                    .into(imagenPost);



            return listItemView;
        }

        public List<Datos> parseJson(JSONObject jsonObject){

            List<Datos> posts = new ArrayList();
            JSONArray jsonArray= null;

            try {

                /*
                * Arreglo a deserealizar
                *
                * */
                jsonArray = jsonObject.getJSONArray("evento");

                for(int i=0; i<jsonArray.length(); i++){

                    try {
                        JSONObject objeto= jsonArray.getJSONObject(i);

                        Datos datos = new Datos(
                                objeto.getString("evento_nombre"),
                                objeto.getString("evento_descripcion"),
                                objeto.getString("evento_img"),
                                objeto.getString("evento_fecha_inicio"),
                                objeto.getString("evento_fecha_final"),
                                objeto.getString("evento_ubicacion")

                                );


                        posts.add(datos);

                    } catch (JSONException e) {
                        Log.e(TAG, "Error de parsing: "+ e.getMessage());
                    }
                }

            } catch (JSONException e) {
                e.printStackTrace();
            }


            return posts;
        }
}
