package jhdz.difusion.data.perfil;

import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Intent;
import android.graphics.Color;
import android.os.Handler;
import android.support.constraint.ConstraintLayout;
import android.support.design.widget.BaseTransientBottomBar;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Toast;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import jhdz.cultural.R;
import jhdz.difusion.constantes.URL_API;
import jhdz.difusion.data.data.login.RegistroActivity;
import jhdz.difusion.data.data.login.Session;
import jhdz.difusion.data.menu_activity.Menu_Activity;

public class Perfil extends AppCompatActivity {
    private static final String TAG = RegistroActivity.class.getSimpleName();
    private static final int DATE_DIALOG_ID = 1;

    private int year;
    private int month;
    private int day;
    private String currentDate;
    EditText correo, pass,re_pass;
    EditText nombre, apellido;
    Button actualizar_button;

    Button f_na, enviar_datos, enviar_acceso;


    private ProgressDialog pDialog;

    String ID_USER;
    String FEC = "";
    ConstraintLayout ct;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.update);

        pDialog = new ProgressDialog(this);
        pDialog.setMessage("Espera...");
        pDialog.setCancelable(false);
        pDialog.show();

        DOWNLOAD_Perfil();
        final Calendar c = Calendar.getInstance();
        year = c.get(Calendar.YEAR);
        month = c.get(Calendar.MONTH);
        day = c.get(Calendar.DAY_OF_MONTH);

        nombre = (EditText) findViewById(R.id.textnom);
        apellido = (EditText) findViewById(R.id.txtapellido);
        enviar_datos =(Button)findViewById(R.id.enviar);
        ct =(ConstraintLayout)findViewById(R.id.contraint);
        f_na = (Button) findViewById(R.id.date);
        actualizar_button =(Button)findViewById(R.id.update_acces);
        enviar_datos = (Button) findViewById(R.id.enviar);
        correo=(EditText)findViewById(R.id.textemail);
        pass =(EditText)findViewById(R.id.textpass);
        re_pass=(EditText)findViewById(R.id.textpass_);
        correo.setEnabled(false);

        f_na.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                final Calendar c = Calendar.getInstance();
                year = c.get(Calendar.YEAR);
                month = c.get(Calendar.MONTH);
                day = c.get(Calendar.DAY_OF_MONTH);
                showDialog(DATE_DIALOG_ID);
            }
        });


        enviar_datos.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                showpDialog();
                if (Form() == true) {

                    Peticion_Servicio();

                }

                if (Form() == false) {
                    hidepDialog();
                }


            }
        });
        actualizar_button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                showpDialog();

                if (Form_acces() == true) {

                    ActualizarAcceso();
                }

                if (Form_acces() == false) {
                    hidepDialog();
                }


            }
        });


    }

    private void DOWNLOAD_Perfil() {

        Session session= new Session(Perfil.this);
        HashMap<String, String> user = session.getUserDetails();

        String correo_send = user.get(Session.KEY_NAME);

        RequestQueue queue = Volley.newRequestQueue(Perfil.this);
        JsonObjectRequest getRequest = new JsonObjectRequest(Request.Method.GET, URL_API.GET_PERFIL+correo_send, null,
                new Response.Listener<JSONObject>()
                    {
                    @Override
                    public void onResponse(JSONObject response) {
                        // display response

                            pDialog.dismiss();
                        try {


                            for (int i = 0; i < response.length(); i++) {

                            }

                            String email = response.getString("correo");
                            correo.setText(email);

                            JSONObject jsonObject = response;
                            JSONArray jsonArray= null;
                            jsonArray = jsonObject.getJSONArray("datos");

                            for (int i = 0; i < jsonArray.length(); i++) {

                                JSONObject objeto= jsonArray.getJSONObject(i);
                                String name = objeto.getString("usuario_nombre");
                                nombre.setText(name);
                                String lastname = objeto.getString("usuario_apellido");
                                apellido.setText(lastname);
                                String regi= objeto.getString("usuario_registro");
                                f_na.setText(regi);
                                ID_USER = objeto.getString("usuario_id");

                            }


                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                        //


                    }
                },
                new Response.ErrorListener()
                {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        Log.d("Error.Response", error.toString());
                        Toast.makeText(getApplicationContext(),"Intentalo mas tarde",Toast.LENGTH_LONG).show();
                        new Handler().postDelayed(new Runnable(){
                            public void run(){

                                Intent intent = new Intent(Perfil.this, Menu_Activity.class);
                                startActivity(intent);
                                finish();
                            };
                        }, 4000);

                    }
                }
        );

// add it to the RequestQueue
        queue.add(getRequest);


    }


    private boolean Form_acces(){

        if(pass.getText().toString().equals("")||re_pass.getText().toString().equals("")){

            Snackbar.make(ct," Completa los campos requeridos", BaseTransientBottomBar.LENGTH_LONG).show();

            return false;
        }
        if(!pass.getText().toString().equals(re_pass.getText().toString())){

           Snackbar.make(ct," Ambas contraseñas deben coincidir", BaseTransientBottomBar.LENGTH_LONG).show();
            return false;
        }
        if(pass.getText().length()<= 8){
            Snackbar.make(ct," Tu contraseña debe contener 8 caractere min.", BaseTransientBottomBar.LENGTH_LONG).show();
            return false;

        }
        return true;
    }
    private boolean Form() {


        if (nombre.getText().toString().equals("")) {
            nombre.setHintTextColor(Color.RED);
            nombre.setHint("Complete este campo");
            hidepDialog();
            return false;
        }
        if (apellido.getText().toString().equals("")) {
            apellido.setHintTextColor(Color.RED);
            apellido.setHint("Completa este campo");
            hidepDialog();
            return false;
        }


        if (FEC.isEmpty()) {
            hidepDialog();
            Snackbar.make(f_na, " Inserte fecha de nacimiento.", Snackbar.LENGTH_LONG).show();
            return false;
        }

        return true;
    }

    private void updateDisplay() {

        currentDate = new StringBuilder().append(year).append("-")
                .append(month + 1).append("-").append(day).toString();
        Log.i("DATE", currentDate);
    }




    DatePickerDialog.OnDateSetListener myDateSetListener = new DatePickerDialog.OnDateSetListener() {

        @Override
        public void onDateSet(DatePicker datePicker, int i, int j, int k) {

            year = i;
            month = j;
            day = k;
            updateDisplay();
            FEC = currentDate;
            f_na.setText(currentDate);
            FEC = f_na.getText().toString();
        }
    };


    @Override
    protected Dialog onCreateDialog(int id) {
        switch (id) {
            case DATE_DIALOG_ID:
                return new DatePickerDialog(this, myDateSetListener, year, month,
                        day);
        }
        return null;
    }

    @Override
    public void onBackPressed() {
        hidepDialog();
        Intent activity = new Intent(this, Menu_Activity.class);
        startActivity(activity);
        finish();

    }

    private void showpDialog() {
        if (!pDialog.isShowing())
            pDialog.show();
    }

    private void hidepDialog() {
        if (pDialog.isShowing())
            pDialog.dismiss();
    }


    public void Peticion_Servicio() {


        StringRequest stringRequest = new StringRequest(Request.Method.POST, URL_API.ACTUALIZAR_PERFIL ,
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {


                        Pattern pat = Pattern.compile(".*error.*");
                        Matcher mat = pat.matcher(response);

                        if (mat.find()) {
                            hidepDialog();
                            Snackbar.make(ct, response+" : No se pudo completar. " , Snackbar.LENGTH_LONG).show();

                        } else {

                            Snackbar.make(ct, "Actualización de datos completa. " , Snackbar.LENGTH_LONG).show();
                            hidepDialog();
                              getSharedPreferences("culturalUser", 0 /*FILE_MODE*/)
                                    .edit()
                                    .putString(Session.KEY_ID_USER, correo.getText().toString())
                                    .apply();

                        }


                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {

                        hidepDialog();
                        Snackbar.make(ct, " Algo salio mal, intentalo mas tarde . "+error.toString(), Snackbar.LENGTH_LONG).show();
                    }
                }) {
            @Override
            protected Map<String, String> getParams() {
                Map<String, String> params = new HashMap<String, String>();

                params.put("nombre", nombre.getText().toString());
                params.put("apellido", apellido.getText().toString());
                params.put("fecha", FEC);
                params.put("id_user", ID_USER);

                return params;
            }

        };

        RequestQueue requestQueue = Volley.newRequestQueue(this);
        requestQueue.add(stringRequest);


    }
public void ActualizarAcceso(){


    StringRequest stringRequest = new StringRequest(Request.Method.POST, URL_API.ACTUALIZAR_ACCESO ,
            new Response.Listener<String>() {
                @Override
                public void onResponse(String response) {


                    Pattern pat = Pattern.compile(".*error.*");
                    Matcher mat = pat.matcher(response);

                    if (mat.find()) {
                        hidepDialog();
                        Snackbar.make(ct, " Error al actualizar datos. " , Snackbar.LENGTH_LONG).show();

                    } else {
                        hidepDialog();
                        Snackbar.make(ct, "Actualización de datos de acceso completa. " , Snackbar.LENGTH_LONG).show();

                        actualizar_button.setVisibility(View.INVISIBLE);
                        pass.setEnabled(false);
                        re_pass.setEnabled(false);
                    }


                }
            },
            new Response.ErrorListener() {
                @Override
                public void onErrorResponse(VolleyError error) {

                    hidepDialog();
                    Snackbar.make(ct, " Algo salio mal, intentalo mas tarde. " , Snackbar.LENGTH_LONG).show();
                }
            }) {
        @Override
        protected Map<String, String> getParams() {
            Map<String, String> params = new HashMap<String, String>();

            params.put("correo", correo.getText().toString());
            params.put("contrasena", pass.getText().toString());


            return params;
        }

    };

    RequestQueue requestQueue = Volley.newRequestQueue(this);
    requestQueue.add(stringRequest);
}

}

