/ *!
 * jQuery JavaScript Library v1.11.1
 * http://jquery.com/
 *
 * Incluye Sizzle.js
 * http://sizzlejs.com/
 *
 * Copyright 2005, 2014 jQuery Foundation, Inc. y otros colaboradores
 * Publicado bajo la licencia de MIT
 * http://jquery.org/license
 *
 * Fecha: 2014-05-01T17: 42Z
 * /

(función (global, fábrica) {

	if (typeof module === "object" && typeof module.exports === "object") {
		// Para entornos CommonJS y CommonJS donde hay una ventana adecuada,
		// ejecuta la fábrica y obtiene jQuery
		// Para entornos que no poseen intrínsecamente una ventana con un documento
		// (como Node.js), expone una fábrica jQuery-making como module.exports
		// Esto acentúa la necesidad de la creación de una ventana real
		// eg var jQuery = require ("jquery") (ventana);
		// Ver ticket # 14549 para más información
		module.exports = global.document?
			fábrica (global, verdadero):
			función (w) {
				if (! w.document) {
					lanzar nuevo Error ("jQuery requiere una ventana con un documento");
				}
				devolver la fábrica (w);
			};
	} else {
		fábrica (global);
	}

// Pase esto si la ventana aún no está definida
} (typeof window! == "undefined"? window: this, function (window, noGlobal) {

// No puedo hacer esto porque varias aplicaciones, incluido el rastreo de ASP.NET
// la pila a través de arguments.caller.callee y Firefox muere si
// intenta rastrear a través de cadenas de llamadas "use strict". (# 13335)
// Soporte: Firefox 18+
//

var deletedIds = [];

var slice = deletedIds.slice;

var concat = deletedIds.concat;

var push = deletedIds.push;

var indexOf = deletedIds.indexOf;

var class2type = {};

var toString = class2type.toString;

var hasOwn = class2type.hasOwnProperty;

var support = {};



var
	version = "1.11.1",

	// Definir una copia local de jQuery
	jQuery = function (selector, context) {
		// El objeto jQuery es en realidad solo el constructor init 'mejorado'
		// Necesito init si se llama a jQuery (solo permite lanzar el error si no está incluido)
		return new jQuery.fn.init (selector, contexto);
	},

	// Soporte: Android <4.1, IE <9
	// Asegúrate de recortar la BOM y NBSP
	rtrim = / ^ [\ s \ uFEFF \ xA0] + | [\ s \ uFEFF \ xA0] + $ / g,

	// Coincide con la cadena punteada para camelizar
	rmsPrefix = / ^ - ms- /,
	rdashAlpha = / - ([\ da-z]) / gi,

	// Utilizado por jQuery.camelCase como devolución de llamada para reemplazar ()
	fcamelCase = function (all, letter) {
		return letter.toUpperCase ();
	};

jQuery.fn = jQuery.prototype = {
	// La versión actual de jQuery está siendo utilizada
	jquery: versión,

	constructor: jQuery,

	// Comience con un selector vacío
	selector: "",

	// La longitud predeterminada de un objeto jQuery es 0
	longitud: 0,

	toArray: function () {
		return slice.call (esto);
	},

	// Obtenga el enésimo elemento en el conjunto de elementos coincidentes O
	// Obtener todo el conjunto combinado de elementos como una matriz limpia
	get: function (num) {
		return num! = null?

			// Devuelve solo un elemento del conjunto
			(num <0? this [num + this.length]: this [num]):

			// Devuelve todos los elementos en una matriz limpia
			slice.call (esto);
	},

	// Tome una matriz de elementos y empújelos a la pila
	// (devuelve el nuevo conjunto de elementos coincidentes)
	pushStack: function (elems) {

		// Crea un nuevo conjunto de elementos jQuery
		var ret = jQuery.merge (this.constructor (), elems);

		// Agrega el objeto viejo a la pila (como referencia)
		ret.prevObject = this;
		ret.context = this.context;

		// Devuelve el conjunto de elementos recién formado
		return ret;
	},

	// Ejecutar una devolución de llamada para cada elemento en el conjunto combinado.
	// (Puedes sembrar los argumentos con una matriz de argumentos, pero esto es
	// solo se usa internamente)
	each: function (callback, args) {
		return jQuery.each (esto, devolución de llamada, args);
	},

	mapa: función (devolución de llamada) {
		return this.pushStack (jQuery.map (this, function (elem, i) {
			return callback.call (elem, i, elem);
		}));
	},

	slice: function () {
		devuelve this.pushStack (slice.apply (this, arguments));
	},

	primero: function () {
		devuelve this.eq (0);
	},

	last: function () {
		devuelve this.eq (-1);
	},

	eq: función (i) {
		var len = this.length,
			j = + i + (i <0? len: 0);
		devuelve this.pushStack (j> = 0 && j <len? [this [j]]: []);
	},

	end: function () {
		devuelve this.prevObject || este.constructor (nulo);
	},

	// Sólo para uso interno.
	// Se comporta como el método de una matriz, no como un método jQuery.
	empuja empuja,
	sort: deletedIds.sort,
	empalme: deletedIds.splice
};

jQuery.extend = jQuery.fn.extend = function () {
	var src, copyIsArray, copy, name, options, clone,
		target = argumentos [0] || {},
		i = 1,
		length = arguments.length,
		profundo = falso;

	// Manejar una situación de copia profunda
	if (tipo de destino === "booleano") {
		profundo = objetivo;

		// omite el booleano y el objetivo
		target = argumentos [i] || {};
		i ++;
	}

	// Manejar caso cuando el objetivo es una cadena o algo (posible en copia profunda)
	if (typeof target! == "object" &&! jQuery.isFunction (target)) {
		target = {};
	}

	// extender jQuery en sí mismo si solo se pasa un argumento
	if (i === length) {
		target = this;
		yo--;
	}

	para (; i <longitud; i ++) {
		// Solo trato con valores no nulos / indefinidos
		if ((opciones = argumentos [i])!! = null) {
			// Extender el objeto base
			para (nombre en opciones) {
				src = destino [nombre];
				copy = opciones [nombre];

				// Prevenir el ciclo sin fin
				if (target === copy) {
					continuar;
				}

				// Recurse si estamos fusionando objetos simples o matrices
				if (deep && copy && (jQuery.isPlainObject (copy) || (copyIsArray = jQuery.isArray (copy)))) {
					if (copyIsArray) {
						copyIsArray = falso;
						clone = src && jQuery.isArray (src)? src: [];

					} else {
						clone = src && jQuery.isPlainObject (src)? src: {};
					}

					// Nunca muevas objetos originales, clonarlos
					target [name] = jQuery.extend (deep, clone, copy);

				// No traigas valores indefinidos
				} else if (copy! == undefined) {
					destino [nombre] = copia;
				}
			}
		}
	}

	// Devuelve el objeto modificado
	objetivo de retorno;
};

jQuery.extend ({
	// Único para cada copia de jQuery en la página
	expando: "jQuery" + (versión + Math.random ()) .replace (/ \ D / g, ""),

	// Supongamos que jQuery está listo sin el módulo listo
	isReady: cierto,

	error: function (msg) {
		lanzar nuevo Error (msg);
	},

	noop: function () {},

	// Ver test / unit / core.js para detalles sobre isFunction.
	// Desde la versión 1.3, los métodos DOM y las funciones como alerta
	// no son compatibles. Devuelven falso en IE (# 2968).
	isFunction: function (obj) {
		return jQuery.type (obj) === "función";
	},

	isArray: Array.isArray || función (obj) {
		return jQuery.type (obj) === "matriz";
	},

	isWindow: function (obj) {
		/ * jshint eqeqeq: falso * /
		return obj! = null && obj == obj.window;
	},

	isNumeric: function (obj) {
		// parseFloat NaNs falsos positivos de lanzamiento numérico (null | true | false | "")
		// ... pero malinterpreta cadenas de números iniciales, particularmente literales hexadecimales ("0x ...")
		// la substracción fuerza infinitos a NaN
		return! jQuery.isArray (obj) && obj - parseFloat (obj)> = 0;
	},

	isEmptyObject: function (obj) {
		var nombre;
		para (nombre en obj) {
			falso retorno;
		}
		devolver verdadero;
	},

	isPlainObject: function (obj) {
		var clave;

		// Debe ser un Objeto.
		// Debido a IE, también tenemos que verificar la presencia de la propiedad del constructor.
		// Asegúrate de que los nodos DOM y los objetos de la ventana no pasen, también
		if (! obj || jQuery.type (obj)! == "objeto" || obj.nodeType || jQuery.isWindow (obj)) {
			falso retorno;
		}

		tratar {
			// No posee propiedad de constructor debe ser Object
			if (obj.constructor &&
				! hasOwn.call (obj, "constructor") &&
				! hasOwn.call (obj.constructor.prototype, "isPrototypeOf")) {
				falso retorno;
			}
		} catch (e) {
			// IE8,9 Lanzará excepciones en ciertos objetos host # 9897
			falso retorno;
		}

		// Soporte: IE <9
		// Manejar la iteración sobre las propiedades heredadas antes de las propias propiedades.
		if (support.ownLast) {
			para (clave en obj) {
				return hasOwn.call (obj, clave);
			}
		}

		// Propias propiedades se enumeran en primer lugar, por lo que para acelerar,
		// si el último es propio, todas las propiedades son propias.
		para (clave en obj) {}

		tecla de retorno === indefinido || hasOwn.call (obj, clave);
	},

	tipo: función (obj) {
		if (obj == null) {
			return obj + "";
		}
		return typeof obj === "objeto" || typeof obj === "función"?
			class2type [toString.call (obj)] || "objeto":
			typeof obj;
	},

	// Evalúa un script en un contexto global
	// Soluciones basadas en los hallazgos de Jim Driscoll
	// http://weblogs.java.net/blog/driscoll/archive/2009/09/08/eval-javascript-global-context
	globalEval: function (data) {
		if (data && jQuery.trim (data)) {
			// Utilizamos execScript en Internet Explorer
			// Usamos una función anónima para que el contexto sea ventana
			// en lugar de jQuery en Firefox
			(window.execScript || función (datos) {
				ventana ["eval"] .call (ventana, datos);
			}) (datos);
		}
	},

	// Convertir guiones a camelCase; utilizado por el css y los módulos de datos
	// Microsoft olvidó aumentar su prefijo de proveedor (# 9572)
	camelCase: function (string) {
		return string.replace (rmsPrefix, "ms-") .replace (rdashAlpha, fcamelCase);
	},

	nodeName: function (elem, name) {
		return elem.nodeName && elem.nodeName.toLowerCase () === name.toLowerCase ();
	},

	// args es solo para uso interno
	cada uno: función (obj, callback, args) {
		valor de var,
			i = 0,
			longitud = obj.length,
			isArray = isArraylike (obj);

		if (args) {
			if (isArray) {
				para (; i <longitud; i ++) {
					value = callback.apply (obj [i], args);

					if (value === false) {
						descanso;
					}
				}
			} else {
				para (i en obj) {
					value = callback.apply (obj [i], args);

					if (value === false) {
						descanso;
					}
				}
			}

		// Un caso especial, rápido, para el uso más común de cada
		} else {
			if (isArray) {
				para (; i <longitud; i ++) {
					value = callback.call (obj [i], i, obj [i]);

					if (value === false) {
						descanso;
					}
				}
			} else {
				para (i en obj) {
					value = callback.call (obj [i], i, obj [i]);

					if (value === false) {
						descanso;
					}
				}
			}
		}

		return obj;
	},

	// Soporte: Android <4.1, IE <9
	recortar: función (texto) {
		devolver texto == nulo?
			"":
			(texto + "") .replace (rtrim, "");
	},

	// los resultados son solo para uso interno
	makeArray: function (arr, results) {
		var ret = resultados || [];

		if (arr! = null) {
			if (isArraylike (Object (arr))) {
				jQuery.merge (ret,
					typeof arr === "cadena"?
					[arr]: arr
				);
			} else {
				push.call (ret, arr);
			}
		}

		return ret;
	},

	inArray: function (elem, arr, i) {
		var len;

		if (arr) {
			if (indexOf) {
				return indexOf.call (arr, elem, i);
			}

			len = arr.length;
			yo = yo? i <0? Math.max (0, len + i): i: 0;

			para (; i <len; i ++) {
				// Omitir el acceso en matrices dispersas
				if (i en arr && arr [i] === elem) {
					devuelve i;
				}
			}
		}

		return -1;
	},

	fusionar: función (primero, segundo) {
		var len = + second.length,
			j = 0,
			i = first.length;

		while (j <len) {
			primero [i ++] = segundo [j ++];
		}

		// Soporte: IE <9
		// Transmisión alternativa de .length a NaN en objetos de otro tipo (por ejemplo, NodeLists)
		if (len! == len) {
			while (segundo [j]! == undefined) {
				primero [i ++] = segundo [j ++];
			}
		}

		first.length = i;

		regresar primero;
	},

	grep: function (elems, callback, invert) {
		var callbackInverse,
			matches = [],
			i = 0,
			longitud = elems.length,
			callbackExpect =! invertido;

		// Ir a través de la matriz, solo guardando los elementos
		// que pasa la función de validación
		para (; i <longitud; i ++) {
			callbackInverse =! callback (elems [i], i);
			if (callbackInverse! == callbackExpect) {
				matches.push (elems [i]);
			}
		}

		partidos de vuelta;
	},

	// arg es solo para uso interno
	mapa: función (elems, callback, arg) {
		valor de var,
			i = 0,
			longitud = elems.length,
			isArray = isArailike (elems),
			ret = [];

		// Ir a través de la matriz, traduciendo cada uno de los elementos a sus nuevos valores
		if (isArray) {
			para (; i <longitud; i ++) {
				value = callback (elems [i], i, arg);

				if (value! = null) {
					ret.push (valor);
				}
			}

		// Revisa cada tecla en el objeto,
		} else {
			para (i en elems) {
				value = callback (elems [i], i, arg);

				if (value! = null) {
					ret.push (valor);
				}
			}
		}

		// Aplanar cualquier matriz anidada
		return concat.apply ([], ret);
	},

	// Un contador GUID global para objetos
	guid: 1,

	// Vincula una función a un contexto, opcionalmente aplicando parcialmente cualquier
	// argumentos.
	proxy: función (fn, contexto) {
		var args, proxy, tmp;

		if (tipo de contexto === "cadena") {
			tmp = fn [contexto];
			contexto = fn;
			fn = tmp;
		}

		// Verificación rápida para determinar si el objetivo es invocable, en la especificación
		// esto arroja un TypeError, pero solo devolveremos undefined.
		if (! jQuery.isFunction (fn)) {
			regreso indefinido;
		}

		// enlace simulado
		args = slice.call (argumentos, 2);
		proxy = function () {
			return fn.apply (context || this, args.concat (slice.call (argumentos)));
		};

		// Establece el guid del controlador único al mismo del controlador original, por lo que se puede eliminar
		proxy.guid = fn.guid = fn.guid || jQuery.guid ++;

		proxy de devolución;
	},

	ahora: function () {
		return + (new Date ());
	},

	// jQuery.support no se usa en Core pero otros proyectos adjuntan su
	// propiedades para que necesite existir.
	soporte soporte
});

// Rellena el mapa class2type
jQuery.each ("Boolean Number String Function Array Date RegExp Object Error" .split (""), function (i, name) {
	class2type ["[object" + name + "]"] = name.toLowerCase ();
});

la función esArraylike (obj) {
	var longitud = obj.length,
		type = jQuery.type (obj);

	if (tipo === "función" || jQuery.isWindow (obj)) {
		falso retorno;
	}

	if (obj.nodeType === 1 && length) {
		devolver verdadero;
	}

	tipo de retorno === "matriz" || longitud === 0 ||
		typeof length === "number" && length> 0 && (length - 1) en obj;
}
var Sizzle =
/ *!
 * Sizzle CSS Selector Engine v1.10.19
 * http://sizzlejs.com/
 *
 * Copyright 2013 jQuery Foundation, Inc. y otros colaboradores
 * Publicado bajo la licencia de MIT
 * http://jquery.org/license
 *
 * Fecha: 2014-04-18
 * /
(función (ventana) {

var i,
	apoyo,
	Expr,
	getText,
	isXML,
	tokenize,
	compilar,
	seleccionar,
	outermostContext,
	sortInput,
	hasDuplicate,

	// documento local vars
	setDocument,
	documento,
	docElem,
	documentIsHTML,
	rbuggyQSA,
	rbuggyMatches,
	partidos,
	contiene,

	// Datos específicos de la instancia
	expando = "chisporroteo" + - (nueva Fecha ()),
	preferredDoc = window.document,
	dirruns = 0,
	hecho = 0,
	classCache = createCache (),
	tokenCache = createCache (),
	compilerCache = createCache (),
	sortOrder = function (a, b) {
		if (a === b) {
			hasDuplicate = verdadero;
		}
		return 0;
	},

	// constantes de propósito general
	strundefined = typeof undefined,
	MAX_NEGATIVE = 1 << 31,

	// métodos de instancia
	hasOwn = ({}). hasOwnProperty,
	arr = [],
	pop = arr.pop,
	push_native = arr.push,
	push = arr.push,
	slice = arr.slice,
	// Usa un índice reducido si no podemos usar uno nativo
	indexOf = arr.indexOf || función (elem) {
		var i = 0,
			len = this.length;
		para (; i <len; i ++) {
			if (this [i] === elem) {
				devuelve i;
			}
		}
		return -1;
	},

	booleans = "checked | selected | async | autofocus | autoplay | controls | defer | disabled | hidden | ismap | loop | multiple | open | readonly | required | scoped",

	// Expresiones regulares

	// Caracteres de espacios en blanco http://www.w3.org/TR/css3-selectors/#whitespace
	whitespace = "[\\ x20 \\ t \\ r \\ n \\ f]",
	// http://www.w3.org/TR/css3-syntax/#characters
	characterEncoding = "(?: \\\\ | | [\\ w-] | [^ \\ x00 - \\ xa0]) +",

	// modelado libremente en caracteres identificadores de CSS
	// Un valor sin comillas debería ser un identificador de CSS http://www.w3.org/TR/css3-selectors/#attribute-selectors
	// Sintaxis correcta: http://www.w3.org/TR/CSS21/syndata.html#value-def-identifier
	identifier = characterEncoding.replace ("w", "w #"),

	// Selectores de atributos: http://www.w3.org/TR/selectors/#attribute-selectors
	attributes = "\\ [" + whitespace + "* (" + characterEncoding + ") (?:" + espacio en blanco +
		// Operador (captura 2)
		"* ([* ^ $ |! ~]? =)" + espacio en blanco +
		// "Los valores de los atributos deben ser identificadores CSS [captura 5] o cadenas [captura 3 o captura 4]"
		"* (?: '((?: \\\\ | | [^ \\\\']) *) '| \" ((?: \\\\ | | [^ \\\\\ "] ) *) \ "| (" + identificador + ")) |)" + espacio en blanco +
		"* \\]",

	pseudos = ":(" + characterEncoding + ") (?: \\ ((" +
		// Para reducir el número de selectores que necesitan tokenize en el preFiltro, prefiera los argumentos:
		// 1. citado (captura 3, captura 4 o captura 5)
		"('((?: \\\\ | | [^ \\\\']) *) '| \" ((?: \\\\. | [^ \\\\\ "]) *) \ ") |" +
		// 2. simple (captura 6)
		"((?: \\\. | [^ \\\\ () [\\]] |" + attributes + ") *) |" +
		// 3. cualquier cosa (captura 2)
		". *" +
		") \\) |)",

	// Espacios en blanco al final y sin escape, capturando algunos caracteres que no son de espacio en blanco que preceden al último
	rtrim = new RegExp ("^" + espacio en blanco + "+ | ((?: ^ | [^ \\\\]) (?: \\\\.) *)" + espacio en blanco + "+ $", "g "),

	rcomma = new RegExp ("^" + espacio en blanco + "*," + espacio en blanco + "*"),
	rcombinators = new RegExp ("^" + espacio en blanco + "* ([> + ~] |" + espacio en blanco + ")" + espacio en blanco + "*"),

	rattributeQuotes = new RegExp ("=" + espacio en blanco + "* ([^ \\] '\"] *?) "+ espacio en blanco +" * \\] "," g "),

	rpseudo = new RegExp (pseudos),
	ridentifier = new RegExp ("^" + identificador + "$"),

	matchExpr = {
		"ID": nuevo RegExp ("^ # (" + characterEncoding + ")"),
		"CLASS": nuevo RegExp ("^ \\. (" + CharacterEncoding + ")"),
		"TAG": nuevo RegExp ("^ (" + characterEncoding.replace ("w", "w *") + ")"),
		"ATTR": nuevo RegExp ("^" + atributos),
		"PSEUDO": nuevo RegExp ("^" + pseudos),
		"CHILD": nuevo RegExp ("^ :( solo | first | last | nth | nth-last) - (child | of-type) (?: \\ (" + whitespace +
			"* (incluso | impar | (([+ -] |) (\\ d *) n |)" + espacio en blanco + "* (?: ([+ -] |)" + espacio en blanco +
			"* (\\ d +) |)) + espacio en blanco +" * \\) |) "," i ",
		"bool": nuevo RegExp ("^ (?:" + booleans + ") $", "i"),
		// Para uso en bibliotecas que implementan .is ()
		// Utilizamos esto para la coincidencia de POS en `seleccionar`
		"needsContext": nuevo RegExp ("^" + espacio en blanco + "* [> + ~] |: (incluso | impar | eq | gt | lt | nth | primero | último) (?: \\ (" +
			espacio en blanco + "* ((?: - \\ d)? \\ d *)" + espacio en blanco + "* \\) |) (? = [^ -] | $)", "i")
	},

	rinputs = / ^ (?: input | select | textarea | botón) $ / i,
	rheader = / ^ h \ d $ / i,

	rnative = / ^ [^ {] + \ {\ s * \ [native \ w /,

	// ID de fácil identificación / recuperable o selectores TAG o CLASS
	rquickExpr = /^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/,

	rsibling = / [+ ~] /,
	rescape = / '| \\ / g,

	// CSS escapa http://www.w3.org/TR/CSS21/syndata.html#escaped-characters
	runescape = new RegExp ("\\\\ ([\\ da-f] {1,6}" + espacio en blanco + "? | (" + espacio en blanco + ") |.)", "ig"),
	funescape = function (_, escaped, escapadoWhitespace) {
		var high = "0x" + escaped - 0x10000;
		// NaN significa no codepoint
		// Soporte: Firefox <24
		// Solución errónea de interpretación numérica de + "0x"
		¡vuelve alto! == alto || escapadoWhitespace?
			escapado :
			alto <0?
				// punto de código BMP
				String.fromCharCode (alto + 0x10000):
				// Punto de código del plano suplementario (par sustituto)
				String.fromCharCode (alto >> 10 | 0xD800, alto y 0x3FF | 0xDC00);
	};

// Optimizar para push.apply (_, NodeList)
tratar {
	push.apply (
		(arr = slice.call (preferredDoc.childNodes)),
		preferredDoc.childNodes
	);
	// Soporte: Android <4.0
	// Detecta que falla silenciosamente push.apply
	arr [preferredDoc.childNodes.length] .nodeType;
} catch (e) {
	push = {apply: arr.length?

		// Leverage slice si es posible
		function (target, els) {
			push_native.apply (target, slice.call (els));
		}:

		// Soporte: IE <9
		// De lo contrario, anexar directamente
		function (target, els) {
			var j = target.length,
				i = 0;
			// No puedo confiar en NodeList.length
			while ((target [j ++] = els [i ++])) {}
			target.length = j - 1;
		}
	};
}

function Sizzle (selector, contexto, resultados, semilla) {
	var match, elem, m, nodeType,
		// QSA vars
		i, grupos, viejo, nid, newContext, newSelector;

	if ((context? context.ownerDocument || context: preferredDoc)! == document) {
		setDocument (contexto);
	}

	contexto = contexto || documento;
	resultados = resultados || [];

	if (! selector || typeof selector! == "cadena") {
		resultados de devolución;
	}

	if ((nodeType = context.nodeType)! == 1 && nodeType! == 9) {
		regreso [];
	}

	if (documentIsHTML &&! seed) {

		// Accesos directos
		if ((match = rquickExpr.exec (selector))) {
			// Speed-up: Sizzle ("# ID")
			if ((m = match [1])) {
				if (nodeType === 9) {
					elem = context.getElementById (m);
					// Ver parentNode para capturar cuando Blackberry 4.6 regresa
					// nodos que ya no están en el documento (jQuery # 6963)
					if (elem && elem.parentNode) {
						// Manejar el caso donde IE, Opera y Webkit devuelven elementos
						// por nombre en lugar de ID
						if (elem.id === m) {
							results.push (elem);
							resultados de devolución;
						}
					} else {
						resultados de devolución;
					}
				} else {
					// Contexto no es un documento
					if (context.ownerDocument && (elem = context.ownerDocument.getElementById (m)) &&
						contains (context, elem) && elem.id === m) {
						results.push (elem);
						resultados de devolución;
					}
				}

			// Speed-up: Sizzle ("TAG")
			} else if (match [2]) {
				push.apply (results, context.getElementsByTagName (selector));
				resultados de devolución;

			// Speed-up: Sizzle (". CLASS")
			} else if ((m = match [3]) && support.getElementsByClassName && context.getElementsByClassName) {
				push.apply (results, context.getElementsByClassName (m));
				resultados de devolución;
			}
		}

		// ruta QSA
		if (support.qsa && (! rbuggyQSA ||! rbuggyQSA.test (selector))) {
			nid = old = expando;
			newContext = contexto;
			newSelector = nodeType === 9 && selector;

			// qSA funciona de forma extraña en consultas basadas en elementos
			// Podemos solucionar esto especificando un ID extra en la raíz
			// y trabajando desde allí (Gracias a Andrew Dupont por la técnica)
			// IE 8 no funciona en elementos de objeto
			if (nodeType === 1 && context.nodeName.toLowerCase ()! == "object") {
				grupos = tokenize (selector);

				if ((antiguo = context.getAttribute ("id"))) {
					nid = old.replace (rescape, "\\ $ &");
				} else {
					context.setAttribute ("id", nid);
				}
				nid = "[id = '" + nid + "']";

				i = groups.length;
				mientras yo-- ) {
					grupos [i] = nid + toSelector (grupos [i]);
				}
				newContext = rsibling.test (selector) && testContext (context.parentNode) || contexto;
				newSelector = groups.join (",");
			}

			if (newSelector) {
				tratar {
					push.apply (resultados,
						newContext.querySelectorAll (newSelector)
					);
					resultados de devolución;
				} catch (qsaError) {
				} finalmente {
					Yo doblo ) {
						context.removeAttribute ("id");
					}
				}
			}
		}
	}

	// Todos los otros
	return select (selector.replace (rtrim, "$ 1"), contexto, resultados, semilla);
}

/ **
 * Crear cachés clave-valor de tamaño limitado
 * @returns {Function (string, Object)} Devuelve los datos del objeto después de almacenarlo en sí mismo con
 * nombre de propiedad la cadena (con sufijo de espacio) y (si la caché es más grande que Expr.cacheLength)
 * borrar la entrada más antigua
 * /
function createCache () {
	var keys = [];

	caché de función (clave, valor) {
		// Use (tecla + "") para evitar la colisión con las propiedades del prototipo nativo (vea el Issue # 157)
		if (keys.push (key + "")> Expr.cacheLength) {
			// Solo guarde las entradas más recientes
			eliminar caché [keys.shift ()];
		}
		return (caché [tecla + ""] = valor);
	}
	caché de retorno;
}

/ **
 * Marque una función para uso especial por Sizzle
 * @param {Function} fn La función para marcar
 * /
function markFunction (fn) {
	fn [expando] = verdadero;
	return fn;
}

/ **
 * Pruebas de soporte usando un elemento
 * @param {Function} fn Pasó el div creado y espera un resultado booleano
 * /
función assert (fn) {
	var div = document.createElement ("div");

	tratar {
		devuelve !! fn (div);
	} catch (e) {
		falso retorno;
	} finalmente {
		// Eliminar de su padre por defecto
		if (div.parentNode) {
			div.parentNode.removeChild (div);
		}
		// liberar memoria en IE
		div = null;
	}
}

/ **
 * Agrega el mismo controlador para todos los atributos especificados
 * @param {String} attrs Lista de atributos separados por tuberías
 * @param {Function} handler El método que se aplicará
 * /
function addHandle (attrs, controlador) {
	var arr = attrs.split ("|"),
		i = attrs.length;

	mientras yo-- ) {
		Expr.attrHandle [arr [i]] = controlador;
	}
}

/ **
 * Verifica el orden de los documentos de dos hermanos
 * @param {Element} a
 * @param {Element} b
 * @ devuelve {Número} Devuelve menos de 0 si a es anterior a b, es mayor que 0 si a sigue a b
 * /
function siblingCheck (a, b) {
	var cur = b && a,
		diff = cur && a.nodeType === 1 && b.nodeType === 1 &&
			(~ b.sourceIndex || MAX_NEGATIVE) -
			(~ a.sourceIndex || MAX_NEGATIVE);

	// Usa IE sourceIndex si está disponible en ambos nodos
	if (diff) {
		return diff;
	}

	// Verifica si b sigue una
	if (cur) {
		while ((cur = cur.nextSibling)) {
			if (cur === b) {
				return -1;
			}
		}
	}

	devuelve un? 1: -1;
}

/ **
 * Devuelve una función para usar en pseudos para los tipos de entrada
 * @param {String} tipo
 * /
función createInputPseudo (type) {
	función de retorno (elem) {
		var name = elem.nodeName.toLowerCase ();
		return name === "input" && elem.type === type;
	};
}

/ **
 * Devuelve una función para usar en pseudos para botones
 * @param {String} tipo
 * /
function createButtonPseudo (type) {
	función de retorno (elem) {
		var name = elem.nodeName.toLowerCase ();
		return (name === "input" || name === "button") && elem.type === type;
	};
}

/ **
 * Devuelve una función para usar en pseudos para posiciones
 * @param {Function} fn
 * /
function createPositionalPseudo (fn) {
	return markFunction (función (argumento) {
		argumento = + argumento;
		return markFunction (función (semilla, coincidencias) {
			var j,
				matchIndexes = fn ([], seed.length, argumento),
				i = matchIndexes.length;

			// Relacionar elementos encontrados en los índices especificados
			mientras yo-- ) {
				if (seed [(j = matchIndexes [i])]) {
					semilla [j] =! (coincide con [j] = semilla [j]);
				}
			}
		});
	});
}

/ **
 * Comprueba la validez de un nodo como contexto Sizzle
 * @param {Element | Object =} context
 * @return {Element | Object | Boolean} El nodo de entrada si es aceptable, de lo contrario un valor falso
 * /
function testContext (context) {
	return context && typeof context.getElementsByTagName! == strundefined && context;
}

// Exponer vars de soporte para mayor comodidad
support = Sizzle.support = {};

/ **
 * Detecta nodos XML
 * @param {Element | Object} elem Un elemento o documento
 * @returns {Boolean} True iff elem es un nodo XML no HTML
 * /
isXML = Sizzle.isXML = function (elem) {
	// documentElement se verifica para los casos donde aún no existe
	// (como cargar iframes en IE - # 4833)
	var documentElement = elem && (elem.ownerDocument || elem) .documentElement;
	return documentElement? documentElement.nodeName! == "HTML": falso;
};

/ **
 * Establece las variables relacionadas con el documento una vez sobre la base del documento actual
 * @param {Element | Object} [doc] Un elemento u objeto de documento para usar para configurar el documento
 * @returns {Object} Devuelve el documento actual
 * /
setDocument = Sizzle.setDocument = function (node) {
	var hasCompare,
		doc = nodo? node.ownerDocument || nodo: preferredDoc,
		parent = doc.defaultView;

	// Si no hay documento y documentElement disponible, regrese
	if (doc === document || doc.nodeType! == 9 ||! doc.documentElement) {
		documento de devolución;
	}

	// Establecer nuestro documento
	document = doc;
	docElem = doc.documentElement;

	// Pruebas de soporte
	documentIsHTML =! isXML (doc);

	// Soporte: IE> 8
	// Si el documento iframe está asignado a la variable "document" y si iframe ha sido recargado,
	// IE arrojará el error de "permiso denegado" al acceder a la variable "documento", consulte jQuery # 13936
	// IE6-8 no es compatible con la propiedad defaultView, por lo que los padres no estarán definidos
	if (padre && parent! == parent.top) {
		// IE11 no tiene attachEvent, entonces todos deben sufrir
		if (parent.addEventListener) {
			parent.addEventListener ("descargar", función () {
				setDocument ();
			}, falso);
		} else if (parent.attachEvent) {
			parent.attachEvent ("onunload", function () {
				setDocument ();
			});
		}
	}

	/ * Atributos
	-------------------------------------------------- -------------------- * /

	// Soporte: IE <8
	// Verificar que getAttribute realmente devuelva atributos y no propiedades (excepto los booleanos IE8)
	support.attributes = assert (function (div) {
		div.className = "i";
		return! div.getAttribute ("className");
	});

	/ * getElement (s) por *
	-------------------------------------------------- -------------------- * /

	// Compruebe si getElementsByTagName ("*") devuelve solo elementos
	support.getElementsByTagName = assert (function (div) {
		div.appendChild (doc.createComment (""));
		return! div.getElementsByTagName ("*"). length;
	});

	// Comprobar si getElementsByClassName puede ser de confianza
	support.getElementsByClassName = rnative.test (doc.getElementsByClassName) && assert (function (div) {
		div.innerHTML = "<div class = 'a'> </ div> <div class = 'a i'> </ div>";

		// Soporte: Safari <4
		// Sobrecoge de clase de captura
		div.firstChild.className = "i";
		// Soporte: Opera <10
		// Captura la falla de gEBCN para encontrar clases no líderes
		return div.getElementsByClassName ("i"). length === 2;
	});

	// Soporte: IE <10
	// Comprobar si getElementById devuelve elementos por nombre
	// Los métodos getElementById rotos no recogen los nombres programáticamente establecidos,
	// entonces usa una prueba rotunda de getElementsByName
	support.getById = assert (function (div) {
		docElem.appendChild (div) .id = expando;
		return! doc.getElementsByName || ! doc.getElementsByName (expando) .length;
	});

	// ID encuentra y filtra
	if (support.getById) {
		Expr.find ["ID"] = función (id, contexto) {
			if (typeof context.getElementById! == strundefined && documentIsHTML) {
				var m = context.getElementById (id);
				// Ver parentNode para capturar cuando Blackberry 4.6 regresa
				// nodos que ya no están en el documento # 6963
				devuelve m && m.parentNode? [m]: [];
			}
		};
		Expr.filter ["ID"] = función (id) {
			var attrId = id.replace (runescape, funescape);
			función de retorno (elem) {
				return elem.getAttribute ("id") === attrId;
			};
		};
	} else {
		// Soporte: IE6 / 7
		// getElementById no es confiable como atajo de búsqueda
		eliminar Expr.find ["ID"];

		Expr.filter ["ID"] = función (id) {
			var attrId = id.replace (runescape, funescape);
			función de retorno (elem) {
				var node = typeof elem.getAttributeNode! == strundefined && elem.getAttributeNode ("id");
				nodo de retorno && node.value === attrId;
			};
		};
	}

	// Tag
	Expr.find ["TAG"] = support.getElementsByTagName?
		función (etiqueta, contexto) {
			if (typeof context.getElementsByTagName! == strundefined) {
				return context.getElementsByTagName (tag);
			}
		}:
		función (etiqueta, contexto) {
			var elem,
				tmp = [],
				i = 0,
				results = context.getElementsByTagName (tag);

			// Filtrar posibles comentarios
			if (tag === "*") {
				while ((elem = resultados [i ++])) {
					if (elem.nodeType === 1) {
						tmp.push (elem);
					}
				}

				devolver tmp;
			}
			resultados de devolución;
		};

	// Clase
	Expr.find ["CLASS"] = support.getElementsByClassName && function (className, context) {
		if (typeof context.getElementsByClassName! == strundefined && documentIsHTML) {
			return context.getElementsByClassName (className);
		}
	};

	/ * QSA / matchesSelector
	-------------------------------------------------- -------------------- * /

	// Compatibilidad con QSA y matchesSelector

	// matchesSelector (: active) informa falso cuando es verdadero (IE9 / Opera 11.5)
	rbuggyMatches = [];

	// qSa (: focus) informa falso cuando es verdadero (Chrome 21)
	// Permitimos esto debido a un error en IE8 / 9 que arroja un error
	// siempre que se acceda a `document.activeElement` en un iframe
	// Entonces, permitimos que: focus pase a través de QSA todo el tiempo para evitar el error de IE
	// Ver http://bugs.jquery.com/ticket/13378
	rbuggyQSA = [];

	if ((support.qsa = rnative.test (doc.querySelectorAll))) {
		// Crear QSA regex
		// Estrategia Regex adoptada por Diego Perini
		assert (function (div) {
			// Seleccionar se establece en cadena vacía a propósito
			// Esto es para probar el tratamiento de IE de forma no explícita
			// establecer un atributo de contenido booleano,
			// ya que su presencia debería ser suficiente
			// http://bugs.jquery.com/ticket/12359
			div.innerHTML = "<select msallowclip = ''> <opción seleccionada = ''> </ option> </ select>";

			// Soporte: IE8, Opera 11-12.16
			// No se debe seleccionar nada cuando las cadenas vacías sigan ^ = o $ = o * =
			// El atributo de prueba debe ser desconocido en Opera pero "seguro" para WinRT
			// http://msdn.microsoft.com/en-us/library/ie/hh465388.aspx#attribute_section
			if (div.querySelectorAll ("[msallowclip ^ = '']"). length) {
				rbuggyQSA.push ("[* ^ $] =" + espacio en blanco + "* (?: '' | \" \ ")");
			}

			// Soporte: IE8
			// Los atributos booleanos y el "valor" no se tratan correctamente
			if (! div.querySelectorAll ("[selected]"). length) {
				rbuggyQSA.push ("\\ [" + espacio en blanco + "* (?: valor |" + booleanos + ")");
			}

			// Webkit / Opera -: checked debería devolver los elementos de opción seleccionados
			// http://www.w3.org/TR/2011/REC-css3-selectors-20110929/#checked
			// IE8 arroja un error aquí y no verá las pruebas posteriores
			if (! div.querySelectorAll (": checked"). length) {
				rbuggyQSA.push (": comprobado");
			}
		});

		assert (function (div) {
			// Soporte: Windows 8 Native Apps
			// Los atributos de tipo y nombre están restringidos durante la asignación .innerHTML
			var input = doc.createElement ("entrada");
			input.setAttribute ("tipo", "oculto");
			div.appendChild (input) .setAttribute ("nombre", "D");

			// Soporte: IE8
			// Aplicar el atributo de sensibilidad de mayúsculas y minúsculas
			if (div.querySelectorAll ("[name = d]") length) {
				rbuggyQSA.push ("nombre" + espacio en blanco + "* [* ^ $ |! ~]? =");
			}

			// FF 3.5 -: elementos habilitados /: deshabilitados y ocultos (los elementos ocultos aún están habilitados)
			// IE8 arroja un error aquí y no verá las pruebas posteriores
			if (! div.querySelectorAll (": enabled"). length) {
				rbuggyQSA.push (": habilitado", ": deshabilitado");
			}

			// Opera 10-11 no arroja pseudos inválidos post-coma
			div.querySelectorAll ("* ,: x");
			rbuggyQSA.push (",. *:");
		});
	}

	if ((support.matchesSelector = rnative.test ((matches = docElem.matches ||
		docElem.webkitMatchesSelector ||
		docElem.mozMatchesSelector ||
		docElem.oMatchesSelector ||
		docElem.msMatchesSelector)))) {

		assert (function (div) {
			// Verifica si es posible hacer coincidenciasSelector
			// en un nodo desconectado (IE 9)
			support.disconnectedMatch = matches.call (div, "div");

			// Esto debería fallar con una excepción
			// Gecko no produce error, devuelve falso en su lugar
			matches.call (div, "[s! = '']: x");
			rbuggyMatches.push ("! =", pseudos);
		});
	}

	rbuggyQSA = rbuggyQSA.length && new RegExp (rbuggyQSA.join ("|"));
	rbuggyMatches = rbuggyMatches.length && new RegExp (rbuggyMatches.join ("|"));

	/ * Contiene
	-------------------------------------------------- -------------------- * /
	hasCompare = rnative.test (docElem.compareDocumentPosition);

	// Element contiene otro
	// A propósito no implementa descendientes inclusivos
	// Como en, un elemento no se contiene
	contains = hasCompare || rnative.test (docElem.contains)?
		función (a, b) {
			var adown = a.nodeType === 9? a.documentElement: a,
				bup = b && b.parentNode;
			devolver a === bup || !! (bup && bup.nodeType === 1 && (
				adown.contains ?
					adown.contains (bup):
					a.compareDocumentPosition && a.compareDocumentPosition (bup) & 16
			));
		}:
		función (a, b) {
			si (b) {
				while ((b = b.parentNode)) {
					if (b === a) {
						devolver verdadero;
					}
				}
			}
			falso retorno;
		};

	/ * Clasificación
	-------------------------------------------------- -------------------- * /

	// Clasificación de orden de documentos
	sortOrder = hasCompare?
	función (a, b) {

		// Marcar para eliminar duplicados
		if (a === b) {
			hasDuplicate = verdadero;
			return 0;
		}

		// Ordenar en el método de existencia si solo una entrada tiene compararDocumentPosition
		var compare =! a.compareDocumentPosition -! b.compareDocumentPosition;
		si (comparar) {
			comparar de vuelta;
		}

		// Calcular posición si ambas entradas pertenecen al mismo documento
		compare = (a.ownerDocument || a) === (b.ownerDocument || b)?
			a.compareDocumentPosition (b):

			// De lo contrario, sabemos que están desconectados
			1;

		// nodos desconectados
		if (comparar y 1 ||
			(! support.sortDetached && b.compareDocumentPosition (a) === compare)) {

			// Elige el primer elemento relacionado con nuestro documento preferido
			if (a === doc || a.ownerDocument === preferredDoc && contains (preferredDoc, a)) {
				return -1;
			}
			if (b === doc || b.ownerDocument === preferredDoc && contains (preferredDoc, b)) {
				return 1;
			}

			// Mantener orden original
			return sortInput?
				(indexOf.call (sortInput, a) - indexOf.call (sortInput, b)):
				0;
		}

		volver comparar y 4? -1: 1;
	}:
	función (a, b) {
		// Salir temprano si los nodos son idénticos
		if (a === b) {
			hasDuplicate = verdadero;
			return 0;
		}

		var cur,
			i = 0,
			aup = a.parentNode,
			bup = b.parentNode,
			ap = [a],
			bp = [b];

		// Los nodos sin padres son documentos o están desconectados
		if (! aup ||! bup) {
			devolver a === doc? -1:
				b === doc? 1:
				aup? -1:
				bup? 1:
				sortInput?
				(indexOf.call (sortInput, a) - indexOf.call (sortInput, b)):
				0;

		// Si los nodos son hermanos, podemos hacer una comprobación rápida
		} else if (aup === bup) {
			return siblingCheck (a, b);
		}

		// De lo contrario, necesitamos listas completas de sus antepasados ​​para comparar
		cur = a;
		while ((cur = cur.parentNode)) {
			ap.unshift (cur);
		}
		cur = b;
		while ((cur = cur.parentNode)) {
			bp.unshift (cur);
		}

		// Camina por el árbol buscando una discrepancia
		while (ap [i] === bp [i]) {
			i ++;
		}

		volver yo?
			// Haz una comprobación de hermanos si los nodos tienen un ancestro común
			siblingCheck (ap [i], bp [i]):

			// De lo contrario, los nodos en nuestro documento ordenan primero
			ap [i] === preferredDoc? -1:
			bp [i] === preferredDoc? 1:
			0;
	};

	devolver el documento;
};

Sizzle.matches = function (expr, elements) {
	return Sizzle (expr, null, null, elementos);
};

Sizzle.matchesSelector = function (elem, expr) {
	// Establecer valores de documento si es necesario
	if ((elem.ownerDocument || elem)! == document) {
		setDocument (elem);
	}

	// Asegúrate de que los selectores de atributos estén citados
	expr = expr.replace (rattributeQuotes, "= '$ 1')");

	if (support.matchesSelector && documentIsHTML &&
		(! rbuggyMatches ||! rbuggyMatches.test (expr)) &&
		(! rbuggyQSA ||! rbuggyQSA.test (expr))) {

		tratar {
			var ret = matches.call (elem, expr);

			// MatchSelector de IE 9 devuelve falso en nodos desconectados
			if (ret || support.disconnectedMatch ||
					// Además, se dice que los nodos desconectados están en un documento
					// fragmento en IE 9
					elem.document && elem.document.nodeType! == 11) {
				return ret;
			}
		} catch (e) {}
	}

	return Sizzle (expr, documento, null, [elem]) .length> 0;
};

Sizzle.contains = function (context, elem) {
	// Establecer valores de documento si es necesario
	if ((context.ownerDocument || context)! == document) {
		setDocument (contexto);
	}
	return contiene (contexto, elem);
};

Sizzle.attr = function (elem, name) {
	// Establecer valores de documento si es necesario
	if ((elem.ownerDocument || elem)! == document) {
		setDocument (elem);
	}

	var fn = Expr.attrHandle [name.toLowerCase ()],
		// No te dejes engañar por las propiedades Object.prototype (jQuery # 13807)
		val = fn && hasOwn.call (Expr.attrHandle, name.toLowerCase ())?
			fn (elem, name,! documentIsHTML):
			indefinido;

	return val! == undefined?
		Val:
		support.attributes || ! documentIsHTML?
			elem.getAttribute (nombre):
			(val = elem.getAttributeNode (name)) && val.specified?
				val.value:
				nulo;
};

Sizzle.error = function (msg) {
	throw new Error ("Error de sintaxis, expresión no reconocida:" + msg);
};

/ **
 * Clasificación de documentos y eliminación de duplicados
 * @param {ArrayLike} resultados
 * /
Sizzle.uniqueSort = function (results) {
	var elem,
		duplicados = [],
		j = 0,
		i = 0;

	// A menos que * sepamos * podemos detectar duplicados, asumir su presencia
	hasDuplicate =! support.detectDuplicates;
	sortInput =! support.sortStable && results.slice (0);
	results.sort (sortOrder);

	if (hasDuplicate) {
		while ((elem = resultados [i ++])) {
			if (elem === resultados [i]) {
				j = duplicates.push (i);
			}
		}
		while (j--) {
			results.splice (duplicados [j], 1);
		}
	}

	// Entrada clara después de la clasificación para liberar objetos
	// Ver https://github.com/jquery/sizzle/pull/225
	sortInput = null;

	resultados de devolución;
};

/ **
 * Función de utilidad para recuperar el valor de texto de una matriz de nodos DOM
 * @param {Array | Element} elem
 * /
getText = Sizzle.getText = function (elem) {
	nodo var,
		ret = "",
		i = 0,
		nodeType = elem.nodeType;

	if (! nodeType) {
		// Si no hay nodeType, se espera que esto sea una matriz
		while ((node ​​= elem [i ++])) {
			// No atravesar nodos de comentarios
			ret + = getText (nodo);
		}
	} else if (nodeType === 1 || nodeType === 9 || nodeType === 11) {
		// Usa el contenido de texto para los elementos
		// Se eliminó el uso de innerText por la consistencia de las nuevas líneas (jQuery # 11153)
		if (typeof elem.textContent === "string") {
			devolver elem.textContent;
		} else {
			// Atraviesa sus hijos
			para (elem = elem.firstChild; elem; elem = elem.nextSibling) {
				ret + = getText (elem);
			}
		}
	} else if (nodeType === 3 || nodeType === 4) {
		return elem.nodeValue;
	}
	// No incluyen comentarios o nodos de instrucciones de procesamiento

	return ret;
};

Expr = Sizzle.selectors = {

	// Puede ser ajustado por el usuario
	cacheLength: 50,

	createPseudo: markFunction,

	match: matchExpr,

	attrHandle: {},

	encontrar: {},

	relativo: {
		">": {dir: "parentNode", primero: true},
		"": {dir: "parentNode"},
		"+": {dir: "previousSibling", primero: true},
		"~": {dir: "previousSibling"}
	},

	Prefiltro: {
		"ATTR": función (coincidencia) {
			match [1] = match [1] .replace (runescape, funescape);

			// Mueve el valor dado para que coincida con [3] si está entre comillas o no.
			match [3] = (match [3] || match [4] || match [5] || "") .replace (runescape, funescape);

			if (match [2] === "~ =") {
				match [3] = "" + match [3] + "";
			}

			return match.slice (0, 4);
		},

		"NIÑO": función (coincidencia) {
			/ * coincide con matchExpr ["CHILD"]
				1 tipo (solo | nth | ...)
				2 qué (niño | de-tipo)
				3 argumento (incluso | impar | \ d * | \ d * n ([+ -] \ d +)? | ...)
				Componente de 4 xn del argumento xn + y ([+ -]? \ D * n |)
				5 signo de xn-componente
				6 x de componente xn
				7 signo de componente y
				8 y de componente y
			* /
			match [1] = match [1] .toLowerCase ();

			if (match [1] .slice (0, 3) === "nth") {
				// nth- * requiere argumento
				if (! match [3]) {
					Sizzle.error (coincidencia [0]);
				}

				// parámetros numéricos xey para Expr.filter.CHILD
				// recuerda ese lanzamiento falso / verdadero respectivamente a 0/1
				match [4] = + (match [4]? match [5] + (match [6] || 1): 2 * (match [3] === "even" || match [3] === " impar" ) );
				coincidencia [5] = + ((coincidencia [7] + coincidencia [8]) || coincidencia [3] === "impar");

			// otros tipos prohíben argumentos
			} else if (match [3]) {
				Sizzle.error (coincidencia [0]);
			}

			partido de vuelta;
		},

		"PSEUDO": función (coincidencia) {
			var exceso,
				unquoted =! match [6] && match [2];

			if (matchExpr ["CHILD"]. test (coincidencia [0])) {
				devolver nulo;
			}

			// Aceptar los argumentos citados como están
			if (match [3]) {
				match [2] = match [4] || partido [5] || "";

			// Elimina el exceso de caracteres de los argumentos no incluidos
			} else if (sin comillas && rpseudo.test (sin comillas) &&
				// Obtener exceso de tokenize (recursivamente)
				(excess = tokenize (sin comillas, verdadero)) &&
				// avanzar al siguiente paréntesis de cierre
				(excess = unquoted.indexOf (")", unquarted.length - excess) - unquoted.length)) {

				// el exceso es un índice negativo
				match [0] = match [0] .slice (0, exceso);
				match [2] = unquoted.slice (0, exceso);
			}

			// Devuelve solo las capturas necesarias por el método de pseudo filtro (tipo y argumento)
			return match.slice (0, 3);
		}
	},

	filtro: {

		"TAG": function (nodeNameSelector) {
			var nodeName = nodeNameSelector.replace (runescape, funescape) .toLowerCase ();
			return nodeNameSelector === "*"?
				function () {return true; }:
				función (elem) {
					return elem.nodeName && elem.nodeName.toLowerCase () === nodeName;
				};
		},

		"CLASS": function (className) {
			var pattern = classCache [className + ""];

			patrón de retorno ||
				(patrón = nuevo RegExp ("(^ |" + espacio en blanco + ")" + nombre de clase + "(" + espacio en blanco + "| $)")) &&
				classCache (className, function (elem) {
					return pattern.test (typeof elem.className === "string" && elem.className || typeof elem.getAttribute! == strundefined && elem.getAttribute ("class") || "");
				});
		},

		"ATTR": función (nombre, operador, control) {
			función de retorno (elem) {
				var result = Sizzle.attr (elem, nombre);

				if (resultado == nulo) {
					operador de retorno === "! =";
				}
				if (! operator) {
					devolver verdadero;
				}

				resultado + = "";

				operador de devolución === "="? resultado === verificación:
					operador === "! ="? resultado! == verificación:
					operador === "^ ="? compruebe && result.indexOf (check) === 0:
					operador === "* ="? verificar && result.indexOf (verificar)> -1:
					operador === "$ ="? verificar && result.slice (-check.length) === verificar:
					operador === "~ ="? ("" + resultado + "") .indexOf (verificar)> -1:
					operador === "| ="? resultado === control || result.slice (0, check.length + 1) === check + "-":
					falso;
			};
		},

		"NIÑO": función (tipo, qué, argumento, primero, último) {
			var simple = type.slice (0, 3)! == "nth",
				forward = type.slice (-4)! == "last",
				ofType = what === "of-type";

			devolver primero === 1 && last === 0?

				// Acceso directo para: nth - * (n)
				función (elem) {
					¡vuelve! elem.parentNode;
				}:

				función (elem, context, xml) {
					var cache, outerCache, node, diff, nodeIndex, start,
						dir = simple! == adelante? "nextSibling": "previousSibling",
						parent = elem.parentNode,
						name = ofType && elem.nodeName.toLowerCase (),
						useCache =! xml &&! ofType;

					if (padre) {

						//: (first | last | only) - (child | of-type)
						if (simple) {
							while (dir) {
								nodo = elem;
								while ((node ​​= node [dir])) {
									if (ofType? node.nodeName.toLowerCase () === name: node.nodeType === 1) {
										falso retorno;
									}
								}
								// Dirección inversa para: only- * (si aún no lo hemos hecho)
								start = dir = type === "only" &&! start && "nextSibling";
							}
							devolver verdadero;
						}

						start = [forward? parent.firstChild: parent.lastChild];

						// non-xml: nth-child (...) almacena datos de caché en `parent`
						if (forward && useCache) {
							// Busca `elem` de un índice previamente almacenado en caché
							outerCache = parent [expando] || (padre [expando] = {});
							cache = outerCache [tipo] || [];
							nodeIndex = caché [0] === dirruns && cache [1];
							diff = caché [0] === dirruns && cache [2];
							node = nodeIndex && parent.childNodes [nodeIndex];

							while ((node ​​= ++ nodeIndex && node && node [dir] ||

								// Regreso a la búsqueda de `elem` desde el comienzo
								(diff = nodeIndex = 0) || start.pop ())) {

								// Cuando se encuentra, los índices de caché en `parent` y break
								if (node.nodeType === 1 && ++ diff && node === elem) {
									outerCache [tipo] = [dirruns, nodeIndex, diff];
									descanso;
								}
							}

						// Usa el índice del elemento previamente almacenado en caché si está disponible
						} else if (useCache && (cache = (elem [expando] || (elem [expando] = {})) [tipo]) && cache [0] === dirruns) {
							diff = caché [1];

						// xml: nth-child (...) o: nth-last-child (...) o: nth (-last)? - of-type (...)
						} else {
							// Usa el mismo loop como arriba para buscar `elem` desde el comienzo
							while ((node ​​= ++ nodeIndex && node && node [dir] ||
								(diff = nodeIndex = 0) || start.pop ())) {

								if ((ofType? node.nodeName.toLowerCase () === name: node.nodeType === 1) && ++ diff) {
									// Guarda en caché el índice de cada elemento encontrado
									if (useCache) {
										(nodo [expando] || (nodo [expando] = {})) [tipo] = [dirruns, diff];
									}

									if (node ​​=== elem) {
										descanso;
									}
								}
							}
						}

						// Incorpore el desplazamiento, luego verifique el tamaño del ciclo
						diff - = último;
						return diff === first || (diff% primero === 0 && diff / first> = 0);
					}
				};
		},

		"PSEUDO": función (pseudo, argumento) {
			// los nombres de las pseudoclases no distinguen entre mayúsculas y minúsculas
			// http://www.w3.org/TR/selectors/#pseudo-classes
			// Priorizar por mayúsculas y minúsculas en caso de que se agreguen pseudos personalizados con letras mayúsculas
			// Recuerda que setFilters hereda de pseudos
			var args,
				fn = Expr.pseudos [pseudo] || Expr.setFilters [pseudo.toLowerCase ()] ||
					Sizzle.error ("pseudo no compatible:" + pseudo);

			// El usuario puede usar createPseudo para indicar que
			// se necesitan argumentos para crear la función de filtro
			// al igual que Sizzle
			if (fn [expando]) {
				return fn (argumento);
			}

			// Pero mantenemos el soporte para viejas firmas
			if (fn.length> 1) {
				args = [pseudo, pseudo, "", argumento];
				devuelve Expr.setFilters.hasOwnProperty (pseudo.toLowerCase ())?
					markFunction (función (semilla, coincidencias) {
						var idx,
							emparejado = fn (semilla, argumento),
							i = coincidente.length;
						mientras yo-- ) {
							idx = indexOf.call (semilla, coincidente [i]);
							seed [idx] =! (coincide con [idx] = emparejado [i]);
						}
					}):
					función (elem) {
						return fn (elem, 0, args);
					};
			}

			return fn;
		}
	},

	pseudos: {
		// Pseudos potencialmente complejos
		"no": markFunction (función (selector) {
			// Recortar el selector pasado a compilar
			// para evitar el tratamiento de los principales y finales
			// espacios como combinators
			entrada var = [],
				resultados = [],
				matcher = compilar (selector.replace (rtrim, "$ 1"));

			return matcher [expando]?
				markFunction (función (semilla, coincidencias, contexto, xml) {
					var elem,
						incomparable = matcher (semilla, nulo, xml, []),
						i = seed.length;

					// Coincide con los elementos que no coinciden con `matcher`
					mientras yo-- ) {
						if ((elem = no coincidente [i])) {
							seed [i] =! (coincide con [i] = elem);
						}
					}
				}):
				función (elem, context, xml) {
					entrada [0] = elem;
					matcher (entrada, nulo, xml, resultados);
					return! results.pop ();
				};
		}),

		"tiene": markFunction (function (selector) {
			función de retorno (elem) {
				return Sizzle (selector, elem) .length> 0;
			};
		}),

		"contiene": markFunction (función (texto) {
			función de retorno (elem) {
				return (elem.textContent || elem.innerText || getText (elem)) .indexOf (text)> -1;
			};
		}),

		// "Si un elemento está representado por un selector: lang ()
		// se basa únicamente en el valor de idioma del elemento
		// siendo igual al identificador C,
		// o comenzando con el identificador C inmediatamente seguido de "-".
		// La coincidencia de C con el valor de idioma del elemento se realiza sin distinción de mayúsculas y minúsculas.
		// El identificador C no tiene que ser un nombre de idioma válido. "
		// http://www.w3.org/TR/selectors/#lang-pseudo
		"lang": markFunction (function (lang) {
			// el valor lang debe ser un identificador válido
			if (! ridentifier.test (lang || ")) {
				Sizzle.error ("lang no compatible:" + lang);
			}
			lang = lang.replace (runescape, funescape) .toLowerCase ();
			función de retorno (elem) {
				var elemLang;
				hacer {
					if ((elemLang = documentIsHTML?
						elem.lang:
						elem.getAttribute ("xml: lang") || elem.getAttribute ("lang"))) {

						elemLang = elemLang.toLowerCase ();
						return elemLang === lang || elemLang.indexOf (lang + "-") === 0;
					}
				} while ((elem = elem.parentNode) && elem.nodeType === 1);
				falso retorno;
			};
		}),

		// Varios
		"objetivo": función (elem) {
			var hash = window.location && window.location.hash;
			return hash && hash.slice (1) === elem.id;
		},

		"raíz": función (elem) {
			return elem === docElem;
		},

		"foco": función (elem) {
			return elem === document.activeElement && (! document.hasFocus || document.hasFocus ()) && !! (elem.type || elem.href || ~ elem.tabIndex);
		},

		// propiedades booleanas
		"habilitado": función (elem) {
			return elem.disabled === falso;
		},

		"deshabilitado": función (elem) {
			return elem.disabled === verdadero;
		},

		"checked": function (elem) {
			// En CSS3,: checked debe devolver los elementos seleccionados y seleccionados
			// http://www.w3.org/TR/2011/REC-css3-selectors-20110929/#checked
			var nodeName = elem.nodeName.toLowerCase ();
			return (nodeName === "input" && !! elem.checked) || (nodeName === "option" && !! elem.selected);
		},

		"seleccionado": función (elem) {
			// Acceder a esta propiedad hace que se seleccione por defecto
			// las opciones en Safari funcionan correctamente
			if (elem.parentNode) {
				elem.parentNode.selectedIndex;
			}

			return elem.selected === verdadero;
		},

		// Contenido
		"vacío": función (elem) {
			// http://www.w3.org/TR/selectors/#empty-pseudo
			//: empty es negado por el elemento (1) o los nodos de contenido (texto: 3; cdata: 4; entidad ref: 5),
			// pero no por otros (comentario: 8; instrucción de procesamiento: 7; etc.)
			// nodeType <6 funciona porque los atributos (2) no aparecen como niños
			para (elem = elem.firstChild; elem; elem = elem.nextSibling) {
				if (elem.nodeType <6) {
					falso retorno;
				}
			}
			devolver verdadero;
		},

		"padre": función (elem) {
			return! Expr.pseudos ["empty"] (elem);
		},

		// Elemento / tipos de entrada
		"encabezado": función (elem) {
			return rheader.test (elem.nodeName);
		},

		"entrada": función (elem) {
			devuelve rinputs.test (elem.nodeName);
		},

		"botón": función (elem) {
			var name = elem.nodeName.toLowerCase ();
			return name === "input" && elem.type === "button" || nombre === "botón";
		},

		"texto": función (elem) {
			var attr;
			return elem.nodeName.toLowerCase () === "input" &&
				elem.type === "text" &&

				// Soporte: IE <8
				// Aparecen nuevos valores de atributo HTML5 (por ejemplo, "búsqueda") con elem.type === "text"
				((attr = elem.getAttribute ("type")) == null || attr.toLowerCase () === "text");
		},

		// Position-in-collection
		"first": createPositionalPseudo (function () {
			devolver [0];
		}),

		"last": createPositionalPseudo (function (matchIndexes, length) {
			return [longitud - 1];
		}),

		"eq": createPositionalPseudo (function (matchIndexes, length, argument) {
			return [argumento <0? argumento + longitud: argumento];
		}),

		"incluso": createPositionalPseudo (function (matchIndexes, length) {
			var i = 0;
			para (; i <longitud; i + = 2) {
				matchIndexes.push (i);
			}
			return matchIndexes;
		}),

		"impar": createPositionalPseudo (function (matchIndexes, length) {
			var i = 1;
			para (; i <longitud; i + = 2) {
				matchIndexes.push (i);
			}
			return matchIndexes;
		}),

		"lt": createPositionalPseudo (function (matchIndexes, length, argument) {
			var i = argumento <0? argumento + longitud: argumento;
			para (; --i> = 0;) {
				matchIndexes.push (i);
			}
			return matchIndexes;
		}),

		"gt": createPositionalPseudo (function (matchIndexes, length, argument) {
			var i = argumento <0? argumento + longitud: argumento;
			for (; ++ i <length;) {
				matchIndexes.push (i);
			}
			return matchIndexes;
		})
	}
};

Expr.pseudos ["nth"] = Expr.pseudos ["eq"];

// Añadir botón / tipo de entrada pseudos
para (i en {radio: verdadero, casilla de verificación: verdadero, archivo: verdadero, contraseña: verdadero, imagen: verdadero}) {
	Expr.pseudos [i] = createInputPseudo (i);
}
for (i en {submit: true, reset: true}) {
	Expr.pseudos [i] = createButtonPseudo (i);
}

// API fácil para crear nuevos setFilters
function setFilters () {}
setFilters.prototype = Expr.filters = Expr.pseudos;
Expr.setFilters = new setFilters ();

tokenize = Sizzle.tokenize = function (selector, parseOnly) {
	var emparejado, partido, tokens, tipo,
		soFar, grupos, preFiltros,
		cached = tokenCache [selector + ""];

	if (en caché) {
		return parseOnly? 0: cached.slice (0);
	}

	soFar = selector;
	grupos = [];
	preFilters = Expr.preFilter;

	while (soFar) {

		// Coma y primera ejecución
		if (! matching || (match = rcomma.exec (soFar))) {
			if (coincidencia) {
				// No consuma comillas finales como válidas
				soFar = soFar.slice (coincide con [0] .length) || hasta aquí;
			}
			groups.push ((tokens = []));
		}

		emparejado = falso;

		// Combinators
		if ((match = rcombinators.exec (soFar))) {
			emparejado = match.shift ();
			tokens.push ({
				valor: emparejado,
				// Conecta los combinadores descendientes al espacio
				type: match [0] .replace (rtrim, "")
			});
			soFar = soFar.slice (matching.length);
		}

		// Filtros
		para (escriba en Expr.filter) {
			if ((match = matchExpr [tipo] .exec (soFar)) && (! preFilters [tipo] ||
				(match = preFilters [type] (match)))) {
				emparejado = match.shift ();
				tokens.push ({
					valor: emparejado,
					tipo: tipo,
					partidos: partido
				});
				soFar = soFar.slice (matching.length);
			}
		}

		if (! emparejado) {
			descanso;
		}
	}

	// Devuelve la longitud del exceso no válido
	// si solo estamos analizando
	// De lo contrario, lanzar un error o devolver tokens
	return parseOnly?
		soFar.length:
		hasta aquí ?
			Sizzle.error (selector):
			// Guarda en caché los tokens
			tokenCache (selector, grupos) .slice (0);
};

function toSelector (tokens) {
	var i = 0,
		len = tokens.length,
		selector = "";
	para (; i <len; i ++) {
		selector + = tokens [i] .value;
	}
	selector de devolución;
}

función addCombinator (matcher, combinator, base) {
	var dir = combinator.dir,
		checkNonElements = base && dir === "parentNode",
		doneName = done ++;

	volver combinator.first?
		// Verificar contra el ancestro más cercano / elemento precedente
		función (elem, context, xml) {
			while ((elem = elem [dir])) {
				if (elem.nodeType === 1 || checkNonElements) {
					return matcher (elem, context, xml);
				}
			}
		}:

		// Verificar contra todos los ancestros / elementos precedentes
		función (elem, context, xml) {
			var oldCache, outerCache,
				newCache = [dirruns, doneName];

			// No podemos establecer datos arbitrarios en nodos XML, por lo que no se benefician del almacenamiento en caché de directorios
			if (xml) {
				while ((elem = elem [dir])) {
					if (elem.nodeType === 1 || checkNonElements) {
						if (matcher (elem, context, xml)) {
							devolver verdadero;
						}
					}
				}
			} else {
				while ((elem = elem [dir])) {
					if (elem.nodeType === 1 || checkNonElements) {
						outerCache = elem [expando] || (elem [expando] = {});
						if ((oldCache = outerCache [dir]) &&
							oldCache [0] === dirruns && oldCache [1] === doneName) {

							// Asignar a newCache para que los resultados retrocedan a elementos anteriores
							return (newCache [2] = oldCache [2]);
						} else {
							// Reutilizar newcache para que los resultados se propaguen hacia atrás a los elementos anteriores
							outerCache [dir] = newCache;

							// Un partido significa que hemos terminado; un error significa que tenemos que seguir comprobando
							if ((newCache [2] = matcher (elem, context, xml))) {
								devolver verdadero;
							}
						}
					}
				}
			}
		};
}

function elementMatcher (matchers) {
	devolver matchers.length> 1?
		función (elem, context, xml) {
			var i = matchers.length;
			mientras yo-- ) {
				if (! matchers [i] (elem, context, xml)) {
					falso retorno;
				}
			}
			devolver verdadero;
		}:
		matchers [0];
}

function multipleContexts (selector, contextos, resultados) {
	var i = 0,
		len = contexts.length;
	para (; i <len; i ++) {
		Sizzle (selector, contextos [i], resultados);
	}
	resultados de devolución;
}

función condensada (no coincidente, mapa, filtro, contexto, xml) {
	var elem,
		newUnmatched = [],
		i = 0,
		len = unmatched.length,
		mapped = map! = null;

	para (; i <len; i ++) {
		if ((elem = no coincidente [i])) {
			if (! filter || filter (elem, context, xml)) {
				newUnmatched.push (elem);
				if (mapeado) {
					map.push (i);
				}
			}
		}
	}

	return newUnmatched;
}

function setMatcher (preFilter, selector, matcher, postFilter, postFinder, postSelector) {
	if (postFilter &&! postFilter [expando]) {
		postFilter = setMatcher (postFilter);
	}
	if (postFinder &&! postFinder [expando]) {
		postFinder = setMatcher (postFinder, postSelector);
	}
	return markFunction (función (semilla, resultados, contexto, xml) {
		var temp, i, elem,
			preMap = [],
			postMap = [],
			preexistente = results.length,

			// Obtener elementos iniciales de semilla o contexto
			elems = semilla || multipleContexts (selector || "*", context.nodeType? [context]: context, []),

			// Prefilter para obtener la entrada de matcher, preservando un mapa para la sincronización de resultados de inicialización
			matcherIn = preFilter && (seed || selector)?
				condense (elems, preMap, preFilter, context, xml):
				Elems,

			matcherOut = matcher?
				// Si tenemos un postFinder, o seed filtrado, o postFilter no semilla o resultados preexistentes,
				postFinder || (seed? preFilter: preexisting || postFilter)?

					// ... es necesario un procesamiento intermedio
					[]:

					// ... de lo contrario, usa los resultados directamente
					resultados:
				matcherIn;

		// Encuentra coincidencias principales
		if (matcher) {
			matcher (matcherIn, matcherOut, context, xml);
		}

		// Aplicar postFilter
		if (postFilter) {
			temp = condense (matcherOut, postMap);
			postFilter (temp, [], context, xml);

			// Ignorar elementos que fallan volviendo a moverlos a matcherIn
			i = temp.length;
			mientras yo-- ) {
				if ((elem = temp [i])) {
					matcherOut [postMap [i]] =! (matcherIn [postMap [i]] = elem);
				}
			}
		}

		si (semilla) {
			if (postFinder || preFilter) {
				if (postFinder) {
					// Obtenga el matcherOut final al condensar este intermedio en contextos postFinder
					temp = [];
					i = matcherOut.length;
					mientras yo-- ) {
						if ((elem = matcherOut [i])) {
							// Restaurar matcherIn ya que elem aún no es una coincidencia final
							temp.push ((matcherIn [i] = elem));
						}
					}
					postFinder (null, (matcherOut = []), temp, xml);
				}

				// Mueva los elementos coincidentes de la semilla a los resultados para mantenerlos sincronizados
				i = matcherOut.length;
				mientras yo-- ) {
					if ((elem = matcherOut [i]) &&
						(temp = postFinder? indexOf.call (seed, elem): preMap [i])> -1) {

						seed [temp] =! (results [temp] = elem);
					}
				}
			}

		// Agregar elementos a los resultados, a través de postFinder si está definido
		} else {
			matcherOut = condensado (
				matcherOut === resultados?
					matcherOut.splice (preexistente, matcherOut.length):
					matcherOut
			);
			if (postFinder) {
				postFinder (null, resultados, matcherOut, xml);
			} else {
				push.apply (resultados, matcherOut);
			}
		}
	});
}

function matcherFromTokens (tokens) {
	var checkContext, matcher, j,
		len = tokens.length,
		leadingRelative = Expr.relative [tokens [0] .type],
		implicitRelative = leadingRelative || Expr.relative [""],
		i = leadingRelative? 1: 0,

		// El matcher fundacional asegura que los elementos son alcanzables desde el (los) contexto (s) de nivel superior
		matchContext = addCombinator (función (elem) {
			return elem === checkContext;
		}, implicitRelative, true),
		matchAnyContext = addCombinator (function (elem) {
			return indexOf.call (checkContext, elem)> -1;
		}, implicitRelative, true),
		matchers = [function (elem, context, xml) {
			return (! leadingRelative && (xml || context! == outermostContext)) || (
				(checkContext = context) .nodeType?
					matchContext (elem, context, xml):
					matchAnyContext (elem, context, xml));
		}];

	para (; i <len; i ++) {
		if ((matcher = Expr.relative [tokens [i] .type])) {
			matchers = [addCombinator (elementMatcher (matchers), matcher)];
		} else {
			matcher = Expr.filter [tokens [i] .type] .apply (null, tokens [i] .matches);

			// Retorno especial al ver un matcher posicional
			if (matcher [expando]) {
				// Encuentra el siguiente operador relativo (si lo hay) para un manejo adecuado
				j = ++ i;
				para (; j <len; j ++) {
					if (Expr.relative [tokens [j] .type]) {
						descanso;
					}
				}
				devuelve setMatcher (
					i> 1 && elementMatcher (matchers),
					i> 1 && toSelector (
						// Si el token anterior era un combinador descendiente, inserte un elemento any implícito `*`
						tokens.slice (0, i - 1) .concat ({value: tokens [i - 2] .type === ""? "" * ":" "})
					) .replace (rtrim, "$ 1"),
					matcher,
					i <j && matcherFromTokens (tokens.slice (i, j)),
					j <len && matcherFromTokens ((tokens = tokens.slice (j))),
					j <len && toSelector (tokens)
				);
			}
			matchers.push (matcher);
		}
	}

	return elementMatcher (matchers);
}

function matcherFromGroupMatchers (elementMatchers, setMatchers) {
	var bySet = setMatchers.length> 0,
		byElement = elementMatchers.length> 0,
		superMatcher = function (semilla, contexto, xml, resultados, más externo) {
			var elem, j, matcher,
				matchedCount = 0,
				i = "0",
				inigualable = semilla && [],
				setMatched = [],
				contextBackup = outermostContext,
				// Siempre debemos tener elementos semilla o el contexto más externo
				elems = semilla || byElement && Expr.find ["TAG"] ("*", más externo),
				// Usa dirruns enteros iff este es el matcher más externo
				dirrunsUnique = (dirruns + = contextBackup == null? 1: Math.random () || 0.1),
				len = elems.length;

			if (outermost) {
				outermostContext = context! == document && context;
			}

			// Agregar elementos que pasen elementMatchers directamente a los resultados
			// Mantenga `i` una cadena si no hay elementos, por lo que` matchedCount` será "00" a continuación
			// Soporte: IE <9, Safari
			// Tolerar las propiedades de NodeList (IE: "length"; Safari: <number>) haciendo coincidir elementos por id
			para (; i! == len && (elem = elems [i])! = null; i ++) {
				if (byElement && elem) {
					j = 0;
					while ((matcher = elementMatchers [j ++])) {
						if (matcher (elem, context, xml)) {
							results.push (elem);
							descanso;
						}
					}
					if (outermost) {
						dirruns = dirrunsUnique;
					}
				}

				// Seguimiento de elementos no coincidentes para establecer filtros
				if (bySet) {
					// Habrán pasado por todas las parejas posibles
					if ((elem =! matcher && elem)) {
						matchingCount--;
					}

					// Alarga la matriz para cada elemento, coincide o no
					si (semilla) {
						unmatched.push (elem);
					}
				}
			}

			// Aplicar filtros de conjunto a elementos no coincidentes
			matchingCount + = i;
			if (bySet && i! == matchedCount) {
				j = 0;
				while ((matcher = setMatchers [j ++])) {
					matcher (sin igual, setMatched, context, xml);
				}

				si (semilla) {
					// Reintegrar las coincidencias de elementos para eliminar la necesidad de clasificar
					if (matchingCount> 0) {
						mientras yo-- ) {
							if (! (inigualable [i] || setMatched [i])) {
								setMatched [i] = pop.call (resultados);
							}
						}
					}

					// Descartar valores de marcador de posición de índice para obtener solo coincidencias reales
					setMatched = condense (setMatched);
				}

				// Añadir coincidencias a los resultados
				push.apply (results, setMatched);

				// Las combinaciones de conjuntos sin semillas que suceden con éxito en varias combinaciones exitosas estipulan la clasificación
				if (outermost &&! seed && setMatched.length> 0 &&
					(matchedCount + setMatchers.length)> 1) {

					Sizzle.uniqueSort (resultados);
				}
			}

			// Anula la manipulación de globales por parte de los marcadores anidados
			if (outermost) {
				dirruns = dirrunsUnique;
				outermostContext = contextBackup;
			}

			regreso sin igual;
		};

	volver por Set?
		markFunction (superMatcher):
		superMatcher;
}

compile = Sizzle.compile = function (selector, coincidencia / * Solo uso interno * /) {
	var i,
		setMatchers = [],
		elementMatchers = [],
		cached = compilerCache [selector + ""];

	if (! cached) {
		// Genera una función de funciones recursivas que se puede usar para verificar cada elemento
		if (! match) {
			match = tokenize (selector);
		}
		i = match.length;
		mientras yo-- ) {
			cached = matcherFromTokens (coincidencia [i]);
			if (en caché [expando]) {
				setMatchers.push (en caché);
			} else {
				elementMatchers.push (en caché);
			}
		}

		// Guarda en caché la función compilada
		cached = compilerCache (selector, matcherFromGroupMatchers (elementMatchers, setMatchers));

		// Guardar selector y tokenización
		cached.selector = selector;
	}
	devolver en caché;
};

/ **
 * Una función de selección de bajo nivel que funciona con compilado de Sizzle
 * funciones de selector
 * Selector @param {String | Function} Selector o precompilado
 * Función de selector construida con Sizzle.compile
 * contexto @param {Element}
 * @param {Array} [resultados]
 * @param {Array} [seed] Un conjunto de elementos para hacer coincidir
 * /
select = Sizzle.select = function (selector, contexto, resultados, semilla) {
	var i, tokens, token, tipo, buscar,
		compiled = typeof selector === "function" && selector,
		match =! seed && tokenize ((selector = compiled.selector || selector));

	resultados = resultados || [];

	// Intenta minimizar las operaciones si no hay semilla y solo un grupo
	if (match.length === 1) {

		// Tome un atajo y establezca el contexto si el selector de raíz es una ID
		tokens = match [0] = match [0] .slice (0);
		if (tokens.length> 2 && (token = tokens [0]). tipo === "ID" &&
				support.getById && context.nodeType === 9 && documentIsHTML &&
				Expr.relative [tokens [1] .type]) {

			context = (Expr.find ["ID"] (token.matches [0] .replace (runescape, funescape), context) || []) [0];
			if (! context) {
				resultados de devolución;

			// Los emparejamientos precompilados aún verificarán ancestros, así que sube un nivel
			} else if (compilado) {
				context = context.parentNode;
			}

			selector = selector.slice (tokens.shift (). value.length);
		}

		// Obtener un conjunto de semillas para la correspondencia de derecha a izquierda
		i = matchExpr ["needsContext"]. test (selector)? 0: tokens.length;
		mientras yo-- ) {
			token = tokens [i];

			// abortar si golpeamos un combinador
			if (Expr.relative [(type = token.type)]) {
				descanso;
			}
			if ((find = Expr.find [type])) {
				// Buscar, expandir el contexto para los principales combinadores de hermanos
				if ((semilla = encontrar (
					token.matches [0] .replace (runescape, funescape),
					rsibling.test (tokens [0] .type) && testContext (context.parentNode) || contexto
				))) {

					// Si seed está vacío o no quedan tokens, podemos regresar temprano
					tokens.splice (i, 1);
					selector = seed.length && toSelector (tokens);
					if (! selector) {
						push.apply (resultados, semilla);
						resultados de devolución;
					}

					descanso;
				}
			}
		}
	}

	// Compila y ejecuta una función de filtrado si no se proporciona una
	// Proporcionar `match` para evitar la retoqueización si modificamos el selector anterior
	(compilado || compilar (selector, partido)) (
		semilla,
		contexto,
		! documentIsHTML,
		resultados,
		rsibling.test (selector) && testContext (context.parentNode) || contexto
	);
	resultados de devolución;
};

// asignaciones de una sola vez

// Clasificar estabilidad
support.sortStable = expando.split (""). sort (sortOrder) .join ("") === expando;

// Soporte: Chrome <14
// Siempre asume duplicados si no se pasan a la función de comparación
support.detectDuplicates = !! hasDuplicate;

// Initialize contra el documento predeterminado
setDocument ();

// Soporte: Webkit <537.32 - Safari 6.0.3 / Chrome 25 (arreglado en Chrome 27)
// Los nodos independientes se suceden de manera confusa * el uno al otro *
support.sortDetached = assert (function (div1) {
	// Debería devolver 1, pero devuelve 4 (siguiente)
	return div1.compareDocumentPosition (document.createElement ("div")) & 1;
});

// Soporte: IE <8
// Prevenir la "interpolación" de atributo / propiedad
// http://msdn.microsoft.com/en-us/library/ms536429%28VS.85%29.aspx
if (! assert (function (div) {
	div.innerHTML = "<a href='#'> </a>";
	devuelve div.firstChild.getAttribute ("href") === "#";
})) {
	addHandle ("tipo | href | alto | ancho", función (elem, nombre, isXML) {
		if (! isXML) {
			return elem.getAttribute (name, name.toLowerCase () === "type"? 1: 2);
		}
	});
}

// Soporte: IE <9
// Usa defaultValue en lugar de getAttribute ("value")
if (! support.attributes ||! assert (function (div) {
	div.innerHTML = "<input />";
	div.firstChild.setAttribute ("valor", "");
	devuelve div.firstChild.getAttribute ("valor") === "";
})) {
	addHandle ("valor", función (elem, nombre, isXML) {
		if (! isXML && elem.nodeName.toLowerCase () === "input") {
			return elem.defaultValue;
		}
	});
}

// Soporte: IE <9
// Usa getAttributeNode para buscar booleanos cuando getAttribute mentiras
if (! assert (function (div) {
	return div.getAttribute ("disabled") == null;
})) {
	addHandle (booleanos, función (elem, nombre, isXML) {
		var val;
		if (! isXML) {
			return elem [nombre] === ¿verdad? name.toLowerCase ():
					(val = elem.getAttributeNode (name)) && val.specified?
					val.value:
				nulo;
		}
	});
}

devolver Sizzle;

})( ventana );



jQuery.find = Sizzle;
jQuery.expr = Sizzle.selectors;
jQuery.expr [":"] = jQuery.expr.pseudos;
jQuery.unique = Sizzle.uniqueSort;
jQuery.text = Sizzle.getText;
jQuery.isXMLDoc = Sizzle.isXML;
jQuery.contains = Sizzle.contains;



var rneedsContext = jQuery.expr.match.needsContext;

var rsingleTag = (/ ^ <(\ w +) \ s * \ /?> (?: <\ / \ 1> |) $ /);



var risSimple = /^.[^:#\[\.,]*$/;

// Implementa la funcionalidad idéntica para filtro y no
función winnow (elementos, calificador, no) {
	if (jQuery.isFunction (calificador)) {
		return jQuery.grep (elementos, función (elem, i) {
			/ * jshint -W018 * /
			¡regreso! calificador.call (elem, i, elem)! == no;
		});

	}

	if (qualifier.nodeType) {
		return jQuery.grep (elementos, función (elem) {
			return (elem === calificador)! == no;
		});

	}

	if (tipo de calificador === "cadena") {
		if (risSimple.test (calificador)) {
			return jQuery.filter (calificador, elementos, no);
		}

		qualifier = jQuery.filter (calificador, elementos);
	}

	return jQuery.grep (elementos, función (elem) {
		return (jQuery.inArray (elem, calificador)> = 0)! == no;
	});
}

jQuery.filter = function (expr, elems, not) {
	var elem = elems [0];

	si no ) {
		expr = ": not (" + expr + ")";
	}

	return elems.length === 1 && elem.nodeType === 1?
		jQuery.find.matchesSelector (elem, expr)? [elem]: []:
		jQuery.find.matches (expr, jQuery.grep (elems, function (elem) {
			return elem.nodeType === 1;
		}));
};

jQuery.fn.extend ({
	find: function (selector) {
		var i,
			ret = [],
			self = esto,
			len = self.length;

		if (typeof selector! == "cadena") {
			return this.pushStack (jQuery (selector) .filter (function () {
				para (i = 0; i <len; i ++) {
					if (jQuery.contains (self [i], this)) {
						devolver verdadero;
					}
				}
			}));
		}

		para (i = 0; i <len; i ++) {
			jQuery.find (selector, self [i], ret);
		}

		// Necesario porque $ (selector, contexto) se convierte en $ (contexto) .find (selector)
		ret = this.pushStack (len> 1? jQuery.unique (ret): ret);
		ret.selector = this.selector? this.selector + "" + selector: selector;
		return ret;
	},
	filter: function (selector) {
		devuelve this.pushStack (winnow (this, selector || [], false));
	},
	no: función (selector) {
		devuelve this.pushStack (winnow (this, selector || [], true));
	},
	es: function (selector) {
		¡regreso!
			esta,

			// Si este es un selector posicional / relativo, verifique la membresía en el conjunto devuelto
			// tan $ ("p: first"). is ("p: last") no devolverá true para un documento con dos "p".
			typeof selector === "cadena" && rneedsContext.test (selector)?
				jQuery (selector):
				selector || [],
			falso
		).longitud;
	}
});


// Inicializar un objeto jQuery


// Una referencia central a la raíz jQuery (documento)
var rootjQuery,

	// Usa el documento correcto de acuerdo con el argumento de ventana (sandbox)
	document = window.document,

	// Una forma simple de verificar cadenas de HTML
	// Prioriza a #id sobre <etiqueta> para evitar XSS a través de location.hash (# 9521)
	// Estricto reconocimiento HTML (# 11290: debe comenzar con <)
	rquickExpr = / ^ (?: \ s * (<[\ w \ W] +>) [^>] * | # ([\ w -] *)) $ /,

	init = jQuery.fn.init = function (selector, contexto) {
		var match, elem;

		// MANEJO: $ (""), $ (nulo), $ (indefinido), $ (falso)
		if (! selector) {
			devuelve esto;
		}

		// Manejar cadenas de HTML
		if (typeof selector === "cadena") {
			if (selector.charAt (0) === "<" && selector.charAt (selector.length - 1) === ">" && selector.length> = 3) {
				// Supongamos que las cadenas que comienzan y terminan con <> son HTML y omiten la comprobación de expresiones regulares
				match = [null, selector, null];

			} else {
				match = rquickExpr.exec (selector);
			}

			// Haga coincidir html o asegúrese de que no se especifique ningún contexto para #id
			if (match && (match [1] ||! context)) {

				// HANDLE: $ (html) -> $ (array)
				if (match [1]) {
					contexto = instancia de contexto de jQuery? contexto [0]: contexto;

					// scripts es cierto para back-compat
					// Permitir intencionalmente que se produzca el error si parseHTML no está presente
					jQuery.merge (this, jQuery.parseHTML (
						partido [1],
						context && context.nodeType? context.ownerDocument || contexto: documento,
						cierto
					));

					// HANDLE: $ (html, props)
					if (rsingleTag.test (match [1]) && jQuery.isPlainObject (context)) {
						para (partido en contexto) {
							// Las propiedades del contexto se llaman como métodos si es posible
							if (jQuery.isFunction (this [match])) {
								este [partido] (contexto [partido]);

							// ... y configurados como atributos
							} else {
								this.attr (coincidencia, contexto [coincidencia]);
							}
						}
					}

					devuelve esto;

				// HANDLE: $ (# id)
				} else {
					elem = document.getElementById (coincidencia [2]);

					// Ver parentNode para capturar cuando Blackberry 4.6 regresa
					// nodos que ya no están en el documento # 6963
					if (elem && elem.parentNode) {
						// Manejar el caso donde IE y Opera devuelven elementos
						// por nombre en lugar de ID
						if (elem.id! == match [2]) {
							return rootjQuery.find (selector);
						}

						// De lo contrario, inyectamos el elemento directamente en el objeto jQuery
						this.length = 1;
						esto [0] = elem;
					}

					this.context = documento;
					this.selector = selector;
					devuelve esto;
				}

			// HANDLE: $ (expr, $ (...))
			} else if (! context || context.jquery) {
				return (contexto || rootjQuery) .find (selector);

			// HANDLE: $ (expr, context)
			// (que es solo equivalente a: $ (context) .find (expr)
			} else {
				return this.constructor (context) .find (selector);
			}

		// HANDLE: $ (DOMElement)
		} else if (selector.nodeType) {
			this.context = this [0] = selector;
			this.length = 1;
			devuelve esto;

		// HANDLE: $ (función)
		// Acceso directo para documentos listos
		} else if (jQuery.isFunction (selector)) {
			return typeof rootjQuery.ready! == "undefined"?
				rootjQuery.ready (selector):
				// Ejecutar inmediatamente si ready no está presente
				selector (jQuery);
		}

		if (selector.selector! == undefined) {
			this.selector = selector.selector;
			this.context = selector.context;
		}

		return jQuery.makeArray (selector, esto);
	};

// Dale a la función init el prototipo de jQuery para una instanciación posterior
init.prototype = jQuery.fn;

// Inicializar referencia central
rootjQuery = jQuery (documento);


var rparentsprev = / ^ (?: parents | prev (?: Until | All)) /,
	// métodos garantizados para producir un conjunto único cuando se comienza desde un conjunto único
	guaranteedUnique = {
		niños: cierto,
		contenido: verdadero,
		siguiente: cierto,
		prev: cierto
	};

jQuery.extend ({
	dir: function (elem, dir, until) {
		var emparejado = [],
			cur = elem [dir];

		while (cur && cur.nodeType! == 9 && (hasta === undefined || cur.nodeType! == 1 ||! jQuery (cur) .is (until))) {
			if (cur.nodeType === 1) {
				emparejado.push (cur);
			}
			cur = cur [dir];
		}
		regreso emparejado;
	},

	hermano: función (n, elem) {
		var r = [];

		para (; n; n = n.nextSibling) {
			if (n.nodeType === 1 && n! == elem) {
				r.push (n);
			}
		}

		devolver r;
	}
});

jQuery.fn.extend ({
	tiene: función (destino) {
		var i,
			targets = jQuery (target, this),
			len = targets.length;

		return this.filter (function () {
			para (i = 0; i <len; i ++) {
				if (jQuery.contains (this, targets [i])) {
					devolver verdadero;
				}
			}
		});
	},

	más cercano: función (selectores, contexto) {
		var cur,
			i = 0,
			l = this.length,
			emparejado = [],
			pos = rneedsContext.test (selectores) || typeof selectores! == "cadena"?
				jQuery (selectores, contexto || this.context):
				0;

		para (; i <l; i ++) {
			para (cur = this [i]; cur && cur! == context; cur = cur.parentNode) {
				// Siempre salte fragmentos de documentos
				if (cur.nodeType <11 && (pos?
					pos.index (cur)> -1:

					// No pases elementos que no sean a Sizzle
					cur.nodeType === 1 &&
						jQuery.find.matchesSelector (cur, selectores))) {

					emparejado.push (cur);
					descanso;
				}
			}
		}

		return this.pushStack (coincidente.length> 1? jQuery.unique (coincidente): coincidente);
	},

	// Determinar la posición de un elemento dentro
	// el conjunto combinado de elementos
	índice: función (elem) {

		// Sin argumento, índice de devolución en el padre
		if (! elem) {
			return (this [0] && this [0] .parentNode)? this.first (). prevAll (). length: -1;
		}

		// índice en selector
		if (typeof elem === "cadena") {
			return jQuery.inArray (esto [0], jQuery (elem));
		}

		// Ubica la posición del elemento deseado
		return jQuery.inArray (
			// Si recibe un objeto jQuery, se usa el primer elemento
			elem.jquery? elem [0]: elem, esto);
	},

	agregar: función (selector, contexto) {
		devuelve this.pushStack (
			jQuery.unique (
				jQuery.merge (this.get (), jQuery (selector, contexto))
			)
		);
	},

	addBack: function (selector) {
		devuelve this.add (selector == null?
			this.prevObject: this.prevObject.filter (selector)
		);
	}
});

hermano de función (cur, dir) {
	hacer {
		cur = cur [dir];
	} while (cur && cur.nodeType! == 1);

	devolver cur;
}

jQuery.each ({
	padre: función (elem) {
		var parent = elem.parentNode;
		return parent && parent.nodeType! == 11? padre: nulo;
	},
	padres: función (elem) {
		devuelve jQuery.dir (elem, "parentNode");
	},
	parentsUntil: function (elem, i, until) {
		devuelve jQuery.dir (elem, "parentNode", hasta);
	},
	siguiente: función (elem) {
		hermano de regreso (elem, "nextSibling");
	},
	prev: function (elem) {
		hermano de regreso (elem, "hermano anterior");
	},
	nextAll: function (elem) {
		devuelve jQuery.dir (elem, "nextSibling");
	},
	prevAll: function (elem) {
		return jQuery.dir (elem, "previousSibling");
	},
	nextUntil: function (elem, i, until) {
		devuelve jQuery.dir (elem, "nextSibling", hasta);
	},
	prevUntil: function (elem, i, until) {
		devuelve jQuery.dir (elem, "previousSibling", hasta);
	},
	hermanos: función (elem) {
		return jQuery.sibling ((elem.parentNode || {}) .firstChild, elem);
	},
	hijos: función (elem) {
		return jQuery.sibling (elem.firstChild);
	},
	contenido: función (elem) {
		return jQuery.nodeName (elem, "iframe")?
			elem.contentDocument || elem.contentWindow.document:
			jQuery.merge ([], elem.childNodes);
	}
}, función (nombre, fn) {
	jQuery.fn [name] = function (until, selector) {
		var ret = jQuery.map (this, fn, until);

		if (name.slice (-5)! == "Until") {
			selector = hasta;
		}

		if (selector && typeof selector === "cadena") {
			ret = jQuery.filter (selector, ret);
		}

		if (this.length> 1) {
			// Eliminar duplicados
			if (! guaranteedUnique [nombre]) {
				ret = jQuery.unique (ret);
			}

			// orden inverso para los padres * y derivados previos
			if (rparentsprev.test (name)) {
				ret = ret.reverse ();
			}
		}

		devuelve this.pushStack (ret);
	};
});
var rnotwhite = (/ \ S + / g);



// caché de formato de cadenas de opciones de objetos
var optionsCache = {};

// Convierte las opciones formateadas en String en formateadas por objetos y las almacena en caché
function createOptions (opciones) {
	var object = optionsCache [opciones] = {};
	jQuery.each (options.match (rnotwhite) || [], function (_, flag) {
		objeto [flag] = verdadero;
	});
	objeto de retorno;
}

/ *
 * Crea una lista de devolución de llamada utilizando los siguientes parámetros:
 *
 * opciones: una lista opcional de opciones separadas por espacios que cambiarán la forma
 * la lista de devolución de llamada se comporta o un objeto de opción más tradicional
 *
 * Por defecto, una lista de devolución de llamada actuará como una lista de devolución de eventos y puede ser
 * "disparado" varias veces.
 *
 * Posibles opciones:
 *
 * una vez: se asegurará de que la lista de devolución de llamada solo se active una vez (como un aplazado)
 *
 * memoria: hará un seguimiento de los valores anteriores y llamará a cualquier devolución de llamada agregada
 * después de que la lista ha sido disparada de inmediato con la última "memorización"
 * valores (como un aplazado)
 *
 * unique: asegurará que una devolución de llamada solo se pueda agregar una vez (no hay duplicados en la lista)
 *
 * stopOnFalse: interrumpe las llamadas cuando una devolución de llamada devuelve falso
 *
 * /
jQuery.Callbacks = function (opciones) {

	// Convierte las opciones de formato de cadena a formato de objeto si es necesario
	// (registramos la caché primero)
	opciones = tipo de opciones === "cadena"?
		(optionsCache [opciones] || createOptions (opciones)):
		jQuery.extend ({}, opciones);

	var // Flag para saber si la lista está actualmente activa
		disparo,
		// Último valor de fuego (para listas no olvidables)
		memoria,
		// Marca para saber si la lista ya se activó
		despedido,
		// Fin del ciclo al disparar
		despidoLongitud,
		// Índice de devolución de llamada activa (modificada por eliminar si es necesario)
		disparar índice,
		// Primera devolución de llamada al fuego (utilizada internamente por add y fireWith)
		disparandoInicio,
		// Lista de devolución real
		list = [],
		// La pila de fuego requiere listas repetibles
		stack =! options.once && [],
		// devolución de llamada de fuego
		fuego = función (datos) {
			memory = options.memory && data;
			disparado = verdadero;
			disparandoIndex = disparandoInicio || 0;
			disparandoStart = 0;
			firingLength = list.length;
			disparando = verdadero;
			para (; list && fuegoIndex <fuegoDeLuego; índicedefuego ++) {
				if (lista [igningIndex] .apply (data [0], data [1]) === false && options.stopOnFalse) {
					memoria = falso; // Para prevenir más llamadas usando add
					descanso;
				}
			}
			disparando = falso;
			if (lista) {
				if (pila) {
					if (stack.length) {
						fuego (stack.shift ());
					}
				} else if (memoria) {
					list = [];
				} else {
					self.disable ();
				}
			}
		},
		// objeto de devolución de llamada real
		self = {
			// Agregar una devolución de llamada o una colección de devoluciones de llamada a la lista
			agregar: función () {
				if (lista) {
					// Primero, guardamos la longitud actual
					var start = list.length;
					(función add (args) {
						jQuery.each (args, function (_, arg) {
							var type = jQuery.type (arg);
							if (tipo === "función") {
								if (! options.unique ||! self.has (arg)) {
									list.push (arg);
								}
							} else if (arg && arg.length && type! == "cadena") {
								// Inspeccionar recursivamente
								agregar (arg);
							}
						});
					}) (argumentos);
					// ¿Necesitamos agregar las devoluciones de llamada al
					// lote de encendido actual?
					si (disparando) {
						firingLength = list.length;
					// Con memoria, si no estamos disparando, entonces
					// deberíamos llamar de inmediato
					} else if (memoria) {
						disparandoInicio = inicio;
						fuego (memoria);
					}
				}
				devuelve esto;
			},
			// Eliminar una devolución de llamada de la lista
			remove: function () {
				if (lista) {
					jQuery.each (argumentos, función (_, arg) {
						índice de var;
						while ((index = jQuery.inArray (arg, list, index))> -1) {
							list.splice (índice, 1);
							// Manejar índices de tiro
							si (disparando) {
								if (index <= despedidaLongitud) {
									FiringLength--;
								}
								if (index <= fuegoIndex) {
									disparandoIndex--;
								}
							}
						}
					});
				}
				devuelve esto;
			},
			// Compruebe si una devolución de llamada dada está en la lista.
			// Si no se da ningún argumento, regrese si la lista tiene callbacks adjuntos o no.
			tiene: function (fn) {
				volver fn? jQuery.inArray (fn, list)> -1: !! (list && list.length);
			},
			// Eliminar todas las devoluciones de llamada de la lista
			empty: function () {
				list = [];
				igniciónLength = 0;
				devuelve esto;
			},
			// Hacer que la lista ya no haga nada
			disable: function () {
				list = stack = memory = undefined;
				devuelve esto;
			},
			// ¿Está deshabilitado?
			disabled: function () {
				lista de regreso!
			},
			// Bloquea la lista en su estado actual
			lock: function () {
				stack = undefined;
				if (! memoria) {
					self.disable ();
				}
				devuelve esto;
			},
			// ¿Está bloqueado?
			locked: function () {
				volver! pila;
			},
			// Llamar a todas las devoluciones de llamada con el contexto y los argumentos dados
			fireWith: function (context, args) {
				if (lista && (! fired || stack)) {
					args = args || [];
					args = [context, args.slice? args.slice (): args];
					si (disparando) {
						stack.push (args);
					} else {
						fuego (args);
					}
				}
				devuelve esto;
			},
			// Llamar a todas las devoluciones de llamada con los argumentos dados
			fuego: función () {
				self.fireWith (esto, argumentos);
				devuelve esto;
			},
			// Para saber si las devoluciones de llamada ya se han llamado al menos una vez
			disparado: function () {
				¡vuelve! despedido;
			}
		};

	volverse a sí mismo;
};


jQuery.extend ({

	Deferido: función (func) {
		var tuples = [
				// acción, agregar oyente, lista de oyentes, estado final
				["resolver", "hecho", jQuery.Callbacks ("una vez que la memoria"), "resuelto"],
				["rechazo", "falla", jQuery.Callbacks ("memoria de una vez"), "rechazado"],
				["notificar", "progreso", jQuery.Callbacks ("memoria")]
			],
			estado = "pendiente",
			promesa = {
				función estatal() {
					estado de devolución;
				},
				siempre: función () {
					deferred.done (argumentos) .fail (argumentos);
					devuelve esto;
				},
				then: function (/ * fnDone, fnFail, fnProgress * /) {
					var fns = argumentos;
					return jQuery.Deferred (function (newDefer) {
						jQuery.each (tuplas, función (i, tupla) {
							var fn = jQuery.isFunction (fns [i]) && fns [i];
							// diferido [hecho | fallar | progress] para reenviar acciones a newDefer
							diferido [tupla [1]] (función () {
								var returned = fn && fn.apply (esto, argumentos);
								if (returned && jQuery.isFunction (returned.promise)) {
									returned.promise ()
										.done (newDefer.resolve)
										.fail (newDefer.reject)
										.progress (newDefer.notify);
								} else {
									newDefer [tuple [0] + "With"] (this === promise? newDefer.promise (): this, fn? [returned]: arguments);
								}
							});
						});
						fns = null;
					}).promesa();
				},
				// Obtenga una promesa para este diferido
				// Si se proporciona obj, el aspecto de promesa se agrega al objeto
				promesa: función (obj) {
					return obj! = null? jQuery.extend (obj, promesa): promesa;
				}
			},
			diferido = {};

		// Keep pipe para back-compat
		promise.pipe = promise.then;

		// Añadir métodos específicos de la lista
		jQuery.each (tuplas, función (i, tupla) {
			var list = tuple [2],
				stateString = tuple [3];

			// promesa [hecho | fallar | progress] = list.add
			promesa [tuple [1]] = list.add;

			// Manejar el estado
			if (stateString) {
				list.add (function () {
					// estado = [resuelto | rechazado]
					state = stateString;

				// [reject_list | resolve_list] .disable; progress_list.lock
				}, tuplas [i ^ 1] [2] .disable, tuplas [2] [2] .lock);
			}

			// diferido [resolver | rechazar | notificar]
			diferido [tuple [0]] = function () {
				diferido [tupla [0] + "Con"] (esto === promesa diferida: esto, argumentos);
				devuelve esto;
			};
			diferido [tuple [0] + "Con"] = list.fireWith;
		});

		// Hacer que el diferido sea una promesa
		promesa.promiso (diferido);

		// Llamar func dado si hay alguno
		if (func) {
			func.call (diferido, diferido);
		}

		// ¡Todo listo!
		devolución diferida;
	},

	// Ayudante diferido
	cuando: función (subordinado / *, ..., subordinadoN * /) {
		var i = 0,
			resolveValues ​​= slice.call (argumentos),
			length = resolveValues.length,

			// el conteo de subordinados incompletos
			restante = longitud! == 1 || (subordinado && jQuery.isFunction (subordinate.promise))? longitud: 0,

			// el maestro diferido Si los valores de resolución consisten en un solo diferido, solo use eso.
			diferido = restante === 1? subordinado: jQuery.Deferred (),

			// Función de actualización para ambos valores de resolución y progreso
			updateFunc = function (i, contexts, values) {
				función de retorno (valor) {
					contextos [i] = esto;
					values ​​[i] = arguments.length> 1? slice.call (argumentos): valor;
					if (valores === progressValues) {
						deferred.notifyWith (contextos, valores);

					} else if (! (- restante)) {
						deferred.resolveWith (contextos, valores);
					}
				};
			},

			progressValues, progressContexts, resolveContexts;

		// agregar oyentes a los subordinados diferidos; tratar a los demás como resueltos
		if (longitud> 1) {
			progressValues ​​= new Array (longitud);
			progressContexts = new Array (longitud);
			resolveContexts = new Array (longitud);
			para (; i <longitud; i ++) {
				if (resolveValues ​​[i] && jQuery.isFunction (resolveValues ​​[i] .promise)) {
					resolveValues ​​[i] .promise ()
						.done (updateFunc (i, resolveContexts, resolveValues))
						.fail (deferred.reject)
						.progress (updateFunc (i, progressContexts, progressValues));
				} else {
					--restante;
				}
			}
		}

		// si no estamos esperando nada, resuelve el maestro
		if (! remaining) {
			deferred.resolveWith (resolveContexts, resolveValues);
		}

		return deferred.promise ();
	}
});


// El diferido utilizado en DOM listo
var lista lista;

jQuery.fn.ready = function (fn) {
	// Agregar la devolución de llamada
	jQuery.ready.promise (). done (fn);

	devuelve esto;
};

jQuery.extend ({
	// ¿El DOM está listo para ser utilizado? Establezca en verdadero una vez que ocurre.
	isReady: falso,

	// Un contador para rastrear cuántos artículos esperar antes
	// el evento listo se dispara. Ver # 6781
	ReadyWait: 1,

	// Mantenga (o suelte) el evento listo
	holdReady: function (hold) {
		if (mantener) {
			jQuery.readyWait ++;
		} else {
			jQuery.ready (verdadero);
		}
	},

	// Manejar cuando el DOM está listo
	listo: función (espera) {

		// Abortar si hay retenciones pendientes o ya estamos listas
		if (wait === true? --jQuery.readyWait: jQuery.isReady) {
			regreso;
		}

		// Asegúrate de que el cuerpo exista, al menos, en caso de que el IE se vuelva un poco entusiasta (ticket # 5443).
		if (! document.body) {
			devuelve setTimeout (jQuery.ready);
		}

		// Recuerda que el DOM está listo
		jQuery.isReady = verdadero;

		// Si un evento DOM Ready normal se dispara, disminuye y espera si es necesario
		if (wait! == true && --jQuery.readyWait> 0) {
			regreso;
		}

		// Si hay funciones enlazadas, ejecutar
		readyList.resolveWith (document, [jQuery]);

		// Dispara cualquier evento listo enlazado
		if (jQuery.fn.triggerHandler) {
			jQuery (document) .triggerHandler ("listo");
			jQuery (documento) .off ("listo");
		}
	}
});

/ **
 * Método de limpieza para eventos dom ready
 * /
function detach () {
	if (document.addEventListener) {
		document.removeEventListener ("DOMContentLoaded", completado, falso);
		window.removeEventListener ("carga", completado, falso);

	} else {
		document.detachEvent ("onreadystatechange", completado);
		window.detachEvent ("onload", completado);
	}
}

/ **
 * El controlador de eventos listos y el método de auto limpieza
 * /
función completada () {
	// readyState === "complete" es lo suficientemente bueno para que podamos llamar al dom ready en oldIE
	if (document.addEventListener || event.type === "load" || document.readyState === "complete") {
		despegar();
		jQuery.ready ();
	}
}

jQuery.ready.promise = function (obj) {
	if (! readyList) {

		readyList = jQuery.Deferred ();

		// Capturar casos en los que se llama a $ (document) .ready () después de que el evento del navegador ya haya ocurrido.
		// una vez intentamos usar readyState "interactivo" aquí, pero causó problemas como el
		// descubierto por ChrisS aquí: http://bugs.jquery.com/ticket/12282#comment:15
		if (document.readyState === "complete") {
			// Manejarlo de forma asíncrona para permitir que las secuencias de comandos tengan la oportunidad de retrasar listas
			setTimeout (jQuery.ready);

		// Los navegadores basados ​​en estándares admiten DOMContentLoaded
		} else if (document.addEventListener) {
			// Usa la práctica devolución de llamada del evento
			document.addEventListener ("DOMContentLoaded", completado, falso);

			// Una alternativa a window.onload, que siempre funcionará
			window.addEventListener ("carga", completado, falso);

		// Si se usa el modelo de evento IE
		} else {
			// Asegúrate de disparar antes de la carga, quizás tarde pero seguro también para iframes
			document.attachEvent ("onreadystatechange", completado);

			// Una alternativa a window.onload, que siempre funcionará
			window.attachEvent ("onload", completado);

			// Si IE y no un marco
			// continuamente verifica si el documento está listo
			var top = false;

			tratar {
				top = window.frameElement == null && document.documentElement;
			} catch (e) {}

			if (arriba && top.doScroll) {
				(función doScrollCheck () {
					if (! jQuery.isReady) {

						tratar {
							// Usa el truco de Diego Perini
							// http://javascript.nwbox.com/IEContentLoaded/
							top.doScroll ("izquierda");
						} catch (e) {
							devuelve setTimeout (doScrollCheck, 50);
						}

						// separar todos los eventos dom ready
						despegar();

						// y ejecuta cualquier función de espera
						jQuery.ready ();
					}
				}) ();
			}
		}
	}
	return readyList.promise (obj);
};


var strundefined = typeof undefined;



// Soporte: IE <9
// Iteración sobre las propiedades heredadas del objeto antes que las suyas
var i;
para (i en jQuery (soporte)) {
	descanso;
}
support.ownLast = i! == "0";

// Nota: la mayoría de las pruebas de soporte se definen en sus respectivos módulos.
// falso hasta que se ejecute la prueba
support.inlineBlockNeedsLayout = false;

// Ejecute ASAP en caso de que necesitemos establecer body.style.zoom
jQuery (función () {
	// Minificado: var a, b, c, d
	var val, div, cuerpo, contenedor;

	body = document.getElementsByTagName ("cuerpo") [0];
	if (! body ||! body.style) {
		// Retorno para los documentos del conjunto de marcos que no tienen un cuerpo
		regreso;
	}

	// Preparar
	div = document.createElement ("div");
	container = document.createElement ("div");
	container.style.cssText = "position: absolute; border: 0; width: 0; height: 0; top: 0; left: -9999px";
	body.appendChild (contenedor) .appendChild (div);

	if (typeof div.style.zoom! == strundefined) {
		// Soporte: IE <8
		// Verifica si los elementos nativos a nivel de bloque actúan como bloque en línea
		// elementos al configurar su pantalla para 'en línea' y dando
		// ellos diseño
		div.style.cssText = "display: inline; margin: 0; border: 0; relleno: 1px; ancho: 1px; zoom: 1";

		support.inlineBlockNeedsLayout = val = div.offsetWidth === 3;
		if (val) {
			// Impide que IE 6 afecte el diseño de los elementos posicionados # 11048
			// Evita que el IE encoja el cuerpo en el modo IE 7 # 12869
			// Soporte: IE <8
			body.style.zoom = 1;
		}
	}

	body.removeChild (contenedor);
});




(función () {
	var div = document.createElement ("div");

	// Ejecute la prueba solo si no se ha ejecutado en otro módulo.
	if (support.deleteExpando == null) {
		// Soporte: IE <9
		support.deleteExpando = true;
		tratar {
			eliminar div.test;
		} catch (e) {
			support.deleteExpando = false;
		}
	}

	// Elementos nulos para evitar fugas en IE.
	div = null;
}) ();


/ **
 * Determina si un objeto puede tener datos
 * /
jQuery.acceptData = function (elem) {
	var noData = jQuery.noData [(elem.nodeName + "") .toLowerCase ()],
		nodeType = + elem.nodeType || 1;

	// No establezca datos en nodos DOM que no sean elementos porque no se borrará (# 8335).
	return nodeType! == 1 && nodeType! == 9?
		falso:

		// Los nodos aceptan datos a menos que se especifique lo contrario; el rechazo puede ser condicional
		! noData || noData! == true && elem.getAttribute ("classid") === noData;
};


var rbrace = / ^ (?: \ {[\ w \ W] * \} | \ [[\ w \ W] * \]) $ /,
	rmultiDash = / ([AZ]) / g;

function dataAttr (elem, key, data) {
	// Si no se encontró nada internamente, intente buscar cualquier
	// datos del atributo data- * HTML5
	if (data === undefined && elem.nodeType === 1) {

		var name = "data-" + key.replace (rmultiDash, "- $ 1") .toLowerCase ();

		data = elem.getAttribute (nombre);

		if (tipo de datos === "cadena") {
			tratar {
				data = data === "true"? cierto :
					datos === "falso"? falso:
					datos === "nulo"? nulo :
					// Solo convierte a un número si no cambia la cadena
					+ datos + "" === datos? + datos:
					rbrace.test (datos)? jQuery.parseJSON (datos):
					datos;
			} catch (e) {}

			// Asegúrate de configurar los datos para que no se modifiquen más tarde
			jQuery.data (elem, clave, datos);

		} else {
			datos = indefinido;
		}
	}

	datos de retorno;
}

// verifica el vacío de un objeto de caché
function isEmptyDataObject (obj) {
	var nombre;
	para (nombre en obj) {

		// si el objeto de datos públicos está vacío, el privado todavía está vacío
		if (name === "data" && jQuery.isEmptyObject (obj [nombre])) {
			continuar;
		}
		if (name! == "toJSON") {
			falso retorno;
		}
	}

	devolver verdadero;
}

function internalData (elem, name, data, pvt / * Solo uso interno * /) {
	if (! jQuery.acceptData (elem)) {
		regreso;
	}

	var ret, thisCache,
		internalKey = jQuery.expando,

		// Tenemos que manejar los nodos DOM y los objetos JS de forma diferente porque IE6-7
		// no se pueden hacer referencias al objeto GC correctamente en el límite DOM-JS
		isNode = elem.nodeType,

		// Solo los nodos DOM necesitan la caché jQuery global; Los datos del objeto JS son
		// conectado directamente al objeto para que GC pueda ocurrir automáticamente
		cache = isNode? jQuery.cache: elem,

		// Solo definiendo una ID para objetos JS si su caché ya existe, permite
		// el código para acceso directo en la misma ruta que un nodo DOM sin caché
		id = isNode? elem [tecla interna]: elem [tecla interna] && clave interna;

	// Evitamos hacer más trabajo del que necesitamos al tratar de obtener datos en un
	// objeto que no tiene datos en absoluto
	if ((! id ||! cache [id] || (! pvt &&! cache [id] .data)) && data === undefined && typeof name === "string") {
		regreso;
	}

	si yo d ) {
		// Solo los nodos DOM necesitan una nueva ID única para cada elemento, ya que sus datos
		// termina en el caché global
		if (isNode) {
			id = elem [clave interna] = deletedIds.pop () || jQuery.guid ++;
		} else {
			id = clave interna;
		}
	}

	if (! cache [id]) {
		// Evita exponer los metadatos jQuery en objetos JS simples cuando el objeto
		// se serializa usando JSON.stringify
		caché [id] = isNode? {}: {toJSON: jQuery.noop};
	}

	// Un objeto se puede pasar a jQuery.data en lugar de un par clave / valor; esto se pone
	// shallow copiado en el caché existente
	if (tipo de nombre === "objeto" || tipo de nombre === "función") {
		if (pvt) {
			caché [id] = jQuery.extend (caché [id], nombre);
		} else {
			caché [id] .data = jQuery.extend (caché [id] .data, nombre);
		}
	}

	thisCache = caché [id];

	// jQuery data () se almacena en un objeto separado dentro de los datos internos del objeto
	// caché para evitar colisiones de teclas entre datos internos y definidos por el usuario
	// datos.
	if (! pvt) {
		if (! thisCache.data) {
			thisCache.data = {};
		}

		thisCache = thisCache.data;
	}

	if (data! == undefined) {
		thisCache [jQuery.camelCase (name)] = data;
	}

	// Compruebe si hay nombres de propiedad de datos convertidos a camello y no convertidos
	// Si se especificó una propiedad de datos
	if (tipo de nombre === "cadena") {

		// Primero intente encontrar los datos de la propiedad tal cual
		ret = thisCache [nombre];

		// Prueba de datos de propiedad nulos | indefinidos
		if (ret == null) {

			// Intenta encontrar la propiedad camelCased
			ret = thisCache [jQuery.camelCase (nombre)];
		}
	} else {
		ret = thisCache;
	}

	return ret;
}

función internalRemoveData (elem, name, pvt) {
	if (! jQuery.acceptData (elem)) {
		regreso;
	}

	var thisCache, yo,
		isNode = elem.nodeType,

		// Ver jQuery.data para más información
		cache = isNode? jQuery.cache: elem,
		id = isNode? elem [jQuery.expando]: jQuery.expando;

	// Si ya no hay entrada de caché para este objeto, no hay
	// propósito de continuar
	if (! cache [id]) {
		regreso;
	}

	if (nombre) {

		thisCache = pvt? caché [id]: caché [id] .data;

		if (thisCache) {

			// Soporta nombres de cadena separados por espacio o por matriz para claves de datos
			if (! jQuery.isArray (name)) {

				// prueba la cadena como una clave antes de cualquier manipulación
				if (nombre en thisCache) {
					name = [nombre];
				} else {

					// divide la versión en camello por espacios a menos que exista una clave con los espacios
					name = jQuery.camelCase (nombre);
					if (nombre en thisCache) {
						name = [nombre];
					} else {
						name = name.split ("");
					}
				}
			} else {
				// Si "nombre" es una matriz de teclas ...
				// Cuando los datos se crean inicialmente, a través de la firma ("clave", "val"),
				// las claves se convertirán en camelCase.
				// Como no hay manera de decir _how_ se agregó una clave, elimine
				// tanto la clave simple como la clave camelCase. # 12786
				// Esto solo penalizará la ruta del argumento de la matriz.
				name = name.concat (jQuery.map (nombre, jQuery.camelCase));
			}

			i = name.length;
			mientras yo-- ) {
				eliminar thisCache [nombre [i]];
			}

			// Si no quedan datos en el caché, queremos continuar
			// y dejar que el objeto de caché se destruya
			if (pvt?! isEmptyDataObject (thisCache):! jQuery.isEmptyObject (thisCache)) {
				regreso;
			}
		}
	}

	// Ver jQuery.data para más información
	if (! pvt) {
		eliminar caché [id] .data;

		// No destruyas la caché principal a menos que el objeto de datos interno
		// había sido lo único que quedaba en él
		if (! isEmptyDataObject (cache [id])) {
			regreso;
		}
	}

	// Destruye el caché
	if (isNode) {
		jQuery.cleanData ([elem], verdadero);

	// Use delete cuando se admite para expandos o `cache` no es una ventana por isWindow (# 10080)
	/ * jshint eqeqeq: falso * /
	} else if (support.deleteExpando || cache! = cache.window) {
		/ * jshint eqeqeq: true * /
		eliminar caché [id];

	// Cuando todo lo demás falla, null
	} else {
		caché [id] = null;
	}
}

jQuery.extend ({
	caché: {},

	// Los siguientes elementos (espacio-sufijo para evitar colisiones Object.prototype)
	// arrojar excepciones inaptables si intenta establecer propiedades de expansión
	sin datos: {
		"applet": cierto,
		"insertar": cierto,
		// ... pero los objetos Flash (que tienen este classid) * pueden * manejar expandos
		"objeto": "clsid: D27CDB6E-AE6D-11cf-96B8-444553540000"
	},

	hasData: function (elem) {
		elem = elem.nodeType? jQuery.cache [elem [jQuery.expando]]: elem [jQuery.expando];
		¡return! elem &&! isEmptyDataObject (elem);
	},

	datos: función (elem, nombre, datos) {
		return internalData (elem, name, data);
	},

	removeData: function (elem, name) {
		devuelve internalRemoveData (elem, nombre);
	},

	// Sólo para uso interno.
	_data: function (elem, name, data) {
		return internalData (elem, name, data, true);
	},

	_removeData: function (elem, name) {
		devuelve internalRemoveData (elem, name, true);
	}
});

jQuery.fn.extend ({
	datos: función (clave, valor) {
		var i, name, data,
			elem = this [0],
			attrs = elem && elem.attributes;

		// Las expectativas especiales de .data básicamente frustran jQuery.access,
		// entonces implementamos el comportamiento relevante nosotros mismos

		// Obtiene todos los valores
		if (clave === undefined) {
			if (this.length) {
				data = jQuery.data (elem);

				if (elem.nodeType === 1 &&! jQuery._data (elem, "parsedAttrs")) {
					i = attrs.length;
					mientras yo-- ) {

						// Soporte: IE11 +
						// Los elementos attrs pueden ser nulos (# 14894)
						if (attrs [i]) {
							name = attrs [i] .name;
							if (name.indexOf ("data-") === 0) {
								name = jQuery.camelCase (name.slice (5));
								dataAttr (elem, nombre, datos [nombre]);
							}
						}
					}
					jQuery._data (elem, "parsedAttrs", verdadero);
				}
			}

			datos de retorno;
		}

		// Establece valores múltiples
		if (tipo de clave === "objeto") {
			return this.each (function () {
				jQuery.data (esto, clave);
			});
		}

		return arguments.length> 1?

			// Establece un valor
			this.each (function () {
				jQuery.data (esto, clave, valor);
			}):

			// Obtiene un valor
			// Trata de obtener primero cualquier información almacenada internamente
			elem? dataAttr (elem, key, jQuery.data (elem, key)): indefinido;
	},

	removeData: function (clave) {
		return this.each (function () {
			jQuery.removeData (this, key);
		});
	}
});


jQuery.extend ({
	queue: function (elem, type, data) {
		var queue;

		if (elem) {
			tipo = (tipo || "fx") + "cola";
			queue = jQuery._data (elem, type);

			// Aumenta la velocidad de dequeue saliendo rápidamente si esto es solo una búsqueda
			if (datos) {
				if (! queue || jQuery.isArray (data)) {
					queue = jQuery._data (elem, type, jQuery.makeArray (data));
				} else {
					queue.push (datos);
				}
			}
			cola de retorno || [];
		}
	},

	dequeue: function (elem, type) {
		tipo = tipo || "fx";

		var queue = jQuery.queue (elem, type),
			startLength = queue.length,
			fn = queue.shift (),
			hooks = jQuery._queueHooks (elem, type),
			siguiente = función () {
				jQuery.dequeue (elem, tipo);
			};

		// Si la cola fx está eliminada, siempre elimine el progreso sentinel
		if (fn === "en progreso") {
			fn = queue.shift ();
			startLength--;
		}

		if (fn) {

			// Agregar un control de progreso para evitar que la cola fx sea
			// dequeued automáticamente
			if (tipo === "fx") {
				queue.unshift ("en progreso");
			}

			// borrar la última función de detención de cola
			eliminar hooks.stop;
			fn.call (elem, siguiente, ganchos);
		}

		if (! startLength && hooks) {
			hooks.empty.fire ();
		}
	},

	// no destinado al consumo público: genera un objeto queueHooks o devuelve el actual
	_queueHooks: function (elem, type) {
		var clave = tipo + "queueHooks";
		return jQuery._data (elem, key) || jQuery._data (elem, key, {
			empty: jQuery.Callbacks ("una vez memoria"). add (función () {
				jQuery._removeData (elem, tipo + "cola");
				jQuery._removeData (elem, clave);
			})
		});
	}
});

jQuery.fn.extend ({
	cola: función (tipo, datos) {
		var setter = 2;

		if (tipo de tipo! == "cadena") {
			datos = tipo;
			type = "fx";
			setter--;
		}

		if (arguments.length <setter) {
			return jQuery.queue (this [0], type);
		}

		devolver datos === undefined?
			esta :
			this.each (function () {
				var queue = jQuery.queue (this, type, data);

				// asegurar un gancho para esta cola
				jQuery._queueHooks (esto, tipo);

				if (escribe === "fx" && queue [0]! == "inprogress") {
					jQuery.dequeue (esto, tipo);
				}
			});
	},
	dequeue: function (type) {
		return this.each (function () {
			jQuery.dequeue (esto, tipo);
		});
	},
	clearQueue: function (type) {
		devuelve this.queue (tipo || "fx", []);
	},
	// Obtener una promesa resuelta cuando las colas de un cierto tipo
	// se vacían (fx es el tipo por defecto)
	promesa: función (tipo, obj) {
		var tmp,
			recuento = 1,
			defer = jQuery.Deferred (),
			elementos = esto,
			i = this.length,
			resolve = function () {
				if (! (--count)) {
					defer.resolveWith (elementos, [elementos]);
				}
			};

		if (tipo de tipo! == "cadena") {
			obj = tipo;
			tipo = indefinido;
		}
		tipo = tipo || "fx";

		mientras yo-- ) {
			tmp = jQuery._data (elementos [i], tipo + "queueHooks");
			if (tmp && tmp.empty) {
				contar ++;
				tmp.empty.add (resolver);
			}
		}
		resolver();
		return defer.promise (obj);
	}
});
var pnum = (/[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/).source;

var cssExpand = ["Superior", "Derecho", "Inferior", "Izquierda"];

var isHidden = function (elem, el) {
		// isHidden podría llamarse desde la función jQuery # filter;
		// en ese caso, el elemento será el segundo argumento
		elem = el || elem;
		return jQuery.css (elem, "display") === "ninguno" || ! jQuery.contains (elem.ownerDocument, elem);
	};



// Método multifuncional para obtener y establecer valores de una colección
// Los valores / s se pueden ejecutar opcionalmente si se trata de una función
var access = jQuery.access = function (elems, fn, key, value, chainable, emptyGet, raw) {
	var i = 0,
		longitud = elems.length,
		bulk = clave == nulo;

	// Establece muchos valores
	if (jQuery.type (key) === "object") {
		chainable = verdadero;
		para (yo en clave) {
			jQuery.access (elems, fn, i, clave [i], true, emptyGet, raw);
		}

	// Establece un valor
	} else if (value! == undefined) {
		chainable = verdadero;

		if (! jQuery.isFunction (value)) {
			raw = verdadero;
		}

		if (bulk) {
			// Las operaciones masivas se ejecutan contra todo el conjunto
			if (raw) {
				fn.call (elems, valor);
				fn = nulo;

			// ... excepto cuando se ejecutan valores de funciones
			} else {
				bulk = fn;
				fn = función (elem, clave, valor) {
					return bulk.call (jQuery (elem), valor);
				};
			}
		}

		if (fn) {
			para (; i <longitud; i ++) {
				fn (elems [i], key, raw? value: value.call (elems [i], i, fn (elems [i], clave)));
			}
		}
	}

	volver encadenable?
		Elems:

		// Obtiene
		a granel?
			fn.call (elems):
			longitud ? fn (elems [0], tecla): emptyGet;
};
var rcheckableType = (/ ^ (?: checkbox | radio) $ / i);



(función () {
	// Minificado: var a, b, c
	var input = document.createElement ("entrada"),
		div = document.createElement ("div"),
		fragment = document.createDocumentFragment ();

	// Preparar
	div.innerHTML = "<link /> <table> </ table> <a href='/a'> a </a> <input type = 'checkbox' />";

	// IE elimina los espacios en blanco iniciales cuando se utiliza .innerHTML
	support.leadingWhitespace = div.firstChild.nodeType === 3;

	// Asegúrate de que los elementos tbody no se inserten automáticamente
	// IE los insertará en tablas vacías
	support.tbody =! div.getElementsByTagName ("tbody") .length;

	// Asegúrate de que los elementos del enlace sean serializados correctamente por innerHTML
	// Esto requiere un elemento contenedor en IE
	support.htmlSerialize = !! div.getElementsByTagName ("enlace") .length;

	// Asegura que la clonación de un elemento html5 no causa problemas
	// Donde outerHTML no está definido, esto todavía funciona
	support.html5Clone =
		document.createElement ("nav") .cloneNode (true) .outerHTML! == "<: nav> </: nav>";

	// Compruebe si una casilla de verificación desconectada retendrá su marcada
	// valor de verdadero después de anexado al DOM (IE6 / 7)
	input.type = "casilla de verificación";
	input.checked = verdadero;
	fragment.appendChild (entrada);
	support.appendChecked = input.checked;

	// Asegúrate de que textarea (y checkbox) defaultValue esté clonado correctamente
	// Soporte: IE6-IE11 +
	div.innerHTML = "<textarea> x </ textarea>";
	support.noCloneChecked = !! div.cloneNode (true) .lastChild.defaultValue;

	// # 11217 - WebKit pierde control cuando el nombre está después del atributo marcado
	fragment.appendChild (div);
	div.innerHTML = "<input type = 'radio' checked = 'checked' name = 't' />";

	// Soporte: Safari 5.1, iOS 5.1, Android 4.x, Android 2.3
	// viejo WebKit no clona el estado verificado correctamente en fragmentos
	support.checkClone = div.cloneNode (true) .cloneNode (true) .lastChild.checked;

	// Soporte: IE <9
	// Opera no clona eventos (y typeof div.attachEvent === undefined).
	// IE9-10 clona eventos vinculados mediante attachEvent, pero no se desencadenan con .click ()
	support.noCloneEvent = true;
	if (div.attachEvent) {
		div.attachEvent ("onclick", function () {
			support.noCloneEvent = false;
		});

		div.cloneNode (true) .click ();
	}

	// Ejecute la prueba solo si no se ha ejecutado en otro módulo.
	if (support.deleteExpando == null) {
		// Soporte: IE <9
		support.deleteExpando = true;
		tratar {
			eliminar div.test;
		} catch (e) {
			support.deleteExpando = false;
		}
	}
}) ();


(función () {
	var i, eventName,
		div = document.createElement ("div");

	// Soporte: IE <9 (falta enviar / cambiar burbuja), Firefox 23+ (falta evento focusin)
	for (i en {submit: true, change: true, focusin: true}) {
		eventName = "on" + i;

		if (! (soporte [i + "Bubbles"] = eventName en la ventana)) {
			// Cuidado con las restricciones de CSP (https://developer.mozilla.org/es/Security/CSP)
			div.setAttribute (eventName, "t");
			soporte [i + "Bubbles"] = div.attributes [eventName] .expando === false;
		}
	}

	// Elementos nulos para evitar fugas en IE.
	div = null;
}) ();


var rformElems = / ^ (?: input | select | textarea) $ / i,
	rkeyEvent = / ^ clave /,
	rmouseEvent = / ^ (?: mouse | pointer | contextmenu) | click /,
	rfocusMorph = / ^ (?: focusinfocus | focusoutblur) $ /,
	rtypenamespace = /^([^.]*)(?:\.(.+)|)$/;

function returnTrue () {
	devolver verdadero;
}

function returnFalse () {
	falso retorno;
}

function safeActiveElement () {
	tratar {
		return document.activeElement;
	} catch (err) {}
}

/ *
 * Funciones de ayuda para la gestión de eventos, no parte de la interfaz pública.
 * Apoyos a la biblioteca addEvent de Dean Edwards para muchas de las ideas.
 * /
jQuery.event = {

	global: {},

	agregar: función (elem, tipos, manejador, datos, selector) {
		var tmp, events, t, handleObjIn,
			special, eventHandle, handleObj,
			manejadores, tipo, espacios de nombres, origType,
			elemData = jQuery._data (elem);

		// No adjunte eventos a noData ni a los nodos de texto / comentario (pero permita objetos simples)
		if (! elemData) {
			regreso;
		}

		// La persona que llama puede pasar un objeto de datos personalizados en lugar del manejador
		if (handler.handler) {
			handleObjIn = controlador;
			handler = handleObjIn.handler;
			selector = handleObjIn.selector;
		}

		// Asegúrate de que el controlador tenga una ID única, utilizada para encontrarla / eliminarla más tarde
		if (! handler.guid) {
			handler.guid = jQuery.guid ++;
		}

		// Inicia la estructura de eventos del elemento y el controlador principal, si esta es la primera
		if (! (events = elemData.events)) {
			events = elemData.events = {};
		}
		if (! (eventHandle = elemData.handle)) {
			eventHandle = elemData.handle = function (e) {
				// Descartar el segundo evento de jQuery.event.trigger () y
				// cuando se invoca un evento después de que una página se descargó
				return typeof jQuery! == strundefined && (! e || jQuery.event.triggered! == e.type)?
					jQuery.event.dispatch.apply (eventHandle.elem, arguments):
					indefinido;
			};
			// Agregue elem como una propiedad del identificador fn para evitar una pérdida de memoria con IE eventos no nativos
			eventHandle.elem = elem;
		}

		// Manejar múltiples eventos separados por un espacio
		types = (types || "") .match (rnotwhite) || [""];
		t = tipos.length;
		while (t--) {
			tmp = rtypenamespace.exec (tipos [t]) || [];
			type = origType = tmp [1];
			espacios de nombres = (tmp [2] || "") .split (".") .sort ();

			// There * must * debe ser un tipo, no adjuntar controladores de espacio de nombres solo
			if (! type) {
				continuar;
			}

			// Si el evento cambia su tipo, use los manejadores de eventos especiales para el tipo cambiado
			especial = jQuery.event.special [tipo] || {};

			// Si el selector está definido, determine el tipo de api de evento especial; de lo contrario, indique el tipo
			type = (selector? special.delegateType: special.bindType) || tipo;

			// Actualización especial basada en el tipo de reinicio reciente
			especial = jQuery.event.special [tipo] || {};

			// handleObj se pasa a todos los controladores de eventos
			handleObj = jQuery.extend ({
				tipo: tipo,
				origType: origType,
				datos: datos,
				controlador: controlador,
				guid: handler.guid,
				selector: selector,
				needsContext: selector && jQuery.expr.match.needsContext.test (selector),
				namespace: namespaces.join (".")
			}, handleObjIn);

			// Inicia la cola del controlador de eventos si somos los primeros
			if (! (handlers = eventos [tipo])) {
				manejadores = eventos [tipo] = [];
				handlers.delegateCount = 0;

				// Solo use addEventListener / attachEvent si el manejador de eventos especiales devuelve falso
				if (! special.setup || special.setup.call (elem, data, namespaces, eventHandle) === false) {
					// Vincula el controlador de eventos global al elemento
					if (elem.addEventListener) {
						elem.addEventListener (type, eventHandle, false);

					} else if (elem.attachEvent) {
						elem.attachEvent ("on" + type, eventHandle);
					}
				}
			}

			if (special.add) {
				special.add.call (elem, handleObj);

				if (! handleObj.handler.guid) {
					handleObj.handler.guid = handler.guid;
				}
			}

			// Agregar a la lista de controladores del elemento, delega delante
			if (selector) {
				handlers.splice (handlers.delegateCount ++, 0, handleObj);
			} else {
				handlers.push (handleObj);
			}

			// Mantenga un registro de los eventos que alguna vez se han utilizado, para la optimización de eventos
			jQuery.event.global [type] = true;
		}

		// Anular elemento para evitar fugas de memoria en IE
		elem = null;
	},

	// Separar un evento o conjunto de eventos de un elemento
	remove: function (elem, types, handler, selector, mappedTypes) {
		var j, handleObj, tmp,
			origCount, t, eventos,
			especial, manejadores, tipo,
			espacios de nombres, origType,
			elemData = jQuery.hasData (elem) && jQuery._data (elem);

		if (! elemData ||! (events = elemData.events)) {
			regreso;
		}

		// Una vez para cada tipo. Namespace en types; tipo puede ser omitido
		types = (types || "") .match (rnotwhite) || [""];
		t = tipos.length;
		while (t--) {
			tmp = rtypenamespace.exec (tipos [t]) || [];
			type = origType = tmp [1];
			espacios de nombres = (tmp [2] || "") .split (".") .sort ();

			// Desvincular todos los eventos (en este espacio de nombres, si se proporciona) para el elemento
			if (! type) {
				para (escriba eventos) {
					jQuery.event.remove (elem, type + types [t], handler, selector, true);
				}
				continuar;
			}

			especial = jQuery.event.special [tipo] || {};
			type = (selector? special.delegateType: special.bindType) || tipo;
			handlers = eventos [tipo] || [];
			tmp = tmp [2] && new RegExp ("(^ | \\.)" + namespaces.join ("\\. (?:. * \\. |)") + "(\\. | $)" );

			// Eliminar eventos coincidentes
			origCount = j = handlers.length;
			while (j--) {
				handleObj = controladores [j];

				if ((mappedTypes || origType === handleObj.origType) &&
					(! handler || handler.guid === handleObj.guid) &&
					(! tmp || tmp.test (handleObj.namespace)) &&
					(! selector || selector === handleObj.selector || selector === "**" && handleObj.selector)) {
					handlers.splice (j, 1);

					if (handleObj.selector) {
						handlers.delegateCount--;
					}
					if (special.remove) {
						special.remove.call (elem, handleObj);
					}
				}
			}

			// Eliminar el controlador genérico de eventos si eliminamos algo y no existen más controladores
			// (evita el potencial de recursión sin fin durante la eliminación de manejadores de eventos especiales)
			if (origCount &&! handlers.length) {
				if (! special.teardown || special.teardown.call (elem, namespaces, elemData.handle) === false) {
					jQuery.removeEvent (elem, type, elemData.handle);
				}

				eliminar eventos [tipo];
			}
		}

		// Eliminar el expando si ya no se usa
		if (jQuery.isEmptyObject (events)) {
			eliminar elemData.handle;

			// removeData también verifica el vacío y borra el expando si está vacío
			// así que úsala en lugar de eliminar
			jQuery._removeData (elem, "eventos");
		}
	},

	trigger: function (event, data, elem, onlyHandlers) {
		var handle, ontype, cur,
			bubbleType, especial, tmp, i,
			eventPath = [elem || documento],
			type = hasOwn.call (event, "type")? event.type: event,
			namespaces = hasOwn.call (event, "namespace")? event.namespace.split ("."): [];

		cur = tmp = elem = elem || documento;

		// No hacer eventos en el texto y nodos de comentarios
		if (elem.nodeType === 3 || elem.nodeType === 8) {
			regreso;
		}

		// enfoca / difumina morfos para enfocar / salir; asegurarse de que no los estamos disparando en este momento
		if (rfocusMorph.test (tipo + jQuery.event.triggered)) {
			regreso;
		}

		if (type.indexOf (".")> = 0) {
			// disparador espaciado de nombres; crear una expresión regular para hacer coincidir el tipo de evento en handle ()
			namespaces = type.split (".");
			type = namespaces.shift ();
			namespaces.sort ();
		}
		ontype = type.indexOf (":") <0 && "on" + type;

		// La persona que llama puede pasar un objeto jQuery.Event, Object o simplemente una cadena de tipo de evento
		event = event [jQuery.expando]?
			evento:
			nuevo jQuery.Event (tipo, tipo de evento === "objeto" && evento);

		// Trigger bitmask: & 1 para controladores nativos; & 2 para jQuery (siempre verdadero)
		event.isTrigger = onlyHandlers? 2: 3;
		event.namespace = namespaces.join (".");
		event.namespace_re = event.namespace?
			nuevo RegExp ("(^ | \\.)" + namespaces.join ("\\. (?:. * \\. |)") + "(\\. | $)"):
			nulo;

		// Limpiar el evento en caso de que se reutilice
		event.result = undefined;
		if (! event.target) {
			event.target = elem;
		}

		// Clonar cualquier información entrante y anteponer el evento, creando la lista de argumentos del manejador
		data = data == null?
			[evento]:
			jQuery.makeArray (datos, [evento]);

		// Permitir que los eventos especiales dibujen fuera de las líneas
		especial = jQuery.event.special [tipo] || {};
		if (! onlyHandlers && special.trigger && special.trigger.apply (elem, data) === false) {
			regreso;
		}

		// Determine la ruta de propagación del evento de antemano, según la especificación de eventos W3C (# 9951)
		// Bubble up to document, luego a window; busque un propietario globalDocument var (# 9724)
		if (! onlyHandlers &&! special.noBubble &&! jQuery.isWindow (elem)) {

			bubbleType = special.delegateType || tipo;
			if (! rfocusMorph.test (tipo de burbuja + tipo)) {
				cur = cur.parentNode;
			}
			for (; cur; cur = cur.parentNode) {
				eventPath.push (cur);
				tmp = cur;
			}

			// Solo agregue la ventana si tenemos que documentar (p. Ej., No obj o DOM separado)
			if (tmp === (elem.ownerDocument || documento)) {
				eventPath.push (tmp.defaultView || tmp.parentWindow || ventana);
			}
		}

		// Controladores de fuego en la ruta del evento
		i = 0;
		while ((cur = eventPath [i ++]) &&! event.isPropagationStopped ()) {

			event.type = i> 1?
				bubbleType:
				special.bindType || tipo;

			// manejador jQuery
			handle = (jQuery._data (cur, "eventos") || {}) [event.type] && jQuery._data (cur, "handle");
			if (handle) {
				handle.apply (cur, data);
			}

			// Controlador nativo
			handle = ontype && cur [ontype];
			if (manejar && handle.apply && jQuery.acceptData (cur)) {
				event.result = handle.apply (cur, data);
				if (event.result === false) {
					event.preventDefault ();
				}
			}
		}
		event.type = tipo;

		// Si nadie impidió la acción predeterminada, hazlo ahora
		if (! onlyHandlers &&! event.isDefaultPrevented ()) {

			if ((! special._default || special._default.apply (eventPath.pop (), data) === false) &&
				jQuery.acceptData (elem)) {

				// Llamar a un método DOM nativo en el destino con el mismo nombre que el evento.
				// No se puede usar una comprobación .isFunction () aquí porque IE6 / 7 falla esa prueba.
				// No haga acciones predeterminadas en la ventana, ahí es donde se encuentran las variables globales (# 6170)
				if (ontype && elem [tipo] &&! jQuery.isWindow (elem)) {

					// No vuelva a activar un evento onFOO cuando llamemos a su método FOO ()
					tmp = elem [ontype];

					if (tmp) {
						elem [ontype] = null;
					}

					// Prevenir el reinicio del mismo evento, ya que ya lo borramos
					jQuery.event.triggered = tipo;
					tratar {
						elem [tipo] ();
					} catch (e) {
						// IE <9 muere en foco / desenfoque a elemento oculto (# 1486, # 12518)
						// solo reproducible en WinXP IE8 nativo, no IE9 en modo IE8
					}
					jQuery.event.triggered = undefined;

					if (tmp) {
						elem [ontype] = tmp;
					}
				}
			}
		}

		return event.result;
	},

	dispatch: function (event) {

		// Hacer un jQuery.Event escribible desde el objeto de evento nativo
		event = jQuery.event.fix (evento);

		var i, ret, handleObj, emparejado, j,
			handlerQueue = [],
			args = slice.call (argumentos),
			manejadores = (jQuery._data (this, "events") || {}) [event.type] || [],
			special = jQuery.event.special [event.type] || {};

		// Utiliza el jQuery.Event corregido en lugar del evento nativo (solo lectura)
		args [0] = evento;
		event.delegateTarget = this;

		// Llamar al anzuelo preDispatch para el tipo mapeado, y dejarlo fianza si lo desea
		if (special.preDispatch && special.preDispatch.call (this, event) === false) {
			regreso;
		}

		// Determinar manejadores
		handlerQueue = jQuery.event.handlers.call (this, event, handlers);

		// Ejecutar delegados primero; es posible que quieran detener la propagación debajo de nosotros
		i = 0;
		while ((matched = handlerQueue [i ++]) &&! event.isPropagationStopped ()) {
			event.currentTarget = matched.elem;

			j = 0;
			while ((handleObj = matched.handlers [j ++]) &&! event.isImmediatePropagationStopped ()) {

				// Evento desencadenado debe 1) no tener espacio de nombres, o
				// 2) tienen espacio (s) de nombre un subconjunto o igual a aquellos en el evento enlazado (ambos no pueden tener espacio de nombre).
				if (! event.namespace_re || event.namespace_re.test (handleObj.namespace)) {

					event.handleObj = handleObj;
					event.data = handleObj.data;

					ret = ((jQuery.event.special [handleObj.origType] || {}). handle || handleObj.handler)
							.apply (coincide con.elem, args);

					if (ret! == undefined) {
						if ((event.result = ret) === falso) {
							event.preventDefault ();
							event.stopPropagation ();
						}
					}
				}
			}
		}

		// Llamar al anzuelo postDispatch para el tipo mapeado
		if (special.postDispatch) {
			special.postDispatch.call (this, event);
		}

		return event.result;
	},

	handlers: function (event, handlers) {
		var sel, handleObj, coincidencias, yo,
			handlerQueue = [],
			delegateCount = handlers.delegateCount,
			cur = event.target;

		// Encuentra manejadores de delegados
		// Black-hole SVG <use> árboles de instancias (# 13180)
		// Evita el burbujeo sin clic izquierdo en Firefox (# 3861)
		if (delegateCount && cur.nodeType && (! event.button || event.type! == "click")) {

			/ * jshint eqeqeq: falso * /
			for (; cur! = this; cur = cur.parentNode || this) {
				/ * jshint eqeqeq: true * /

				// No marque elementos que no sean elementos (# 13208)
				// No procesa clics en elementos desactivados (# 6911, # 8165, # 11382, # 11764)
				if (cur.nodeType === 1 && (cur.disabled! == verdadero || event.type! == "clic")) {
					matches = [];
					para (i = 0; i <delegateCount; i ++) {
						handleObj = manejadores [i];

						// No entre en conflicto con las propiedades Object.prototype (# 13203)
						sel = handleObj.selector + "";

						if (coincide con [sel] === undefined) {
							coincide con [sel] = handleObj.needsContext?
								jQuery (sel, this) .index (cur)> = 0:
								jQuery.find (sel, this, null, [cur]) .length;
						}
						if (coincide con [sel]) {
							matches.push (handleObj);
						}
					}
					if (matches.length) {
						handlerQueue.push ({elem: cur, handlers: matches});
					}
				}
			}
		}

		// Agrega los manejadores restantes (directamente enlazados)
		if (delegateCount <handlers.length) {
			handlerQueue.push ({elem: this, handlers: handlers.slice (delegateCount)});
		}

		return handlerQueue;
	},

	fix: function (event) {
		if (evento [jQuery.expando]) {
			evento de regreso;
		}

		// Crea una copia editable del objeto de evento y normaliza algunas propiedades
		var i, prop, copy,
			type = event.type,
			originalEvent = evento,
			fixHook = this.fixHooks [tipo];

		if (! fixHook) {
			this.fixHooks [type] = fixHook =
				rmouseEvent.test (tipo)? this.mouseHooks:
				rkeyEvent.test (tipo)? this.keyHooks:
				{};
		}
		copy = fixHook.props? this.props.concat (fixHook.props): this.props;

		event = new jQuery.Event (originalEvent);

		i = copy.length;
		mientras yo-- ) {
			prop = copy [i];
			evento [prop] = originalEvent [prop];
		}

		// Soporte: IE <9
		// Fix target property (# 1925)
		if (! event.target) {
			event.target = originalEvent.srcElement || documento;
		}

		// Soporte: Chrome 23+, Safari?
		// Target no debe ser un nodo de texto (# 504, # 13143)
		if (event.target.nodeType === 3) {
			event.target = event.target.parentNode;
		}

		// Soporte: IE <9
		// Para eventos de mouse / key, metaKey == false si no está definido (# 3368, # 11328)
		event.metaKey = !! event.metaKey;

		devuelve fixHook.filter? fixHook.filter (evento, evento original): evento;
	},

	// Incluye algunos accesorios para eventos compartidos por KeyEvent y MouseEvent
	accesorios: "altKey bubbles cancelable ctrlKey currentTarget eventPhase metaKey relatedTarget shiftKey target timeStamp ver qué" .split (""),

	fixHooks: {},

	keyHooks: {
		accesorios: "char charCódigo de clave de código" .split (""),
		filtro: función (evento, original) {

			// Agregar cuál para eventos clave
			if (event.which == null) {
				event.which = original.charCode! = null? original.charCode: original.keyCode;
			}

			evento de regreso;
		}
	},

	mouseHooks: {
		accesorios: "botones de botones clientX clientY fromElement offsetX offsetY pageX pageY screenX screenY toElement" .split (""),
		filtro: función (evento, original) {
			var body, eventDoc, doc,
				button = original.button,
				fromElement = original.fromElement;

			// Calcula páginaX / Y si falta y clienteX / Y disponible
			if (event.pageX == null && original.clientX! = null) {
				eventDoc = event.target.ownerDocument || documento;
				doc = eventDoc.documentElement;
				body = eventDoc.body;

				event.pageX = original.clientX + (doc && doc.scrollLeft || body && body.scrollLeft || 0) - (doc && doc.clientLeft || body && body.clientLeft || 0);
				event.pageY = original.clientY + (doc && doc.scrollTop || body && body.scrollTop || 0) - (doc && doc.clientTop || body && body.clientTop || 0);
			}

			// Añadir relatedTarget, si es necesario
			if (! event.relatedTarget && fromElement) {
				event.relatedTarget = fromElement === event.target? original.toElement: fromElement;
			}

			// Agregar cuál para hacer clic: 1 === izquierda; 2 === medio; 3 === derecha
			// Nota: el botón no está normalizado, entonces no lo use
			if (! event.which && button! == undefined) {
				event.which = (button & 1? 1: (button & 2? 3: (button & 4? 2: 0)));
			}

			evento de regreso;
		}
	},

	especial: {
		carga: {
			// Previene los eventos disparados de image.load de bubbling a window.load
			noBubble: cierto
		},
		atención: {
			// Si es posible, active el evento nativo para que la secuencia de desenfoque / enfoque sea correcta
			trigger: function () {
				if (this! == safeActiveElement () && this.focus) {
					tratar {
						this.focus ();
						falso retorno;
					} catch (e) {
						// Soporte: IE <9
						// Si cometemos un error al enfocar al elemento oculto (# 1486, # 12518),
						// deja que .trigger () ejecute los controladores
					}
				}
			},
			delegateType: "focusin"
		},
		desenfoque: {
			trigger: function () {
				if (this === safeActiveElement () && this.blur) {
					this.blur ();
					falso retorno;
				}
			},
			delegateType: "focusout"
		},
		click: {
			// Para la casilla de verificación, activa el evento nativo de modo que el estado verificado sea el correcto
			trigger: function () {
				if (jQuery.nodeName (this, "input") && this.type === "checkbox" && this.click) {
					this.click ();
					falso retorno;
				}
			},

			// Para coherencia entre navegadores, no dispare nativos .click () en enlaces
			_default: function (event) {
				return jQuery.nodeName (event.target, "a");
			}
		},

		beforeunload: {
			postDispatch: function (event) {

				// Soporte: Firefox 20+
				// Firefox no alerta si el campo returnValue no está establecido.
				if (event.result! == undefined && event.originalEvent) {
					event.originalEvent.returnValue = event.result;
				}
			}
		}
	},

	simular: función (tipo, elemento, evento, burbuja) {
		// Aprovechar un evento de donantes para simular uno diferente.
		// Fake originalEvent para evitar el stopPropagation del donante, pero si el
		// el evento simulado evita el valor predeterminado, luego hacemos lo mismo con el donante.
		var e = jQuery.extend (
			nuevo jQuery.Event (),
			evento,
			{
				tipo: tipo,
				isSimulated: cierto,
				originalEvent: {}
			}
		);
		if (burbuja) {
			jQuery.event.trigger (e, null, elem);
		} else {
			jQuery.event.dispatch.call (elem, e);
		}
		if (e.isDefaultPrevented ()) {
			event.preventDefault ();
		}
	}
};

jQuery.removeEvent = document.removeEventListener?
	función (elem, tipo, identificador) {
		if (elem.removeEventListener) {
			elem.removeEventListener (type, handle, false);
		}
	}:
	función (elem, tipo, identificador) {
		var name = "on" + tipo;

		if (elem.detachEvent) {

			// # 8545, # 7054, evitando fugas de memoria para eventos personalizados en IE6-8
			// detachEvent necesitaba propiedad en el elemento, por nombre de ese evento, para exponerlo correctamente a GC
			if (typeof elem [nombre] === strundefined) {
				elem [nombre] = nulo;
			}

			elem.detachEvent (name, handle);
		}
	};

jQuery.Event = function (src, props) {
	// Permitir instanciación sin la palabra clave 'nueva'
	if (! (esta instancia de jQuery.Event)) {
		return new jQuery.Event (src, props);
	}

	// Objeto de evento
	if (src && src.type) {
		this.originalEvent = src;
		this.type = src.type;

		// Los eventos que burbujean en el documento pueden haberse marcado como impedidos
		// por un controlador más abajo en el árbol; reflejar el valor correcto
		this.isDefaultPrevented = src.defaultPrevented ||
				src.defaultPredented === undefined &&
				// Soporte: IE <9, Android <4.0
				src.returnValue === ¿falso?
			returnTrue:
			falso retorno;

	// Tipo de evento
	} else {
		this.type = src;
	}

	// Poner propiedades provistas explícitamente en el objeto del evento
	if (props) {
		jQuery.extend (esto, accesorios);
	}

	// Crea una marca de tiempo si el evento entrante no tiene uno
	this.timeStamp = src && src.timeStamp || jQuery.now ();

	// Marcarlo como arreglado
	esto [jQuery.expando] = verdadero;
};

// jQuery.Event se basa en eventos DOM3 según lo especificado por el enlace de lenguaje ECMAScript
// http://www.w3.org/TR/2003/WD-DOM-Level-3-Events-20030331/ecma-script-binding.html
jQuery.Event.prototype = {
	isDefaultPrevented: returnFalse,
	isPropagationStopped: returnFalse,
	isImmediatePropagationStopped: returnFalse,

	preventDefault: function () {
		var e = this.originalEvent;

		this.isDefaultPrevented = returnTrue;
		if (! e) {
			regreso;
		}

		// Si preventDefault existe, ejecútelo en el evento original
		if (e.preventDefault) {
			e.preventDefault ();

		// Soporte: IE
		// De lo contrario, establezca la propiedad returnValue del evento original en falso
		} else {
			e.returnValue = false;
		}
	},
	stopPropagation: function () {
		var e = this.originalEvent;

		this.isPropagationStopped = returnTrue;
		if (! e) {
			regreso;
		}
		// Si stopPropagation existe, ejecútelo en el evento original
		if (e.stopPropagation) {
			e.stopPropagation ();
		}

		// Soporte: IE
		// Establece la propiedad cancelBubble del evento original en true
		e.cancelBubble = verdadero;
	},
	stopImmediatePropagation: function () {
		var e = this.originalEvent;

		this.isImmediatePropagationStopped = returnTrue;

		if (e && e.stopImmediatePropagation) {
			e.stopImmediatePropagation ();
		}

		this.stopPropagation ();
	}
};

// Crear mouseenter / leave events usando mouseover / out y event-time checks
jQuery.each ({
	mouseenter: "mouseover",
	mouseleave: "mouseout",
	pointerenter: "puntero",
	pointerleave: "puntero"
}, función (orig, corregir) {
	jQuery.event.special [orig] = {
		delegateType: corregir,
		bindType: corregir,

		manejar: función (evento) {
			var ret,
				objetivo = esto,
				related = event.relatedTarget,
				handleObj = event.handleObj;

			// Para mousenter / leave llama al controlador si está relacionado fuera del objetivo.
			// NB: No relatedTarget si el mouse se fue / ingresó a la ventana del navegador
			if (! related || (related! == target &&! jQuery.contains (target, related))) {
				event.type = handleObj.origType;
				ret = handleObj.handler.apply (esto, argumentos);
				event.type = fix;
			}
			return ret;
		}
	};
});

// IE enviar delegación
if (! support.submitBubbles) {

	jQuery.event.special.submit = {
		setup: function () {
			// Solo necesito esto para los eventos de envío de formularios delegados
			if (jQuery.nodeName (this, "form")) {
				falso retorno;
			}

			// Lazy-add a handler cuando un formulario descendiente puede ser enviado
			jQuery.event.add (esto, "click._submit keypress._submit", función (e) {
				// La comprobación del nombre del nodo evita un bloqueo relacionado con VML en IE (# 9807)
				var elem = e.target,
					form = jQuery.nodeName (elem, "input") || jQuery.nodeName (elem, "botón")? elem.form: undefined;
				if (form &&! jQuery._data (form, "submitBubbles")) {
					jQuery.event.add (form, "submit._submit", function (event) {
						event._submit_bubble = true;
					});
					jQuery._data (form, "submitBubbles", true);
				}
			});
			// return undefined ya que no necesitamos un detector de eventos
		},

		postDispatch: function (event) {
			// Si el usuario envió el formulario, inserte el evento en el árbol
			if (event._submit_bubble) {
				eliminar event._submit_bubble;
				if (this.parentNode &&! event.isTrigger) {
					jQuery.event.simulate ("submit", this.parentNode, event, true);
				}
			}
		},

		desmontaje: función () {
			// Solo necesito esto para los eventos de envío de formularios delegados
			if (jQuery.nodeName (this, "form")) {
				falso retorno;
			}

			// Eliminar manejadores delegados; cleanData eventualmente recoge los controladores de envío adjuntos anteriormente
			jQuery.event.remove (this, "._submit");
		}
	};
}

// IE cambia delegación y checkbox / radio fix
if (! support.changeBubbles) {

	jQuery.event.special.change = {

		setup: function () {

			if (rformElems.test (this.nodeName)) {
				// IE no dispara cambio en un cheque / radio hasta desenfoque; activarlo al hacer clic
				// después de un cambio de propiedad. Coma el cambio de desenfoque en special.change.handle.
				// Aún se activa el cambio una segunda vez para comprobar / radio después del desenfoque.
				if (this.type === "checkbox" || this.type === "radio") {
					jQuery.event.add (this, "propertychange._change", función (evento) {
						if (event.originalEvent.propertyName === "checked") {
							this._just_changed = verdadero;
						}
					});
					jQuery.event.add (esto, "click._change", función (evento) {
						if (this._just_changed &&! event.isTrigger) {
							this._just_changed = false;
						}
						// Permitir eventos de cambio simulados y activados (# 11500)
						jQuery.event.simulate ("change", this, event, true);
					});
				}
				falso retorno;
			}
			// evento delegado; lazy-add un controlador de cambio en las entradas descendientes
			jQuery.event.add (this, "beforeactivate._change", función (e) {
				var elem = e.target;

				if (rformElems.test (elem.nodeName) &&! jQuery._data (elem, "changeBubbles")) {
					jQuery.event.add (elem, "change._change", function (event) {
						if (this.parentNode &&! event.isSimulated &&! event.isTrigger) {
							jQuery.event.simulate ("change", this.parentNode, event, true);
						}
					});
					jQuery._data (elem, "changeBubbles", verdadero);
				}
			});
		},

		manejar: función (evento) {
			var elem = event.target;

			// Tragar eventos nativos de cambio de casilla de verificación / radio, ya los hemos activado anteriormente
			if (this! == elem || event.isSimulated || event.isTrigger || (elem.type! == "radio" && elem.type! == "casilla de verificación")) {
				return event.handleObj.handler.apply (esto, argumentos);
			}
		},

		desmontaje: función () {
			jQuery.event.remove (esto, "._change");

			return! rformElems.test (this.nodeName);
		}
	};
}

// Crea un foco "burbujeante" y desenfoca eventos
if (! support.focusinBubbles) {
	jQuery.each ({focus: "focusin", desenfoque: "focusout"}, función (orig, corregir) {

		// Adjunte un único controlador de captura en el documento mientras alguien quiere focusin / focusout
		var handler = function (event) {
				jQuery.event.simulate (fix, event.target, jQuery.event.fix (event), true);
			};

		jQuery.event.special [fix] = {
			setup: function () {
				var doc = this.ownerDocument || esta,
					attach = jQuery._data (doc, fix);

				if (! attachments) {
					doc.addEventListener (orig, handler, true);
				}
				jQuery._data (doc, fix, (attach || 0) + 1);
			},
			desmontaje: función () {
				var doc = this.ownerDocument || esta,
					attach = jQuery._data (doc, fix) - 1;

				if (! attachments) {
					doc.removeEventListener (orig, handler, true);
					jQuery._removeData (doc, fix);
				} else {
					jQuery._data (doc, fix, attach);
				}
			}
		};
	});
}

jQuery.fn.extend ({

	on: function (tipos, selector, datos, fn, / * INTERNAL * / one) {
		tipo var, origFn;

		// Los tipos pueden ser un mapa de tipos / manejadores
		if (tipo de tipos === "objeto") {
			// (tipos-Objeto, selector, datos)
			if (typeof selector! == "cadena") {
				// (tipos-Objeto, datos)
				datos = datos || selector;
				selector = indefinido;
			}
			para (escriba los tipos) {
				this.on (tipo, selector, datos, tipos [tipo], uno);
			}
			devuelve esto;
		}

		if (data == null && fn == null) {
			// (tipos, fn)
			fn = selector;
			data = selector = undefined;
		} else if (fn == null) {
			if (typeof selector === "cadena") {
				// (tipos, selector, fn)
				fn = datos;
				datos = indefinido;
			} else {
				// (tipos, datos, fn)
				fn = datos;
				data = selector;
				selector = indefinido;
			}
		}
		if (fn === falso) {
			fn = returnFalse;
		} else if (! fn) {
			devuelve esto;
		}

		if (one === 1) {
			origFn = fn;
			fn = función (evento) {
				// Puede usar un conjunto vacío, ya que el evento contiene la información
				jQuery (). off (evento);
				return origFn.apply (esto, argumentos);
			};
			// Usa el mismo guid para que la persona que llama pueda eliminar usando origFn
			fn.guid = origFn.guid || (origFn.guid = jQuery.guid ++);
		}
		return this.each (function () {
			jQuery.event.add (this, types, fn, data, selector);
		});
	},
	uno: función (tipos, selector, datos, fn) {
		return this.on (tipos, selector, datos, fn, 1);
	},
	off: función (tipos, selector, fn) {
		var handleObj, tipo;
		if (types && types.preventDefault && types.handleObj) {
			// (evento) enviado jQuery.Event
			handleObj = types.handleObj;
			jQuery (types.delegateTarget) .off (
				handleObj.namespace? handleObj.origType + "." + handleObj.namespace: handleObj.origType,
				handleObj.selector,
				handleObj.handler
			);
			devuelve esto;
		}
		if (tipo de tipos === "objeto") {
			// (tipos-objeto [, selector])
			para (escriba los tipos) {
				this.off (tipo, selector, tipos [tipo]);
			}
			devuelve esto;
		}
		if (selector === falso || typeof selector === "función") {
			// (tipos [, fn])
			fn = selector;
			selector = indefinido;
		}
		if (fn === falso) {
			fn = returnFalse;
		}
		return this.each (function () {
			jQuery.event.remove (this, types, fn, selector);
		});
	},

	trigger: function (type, data) {
		return this.each (function () {
			jQuery.event.trigger (tipo, datos, esto);
		});
	},
	triggerHandler: function (type, data) {
		var elem = this [0];
		if (elem) {
			return jQuery.event.trigger (tipo, datos, elem, verdadero);
		}
	}
});


function createSafeFragment (documento) {
	var list = nodeNames.split ("|"),
		safeFrag = document.createDocumentFragment ();

	if (safeFrag.createElement) {
		while (list.length) {
			safeFrag.createElement (
				list.pop ()
			);
		}
	}
	devolver safeFrag;
}

var nodeNames = "abbr | article | aside | audio | bdi | canvas | data | datalist | detalles | figcaption | figure | footer |" +
		"header | hgroup | mark | meter | nav | salida | progreso | sección | resumen | tiempo | video",
	rinlinejQuery = / jQuery \ d + = "(?: null | \ d +)" / g,
	rnoshimcache = new RegExp ("<(?:" + nodeNames + ") [\\ s />]", "i"),
	rleadingWhitespace = / ^ \ s + /,
	rxhtmlTag = / <(?! area | br | col | embed | hr | img | entrada | enlace | meta | param) (([\ w:] +) [^>] *) \ /> / gi,
	rtagName = / <([\ w:] +) /,
	rtbody = / <tbody / i,
	rhtml = / <| & #? \ w +; /,
	rnoInnerhtml = / <(?: script | style | link) / i,
	// checked = "checked" o checked
	rchecked = /checked\s*(?:[^=]|=\s*.checked.)/i,
	rscriptType = / ^ $ | \ / (?: java | ecma) script / i,
	rscriptTypeMasked = /^true\/(.*)/,
	rcleanScript = / ^ \ s * <! (?: \ [CDATA \ [| -) | (?: \] \] | -)> \ s * $ / g,

	// Tenemos que cerrar estas etiquetas para admitir XHTML (# 13200)
	wrapMap = {
		opción: [1, "<seleccionar múltiple = 'múltiple'>", "</ seleccionar>"],
		leyenda: [1, "<fieldset>", "</ fieldset>"],
		área: [1, "<mapa>", "</ mapa>"],
		param: [1, "<objeto>", "</ objeto>"],
		thead: [1, "<table>", "</ table>"],
		tr: [2, "<table> <tbody>", "</ tbody> </ table>"],
		col: [2, "<table> <tbody> </ tbody> <colgroup>", "</ colgroup> </ table>"],
		td: [3, "<table> <tbody> <tr>", "</ tr> </ tbody> </ table>"],

		// IE6-8 no puede serializar enlace, script, estilo o cualquier etiqueta html5 (NoScope),
		// a menos que esté envuelto en un div con caracteres ininterrumpidos delante de él.
		_default: support.htmlSerialize? [0, "", ""]: [1, "X <div>", "</ div>"]
	},
	safeFragment = createSafeFragment (documento),
	fragmentDiv = safeFragment.appendChild (document.createElement ("div"));

wrapMap.optgroup = wrapMap.option;
wrapMap.tbody = wrapMap.tfoot = wrapMap.colgroup = wrapMap.caption = wrapMap.thead;
wrapMap.th = wrapMap.td;

function getAll (context, tag) {
	var elems, elem,
		i = 0,
		found = typeof context.getElementsByTagName! == strundefined? context.getElementsByTagName (tag || "*"):
			typeof context.querySelectorAll! == strundefined? context.querySelectorAll (tag || "*"):
			indefinido;

	si se encuentra ) {
		for (found = [], elems = context.childNodes || context; (elem = elems [i])! = null; i ++) {
			if (! tag || jQuery.nodeName (elem, tag)) {
				found.push (elem);
			} else {
				jQuery.merge (found, getAll (elem, tag));
			}
		}
	}

	etiqueta de devolución === indefinido || tag && jQuery.nodeName (context, tag)?
		jQuery.merge ([context], encontrado):
		encontró;
}

// Utilizado en buildFragment, corrige la propiedad defaultChecked
función fixDefaultChecked (elem) {
	if (rcheckableType.test (elem.type)) {
		elem.defaultChecked = elem.checked;
	}
}

// Soporte: IE <8
// Manipular tablas requiere un tbody
manipulación de funcionesTarget (elem, contenido) {
	return jQuery.nodeName (elem, "tabla") &&
		jQuery.nodeName (content.nodeType! == 11? content: content.firstChild, "tr")?

		elem.getElementsByTagName ("tbody") [0] ||
			elem.appendChild (elem.ownerDocument.createElement ("tbody")):
		elem;
}

// Reemplazar / restaurar el atributo de tipo de elementos de script para la manipulación segura de DOM
función disableScript (elem) {
	elem.type = (jQuery.find.attr (elem, "type")!! == null) + "/" + elem.type;
	regreso elem;
}
function restoreScript (elem) {
	var match = rscriptTypeMasked.exec (elem.type);
	if (coincidencia) {
		elem.type = match [1];
	} else {
		elem.removeAttribute ("tipo");
	}
	regreso elem;
}

// Marcar los scripts como que ya han sido evaluados
function setGlobalEval (elems, refElements) {
	var elem,
		i = 0;
	para (; (elem = elems [i])! = null; i ++) {
		jQuery._data (elem, "globalEval",! refElements || jQuery._data (refElements [i], "globalEval"));
	}
}

function cloneCopyEvent (src, dest) {

	if (dest.nodeType! == 1 ||! jQuery.hasData (src)) {
		regreso;
	}

	tipo var, i, l,
		oldData = jQuery._data (src),
		curData = jQuery._data (dest, oldData),
		events = oldData.events;

	if (eventos) {
		eliminar curData.handle;
		curData.events = {};

		para (escriba eventos) {
			para (i = 0, l = eventos [tipo] .length; i <l; i ++) {
				jQuery.event.add (dest, tipo, eventos [tipo] [i]);
			}
		}
	}

	// convierte el objeto de datos públicos clonado en una copia del original
	if (curData.data) {
		curData.data = jQuery.extend ({}, curData.data);
	}
}

function fixCloneNodeIssues (src, dest) {
	var nodeName, e, datos;

	// No necesitamos hacer nada por elementos que no sean Elementos
	if (dest.nodeType! == 1) {
		regreso;
	}

	nodeName = dest.nodeName.toLowerCase ();

	// IE6-8 copia los eventos vinculados a través de attachEvent al usar cloneNode.
	if (! support.noCloneEvent && dest [jQuery.expando]) {
		data = jQuery._data (dest);

		para (e en data.events) {
			jQuery.removeEvent (dest, e, data.handle);
		}

		// Los datos del evento se referencian en lugar de copiarse si también se copia el expando
		dest.removeAttribute (jQuery.expando);
	}

	// IE blanquea los contenidos al clonar scripts e intenta evaluar el texto recién establecido
	if (nodeName === "script" && dest.text! == src.text) {
		disableScript (dest) .text = src.text;
		restoreScript (dest);

	// IE6-10 clona incorrectamente a los niños de los elementos del objeto usando classid.
	// IE10 arroja NoModificationAllowedError si parent es nulo, # 12132.
	} else if (nodeName === "object") {
		if (dest.parentNode) {
			dest.outerHTML = src.outerHTML;
		}

		// Esta ruta parece inevitable para IE9. Al clonar un objeto
		// elemento en IE9, la estrategia outerHTML anterior no es suficiente.
		// Si el src tiene innerHTML y el destino no,
		// copia el src.innerHTML en dest.innerHTML. # 10324
		if (support.html5Clone && (src.innerHTML &&! jQuery.trim (dest.innerHTML))) {
			dest.innerHTML = src.innerHTML;
		}

	} else if (nodeName === "input" && rcheckableType.test (src.type)) {
		// IE6-8 no puede mantener el estado comprobado de una casilla clonada
		// o botón de radio. Peor aún, IE6-7 no puede dar el elemento clonado
		// una apariencia marcada si el valor predeterminado comprobado no está configurado

		dest.defaultChecked = dest.checked = src.checked;

		// IE6-7 se confunde y termina configurando el valor de un clonado
		// casilla de verificación / botón de opción a una cadena vacía en lugar de "on"
		if (dest.value! == src.value) {
			dest.value = src.value;
		}

	// IE6-8 no puede devolver la opción seleccionada al valor predeterminado seleccionado
	// estado cuando las opciones de clonación
	} else if (nodeName === "option") {
		dest.defaultSelected = dest.selected = src.defaultSelected;

	// IE6-8 no establece el Valor predeterminado en el valor correcto cuando
	// clonación de otros tipos de campos de entrada
	} else if (nodeName === "input" || nodeName === "textarea") {
		dest.defaultValue = src.defaultValue;
	}
}

jQuery.extend ({
	clone: ​​function (elem, dataAndEvents, deepDataAndEvents) {
		var destElements, node, clone, i, srcElements,
			inPage = jQuery.contains (elem.ownerDocument, elem);

		if (support.html5Clone || jQuery.isXMLDoc (elem) ||! rnoshimcache.test ("<" + elem.nodeName + ">")) {
			clone = elem.cloneNode (true);

		// IE <= 8 no clona correctamente nodos de elementos desconocidos y desconocidos
		} else {
			fragmentDiv.innerHTML = elem.outerHTML;
			fragmentDiv.removeChild (clone = fragmentDiv.firstChild);
		}

		if ((! support.noCloneEvent ||! support.noCloneChecked) &&
				(elem.nodeType === 1 || elem.nodeType === 11) &&! jQuery.isXMLDoc (elem)) {

			// Evitamos Sizzle aquí por motivos de rendimiento: http://jsperf.com/getall-vs-sizzle/2
			destElements = getAll (clon);
			srcElements = getAll (elem);

			// Soluciona todos los problemas de clonación de IE
			for (i = 0; (node ​​= srcElements [i])! = null; ++ i) {
				// Asegúrese de que el nodo de destino no sea nulo; Correcciones # 9587
				if (destElements [i]) {
					fixCloneNodeIssues (node, destElements [i]);
				}
			}
		}

		// Copia los eventos desde el original al clon
		if (dataAndEvents) {
			if (deepDataAndEvents) {
				srcElements = srcElements || getAll (elem);
				destElements = destElements || getAll (clonar);

				for (i = 0; (node ​​= srcElements [i])! = null; i ++) {
					cloneCopyEvent (node, destElements [i]);
				}
			} else {
				cloneCopyEvent (elem, clone);
			}
		}

		// Conservar el historial de evaluación de guiones
		destElements = getAll (clone, "script");
		if (destElements.length> 0) {
			setGlobalEval (destElements,! inPage && getAll (elem, "script"));
		}

		destElements = srcElements = node = null;

		// Devuelve el conjunto clonado
		clon de retorno;
	},

	buildFragment: function (elems, context, scripts, selection) {
		var j, elem, contiene,
			tmp, tag, tbody, wrap,
			l = elems.length,

			// Asegurar un fragmento seguro
			safe = createSafeFragment (contexto),

			nodes = [],
			i = 0;

		para (; i <l; i ++) {
			elem = elems [i];

			if (elem || elem === 0) {

				// Añadir nodos directamente
				if (jQuery.type (elem) === "object") {
					jQuery.merge (nodos, elem.nodeType? [elem]: elem);

				// Convierte no-html en un nodo de texto
				} else if (! rhtml.test (elem)) {
					nodes.push (context.createTextNode (elem));

				// Convierte html en nodos DOM
				} else {
					tmp = tmp || safe.appendChild (context.createElement ("div"));

					// Deserializar una representación estándar
					tag = (rtagName.exec (elem) || ["", ""]) [1] .toLowerCase ();
					wrap = wrapMap [tag] || wrapMap._default;

					tmp.innerHTML = wrap [1] + elem.replace (rxhtmlTag, "<$ 1> </ $ 2>") + wrap [2];

					// Desciende a través de envoltorios al contenido correcto
					j = wrap [0];
					while (j--) {
						tmp = tmp.lastChild;
					}

					// Agrega manualmente el espacio en blanco inicial eliminado por IE
					if (! support.leadingWhitespace && rleadingWhitespace.test (elem)) {
						nodes.push (context.createTextNode (rleadingWhitespace.exec (elem) [0]));
					}

					// Eliminar IE <tbody> autoinsertado de IE de fragmentos de tabla
					if (! support.tbody) {

						// String era una <mesa>, * puede * tener espuria <tbody>
						elem = tag === "table" &&! rtbody.test (elem)?
							tmp.firstChild:

							// String era un bare <thead> o <tfoot>
							wrap [1] === "<table>" &&! rtbody.test (elem)?
								tmp:
								0;

						j = elem && elem.childNodes.length;
						while (j--) {
							if (jQuery.nodeName ((tbody = elem.childNodes [j]), "tbody") &&! tbody.childNodes.length) {
								elem.removeChild (tbody);
							}
						}
					}

					jQuery.merge (nodos, tmp.childNodes);

					// Solución # 12392 para WebKit e IE> 9
					tmp.textContent = "";

					// Fix # 12392 para oldIE
					while (tmp.firstChild) {
						tmp.removeChild (tmp.firstChild);
					}

					// Recuerde el contenedor de nivel superior para una limpieza adecuada
					tmp = safe.lastChild;
				}
			}
		}

		// Fix # 11356: Borrar elementos del fragmento
		if (tmp) {
			safe.removeChild (tmp);
		}

		// Reset defaultChecked para cualquier radio y casilla de verificación
		// a punto de ser agregado al DOM en IE 6/7 (# 8060)
		if (! support.appendChecked) {
			jQuery.grep (getAll (nodos, "entrada"), fixDefaultChecked);
		}

		i = 0;
		while ((elem = nodes [i ++])) {

			// # 4087 - Si los elementos de origen y destino son iguales, y esto es
			// ese elemento, no hagas nada
			if (selección && jQuery.inArray (elem, selection)! == -1) {
				continuar;
			}

			contains = jQuery.contains (elem.ownerDocument, elem);

			// Agregar a fragmento
			tmp = getAll (safe.appendChild (elem), "script");

			// Conservar el historial de evaluación de guiones
			if (contiene) {
				setGlobalEval (tmp);
			}

			// Capturar ejecutables
			if (scripts) {
				j = 0;
				while ((elem = tmp [j ++])) {
					if (rscriptType.test (elem.type || "")) {
						scripts.push (elem);
					}
				}
			}
		}

		tmp = null;

		regresar seguro;
	},

	cleanData: function (elems, / * internal * / acceptData) {
		var elem, type, id, data,
			i = 0,
			internalKey = jQuery.expando,
			cache = jQuery.cache,
			deleteExpando = support.deleteExpando,
			especial = jQuery.event.special;

		para (; (elem = elems [i])! = null; i ++) {
			if (acceptData || jQuery.acceptData (elem)) {

				id = elem [tecla interna];
				data = id && cache [id];

				if (datos) {
					if (data.events) {
						for (escriba en data.events) {
							if (especial [tipo]) {
								jQuery.event.remove (elem, type);

							// Este es un atajo para evitar la sobrecarga de jQuery.event.remove
							} else {
								jQuery.removeEvent (elem, type, data.handle);
							}
						}
					}

					// Eliminar el caché solo si no lo había eliminado jQuery.event.remove
					if (caché [id]) {

						eliminar caché [id];

						// IE no nos permite eliminar propiedades de expando de nodos,
						// ni tiene una función removeAttribute en los nodos del documento;
						// debemos manejar todos estos casos
						if (deleteExpando) {
							eliminar elem [tecla interna];

						} else if (typeof elem.removeAttribute! == strundefined) {
							elem.removeAttribute (internalKey);

						} else {
							elem [internalKey] = null;
						}

						deletedIds.push (id);
					}
				}
			}
		}
	}
});

jQuery.fn.extend ({
	texto: función (valor) {
		acceso de retorno (esto, función (valor) {
			valor de retorno === indefinido?
				jQuery.text (esto):
				this.empty (). append ((this [0] && this [0] .ownerDocument || document) .createTextNode (value));
		}, null, value, arguments.length);
	},

	append: function () {
		return this.domManip (argumentos, función (elem) {
			if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
				var target = manipulationTarget (this, elem);
				target.appendChild (elem);
			}
		});
	},

	prepend: function () {
		return this.domManip (argumentos, función (elem) {
			if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
				var target = manipulationTarget (this, elem);
				target.insertBefore (elem, target.firstChild);
			}
		});
	},

	before: function () {
		return this.domManip (argumentos, función (elem) {
			if (this.parentNode) {
				this.parentNode.insertBefore (elem, this);
			}
		});
	},

	after: function () {
		return this.domManip (argumentos, función (elem) {
			if (this.parentNode) {
				this.parentNode.insertBefore (elem, this.nextSibling);
			}
		});
	},

	remove: function (selector, keepData / * uso interno solamente * /) {
		var elem,
			elems = selector? jQuery.filter (selector, esto): esto,
			i = 0;

		para (; (elem = elems [i])! = null; i ++) {

			if (! keepData && elem.nodeType === 1) {
				jQuery.cleanData (getAll (elem));
			}

			if (elem.parentNode) {
				if (keepData && jQuery.contains (elem.ownerDocument, elem)) {
					setGlobalEval (getAll (elem, "script"));
				}
				elem.parentNode.removeChild (elem);
			}
		}

		devuelve esto;
	},

	empty: function () {
		var elem,
			i = 0;

		para (; (elem = this [i])! = null; i ++) {
			// Eliminar nodos de elementos y evitar pérdidas de memoria
			if (elem.nodeType === 1) {
				jQuery.cleanData (getAll (elem, false));
			}

			// Eliminar cualquier nodo restante
			while (elem.firstChild) {
				elem.removeChild (elem.firstChild);
			}

			// Si es una selección, asegúrese de que se muestre vacía (# 12336)
			// Soporte: IE <9
			if (elem.options && jQuery.nodeName (elem, "select")) {
				elem.options.length = 0;
			}
		}

		devuelve esto;
	},

	clone: ​​function (dataAndEvents, deepDataAndEvents) {
		dataAndEvents = dataAndEvents == null? falso: dataAndEvents;
		deepDataAndEvents = deepDataAndEvents == null? dataAndEvents: deepDataAndEvents;

		return this.map (function () {
			devuelve jQuery.clone (this, dataAndEvents, deepDataAndEvents);
		});
	},

	html: function (value) {
		acceso de retorno (esto, función (valor) {
			var elem = this [0] || {},
				i = 0,
				l = this.length;

			if (value === undefined) {
				return elem.nodeType === 1?
					elem.innerHTML.replace (rinlinejQuery, ""):
					indefinido;
			}

			// Mira si podemos tomar un atajo y solo usar innerHTML
			if (tipo de valor === "cadena" &&! rnoInnerhtml.test (valor) &&
				(support.htmlSerialize ||! rnoshimcache.test (valor)) &&
				(support.leadingWhitespace ||! rleadingWhitespace.test (value)) &&
				! wrapMap [(rtagName.exec (value) || ["", ""]) [1] .toLowerCase ()]) {

				value = value.replace (rxhtmlTag, "<$ 1> </ $ 2>");

				tratar {
					para (; i <l; i ++) {
						// Eliminar nodos de elementos y evitar pérdidas de memoria
						elem = esto [i] || {};
						if (elem.nodeType === 1) {
							jQuery.cleanData (getAll (elem, false));
							elem.innerHTML = valor;
						}
					}

					elem = 0;

				// Si usar innerHTML arroja una excepción, use el método alternativo
				} catch (e) {}
			}

			if (elem) {
				this.empty (). append (valor);
			}
		}, null, value, arguments.length);
	},

	replaceWith: function () {
		var arg = argumentos [0];

		// Haga los cambios, reemplazando cada elemento de contexto con el nuevo contenido
		this.domManip (argumentos, función (elem) {
			arg = this.parentNode;

			jQuery.cleanData (getAll (this));

			if (arg) {
				arg.replaceChild (elem, esto);
			}
		});

		// Fuerza la eliminación si no hay contenido nuevo (por ejemplo, desde argumentos vacíos)
		return arg && (arg.length || arg.nodeType)? esto: this.remove ();
	},

	detach: function (selector) {
		devuelve this.remove (selector, verdadero);
	},

	domManip: function (args, callback) {

		// Aplanar cualquier matriz anidada
		args = concat.apply ([], args);

		var primero, nodo, hasScripts,
			scripts, doc, fragmento,
			i = 0,
			l = this.length,
			set = this,
			iNoClone = l - 1,
			value = args [0],
			isFunction = jQuery.isFunction (valor);

		// No podemos clonar fragmentos de Node que contengan marcados, en WebKit
		if (isFunction ||
				(l> 1 && typeof value === "string" &&
					! support.checkClone && rchecked.test (value))) {
			return this.each (función (índice) {
				var self = set.eq (índice);
				if (isFunction) {
					args [0] = value.call (this, index, self.html ());
				}
				self.domManip (args, callback);
			});
		}

		si (l) {
			fragment = jQuery.buildFragment (args, this [0] .ownerDocument, false, this);
			first = fragment.firstChild;

			if (fragment.childNodes.length === 1) {
				fragmento = primero;
			}

			si (primero) {
				scripts = jQuery.map (getAll (fragmento, "script"), disableScript);
				hasScripts = scripts.length;

				// Usa el fragmento original para el último elemento en vez del primero porque puede terminar
				// vaciarse incorrectamente en ciertas situaciones (# 8070).
				para (; i <l; i ++) {
					nodo = fragmento;

					if (i! == iNoClone) {
						node = jQuery.clone (node, true, true);

						// Mantener referencias a scripts clonados para una restauración posterior
						if (hasScripts) {
							jQuery.merge (scripts, getAll (nodo, "script"));
						}
					}

					callback.call (este [i], nodo, i);
				}

				if (hasScripts) {
					doc = scripts [scripts.length - 1] .ownerDocument;

					// Rehabilitar scripts
					jQuery.map (scripts, restoreScript);

					// Evaluar secuencias de comandos ejecutables en la primera inserción de documentos
					para (i = 0; i <hasScripts; i ++) {
						nodo = scripts [i];
						if (rscriptType.test (node.type || "") &&
							! jQuery._data (node, "globalEval") && jQuery.contains (doc, node)) {

							if (node.src) {
								// Dependencia AJAX opcional, pero no ejecutará scripts si no está presente
								if (jQuery._evalUrl) {
									jQuery._evalUrl (node.src);
								}
							} else {
								jQuery.globalEval ((node.text || node.textContent || node.innerHTML || "") .replace (rcleanScript, ""));
							}
						}
					}
				}

				// Solución n. ° 11809: evite la pérdida de memoria
				fragmento = primer = nulo;
			}
		}

		devuelve esto;
	}
});

jQuery.each ({
	appendTo: "append",
	prependTo: "prepend",
	insertAntes: "antes",
	insertAfter: "after",
	replaceAll: "replaceWith"
}, función (nombre, original) {
	jQuery.fn [name] = function (selector) {
		var elems,
			i = 0,
			ret = [],
			insert = jQuery (selector),
			last = insert.length - 1;

		para (; i <= último; i ++) {
			elems = i === ¿por último? esto: this.clone (verdadero);
			jQuery (inserte [i]) [original] (elems);

			// Los navegadores modernos pueden aplicar colecciones jQuery como matrices, pero oldIE necesita un .get ()
			push.apply (ret, elems.get ());
		}

		devuelve this.pushStack (ret);
	};
});


var iframe,
	elemdisplay = {};

/ **
 * Recuperar la visualización real de un elemento
 * @ param {String} nombre nodeName del elemento
 * @param {Object} doc Objeto de documento
 * /
// Llamado solo desde defaultDisplay
function actualDisplay (name, doc) {
	estilo var,
		elem = jQuery (doc.createElement (name)) .appendTo (doc.body),

		// getDefaultComputedStyle solo se puede usar confiablemente en el elemento adjunto
		display = window.getDefaultComputedStyle && (style = window.getDefaultComputedStyle (elem [0]))?

			// El uso de este método es una solución temporal (más parecida a la optimización) hasta que aparezca algo mejor,
			// ya que se eliminó de la especificación y solo se admite en FF
			style.display: jQuery.css (elem [0], "mostrar");

	// No tenemos ningún dato almacenado en el elemento,
	// entonces usa el método "detach" como forma rápida de deshacerse del elemento
	elem.detach ();

	pantalla de retorno;
}

/ **
 * Intente determinar el valor de visualización predeterminado de un elemento
 * @param {String} nodeName
 * /
function defaultDisplay (nodeName) {
	var doc = document,
		display = elemdisplay [nodeName];

	if (! display) {
		display = realDisplay (nodeName, doc);

		// Si la manera simple falla, lee desde dentro de un iframe
		if (display === "none" ||! display) {

			// Usa el iframe ya creado si es posible
			iframe = (iframe || jQuery ("<iframe frameborder = '0' width = '0' height = '0' />")). appendTo (doc.documentElement);

			// Siempre escriba un nuevo esqueleto HTML para que Webkit y Firefox no se ahoguen con la reutilización
			doc = (iframe [0] .contentWindow || iframe [0] .contentDocument) .document;

			// Soporte: IE
			doc.write ();
			doc.close ();

			display = realDisplay (nodeName, doc);
			iframe.detach ();
		}

		// Almacenar la pantalla predeterminada correcta
		elemdisplay [nodeName] = display;
	}

	pantalla de retorno;
}


(función () {
	var shrinkWrapBlocksVal;

	support.shrinkWrapBlocks = function () {
		if (shrinkWrapBlocksVal! = null) {
			return shrinkWrapBlocksVal;
		}

		// Se cambiará más tarde si es necesario.
		shrinkWrapBlocksVal = falso;

		// Minificado: var b, c, d
		var div, cuerpo, contenedor;

		body = document.getElementsByTagName ("cuerpo") [0];
		if (! body ||! body.style) {
			// Prueba iniciada demasiado pronto o en un entorno no compatible, salga.
			regreso;
		}

		// Preparar
		div = document.createElement ("div");
		container = document.createElement ("div");
		container.style.cssText = "position: absolute; border: 0; width: 0; height: 0; top: 0; left: -9999px";
		body.appendChild (contenedor) .appendChild (div);

		// Soporte: IE6
		// Compruebe si los elementos con el diseño encogen y envuelven a sus hijos
		if (typeof div.style.zoom! == strundefined) {
			// Restablecer CSS: tamaño de la caja; monitor; margen; frontera
			div.style.cssText =
				// Soporte: Firefox <29, Android 2.3
				// Tamaño del cuadro del prefijo del vendedor
				"-webkit-box-sizing: content-box; -moz-box-sizing: content-box;" +
				"tamaño de caja: cuadro de contenido; pantalla: bloque; margen: 0; borde: 0;" +
				"relleno: 1px; ancho: 1px; zoom: 1";
			div.appendChild (document.createElement ("div")) .style.width = "5px";
			shrinkWrapBlocksVal = div.offsetWidth! == 3;
		}

		body.removeChild (contenedor);

		return shrinkWrapBlocksVal;
	};

}) ();
var rmargin = (/ ^ margen /);

var rnumnonpx = new RegExp ("^ (" + pnum + ") (? px) [az%] + $", "i");



var getStyles, curCSS,
	rposition = / ^ (arriba | derecha | abajo | izquierda) $ /;

if (window.getComputedStyle) {
	getStyles = function (elem) {
		return elem.ownerDocument.defaultView.getComputedStyle (elem, null);
	};

	curCSS = function (elem, name, computado) {
		var ancho, minWidth, maxWidth, ret,
			style = elem.style;

		calculado = calculado || getStyles (elem);

		// getPropertyValue solo es necesario para .css ('filtro') en IE9, ver # 12537
		ret = calculado? computed.getPropertyValue (nombre) || [nombre] calculado: indefinido;

		if (calculado) {

			if (ret === "" &&! jQuery.contains (elem.ownerDocument, elem)) {
				ret = jQuery.style (elem, nombre);
			}

			// Un homenaje al "increíble hack de Dean Edwards"
			// Chrome <17 y Safari 5.0 usa "valor calculado" en lugar de "valor usado" para margen-derecho
			// Safari 5.1.7 (al menos) devuelve el porcentaje de un conjunto de valores más grande, pero el ancho parece ser confiablemente píxeles
			// esto va en contra de la especificación del borrador de CSSOM: http://dev.w3.org/csswg/cssom/#resolved-values
			if (rnumnonpx.test (ret) && rmargin.test (name)) {

				// Recuerde los valores originales
				width = style.width;
				minWidth = style.minWidth;
				maxWidth = style.maxWidth;

				// Poner los nuevos valores para obtener un valor calculado
				style.minWidth = style.maxWidth = style.width = ret;
				ret = computed.width;

				// Revertir los valores modificados
				style.width = ancho;
				style.minWidth = minWidth;
				style.maxWidth = maxWidth;
			}
		}

		// Soporte: IE
		// IE devuelve el valor de zIndex como un entero.
		return ret === undefined?
			ret:
			ret + "";
	};
} else if (document.documentElement.currentStyle) {
	getStyles = function (elem) {
		return elem.currentStyle;
	};

	curCSS = function (elem, name, computado) {
		var left, rs, rsLeft, ret,
			style = elem.style;

		calculado = calculado || getStyles (elem);
		ret = calculado? [nombre] calculado: indefinido;

		// Evita configurar ret como una cadena vacía aquí
		// entonces no usamos automáticamente
		if (ret == null && style && style [nombre]) {
			ret = estilo [nombre];
		}

		// Del impresionante truco de Dean Edwards
		// http://erik.eae.net/archives/2007/07/27/18.54.15/#comment-102291

		// Si no estamos tratando con un número de píxel regular
		// pero un número que tiene un final extraño, necesitamos convertirlo a píxeles
		// pero no coloca los atributos css, ya que estos son proporcionales al elemento padre en su lugar
		// y no podemos medir el padre en su lugar porque podría desencadenar un problema de "amontonar muñecas"
		if (rnumnonpx.test (ret) &&! rposition.test (name)) {

			// Recuerde los valores originales
			left = style.left;
			rs = elem.runtimeStyle;
			rsLeft = rs && rs.left;

			// Poner los nuevos valores para obtener un valor calculado
			if (rsLeft) {
				rs.left = elem.currentStyle.left;
			}
			style.left = name === "fontSize"? "1em": ret;
			ret = style.pixelLeft + "px";

			// Revertir los valores modificados
			style.left = left;
			if (rsLeft) {
				rs.left = rsLeft;
			}
		}

		// Soporte: IE
		// IE devuelve el valor de zIndex como un entero.
		return ret === undefined?
			ret:
			ret + "" || "auto";
	};
}




función addGetHookIf (conditionFn, hookFn) {
	// Definir el gancho, comprobaremos en la primera ejecución si es realmente necesario.
	regreso {
		get: function () {
			var condition = conditionFn ();

			if (condición == null) {
				// La prueba no estaba lista en este punto; atornillar el gancho esta vez
				// pero vuelve a verificar cuando sea necesario la próxima vez.
				regreso;
			}

			if (condición) {
				// No es necesario enganchar (o no es posible usarlo debido a la falta de dependencia),
				// eliminarlo.
				// Como no hay otros ganchos para marginRight, elimine el objeto completo.
				eliminar this.get;
				regreso;
			}

			// Gancho necesitado; redefinirlo para que la prueba de soporte no se ejecute de nuevo.

			return (this.get = hookFn) .apply (esto, argumentos);
		}
	};
}


(función () {
	// Minificado: var b, c, d, e, f, g, h, i
	var div, style, a, pixelPositionVal, boxSizingReliableVal,
		confiableHiddenOffsetsVal, confiableMarginRightVal;

	// Preparar
	div = document.createElement ("div");
	div.innerHTML = "<link /> <table> </ table> <a href='/a'> a </a> <input type = 'checkbox' />";
	a = div.getElementsByTagName ("a") [0];
	style = a && a.style;

	// Finaliza temprano en entornos limitados (sin navegador)
	if (! style) {
		regreso;
	}

	style.cssText = "float: left; opacity: .5";

	// Soporte: IE <9
	// Asegúrate de que exista la opacidad del elemento (a diferencia del filtro)
	support.opacity = style.opacity === "0.5";

	// Verificar la existencia de flotación de estilo
	// (IE usa styleFloat en lugar de cssFloat)
	support.cssFloat = !! style.cssFloat;

	div.style.backgroundClip = "contenido-box";
	div.cloneNode (true) .style.backgroundClip = "";
	support.clearCloneStyle = div.style.backgroundClip === "content-box";

	// Soporte: Firefox <29, Android 2.3
	// Tamaño del cuadro del prefijo del vendedor
	support.boxSizing = style.boxSizing === "" || style.MozBoxSizing === "" ||
		style.WebkitBoxSizing === "";

	jQuery.extend (soporte, {
		reliableHiddenOffsets: function () {
			if (reliableHiddenOffsetsVal == null) {
				computeStyleTests ();
			}
			return reliableHiddenOffsetsVal;
		},

		boxSizingReliable: function () {
			if (boxSizingReliableVal == null) {
				computeStyleTests ();
			}
			return boxSizingReliableVal;
		},

		pixelPosition: function () {
			if (pixelPositionVal == null) {
				computeStyleTests ();
			}
			return pixelPositionVal;
		},

		// Soporte: Android 2.3
		reliableMarginRight: function () {
			if (reliableMarginRightVal == null) {
				computeStyleTests ();
			}
			devolver confiableMarginRightVal;
		}
	});

	function computeStyleTests () {
		// Minificado: var b, c, d, j
		var div, cuerpo, contenedor, contenido;

		body = document.getElementsByTagName ("cuerpo") [0];
		if (! body ||! body.style) {
			// Prueba iniciada demasiado pronto o en un entorno no compatible, salga.
			regreso;
		}

		// Preparar
		div = document.createElement ("div");
		container = document.createElement ("div");
		container.style.cssText = "position: absolute; border: 0; width: 0; height: 0; top: 0; left: -9999px";
		body.appendChild (contenedor) .appendChild (div);

		div.style.cssText =
			// Soporte: Firefox <29, Android 2.3
			// Tamaño del cuadro del prefijo del vendedor
			"-webkit-box-sizing: border-box; -moz-box-sizing: border-box;" +
			"tamaño de la caja: border-box; display: block; margin-top: 1%; top: 1%;" +
			"borde: 1px; relleno: 1px; ancho: 4px; posición: absoluta";

		// Soporte: IE <9
		// Supongamos valores razonables en ausencia de getComputedStyle
		pixelPositionVal = boxSizingReliableVal = false;
		reliableMarginRightVal = verdadero;

		// Comprueba getComputedStyle para que este código no se ejecute en IE <9.
		if (window.getComputedStyle) {
			pixelPositionVal = (window.getComputedStyle (div, null) || {}) .top! == "1%";
			boxSizingReliableVal =
				(window.getComputedStyle (div, null) || {width: "4px"}) .width === "4px";

			// Soporte: Android 2.3
			// Div con ancho explícito y sin margen-derecho incorrectamente
			// se calcula el margen-derecho según el ancho del contenedor (# 3333)
			// WebKit Bug 13343 - getComputedStyle devuelve el valor incorrecto para margen-derecho
			contents = div.appendChild (document.createElement ("div"));

			// Restablecer CSS: tamaño de la caja; monitor; margen; frontera; relleno
			contents.style.cssText = div.style.cssText =
				// Soporte: Firefox <29, Android 2.3
				// Tamaño del cuadro del prefijo del vendedor
				"-webkit-box-sizing: content-box; -moz-box-sizing: content-box;" +
				"tamaño de caja: cuadro de contenido; pantalla: bloque; margen: 0; borde: 0; relleno: 0";
			contents.style.marginRight = contents.style.width = "0";
			div.style.width = "1px";

			confiableMarginRightVal =
				! parseFloat ((window.getComputedStyle (contents, null) || {}) .marginRight);
		}

		// Soporte: IE8
		// Compruebe si las celdas de la tabla aún tienen offsetWidth / Height cuando se configuran
		// para mostrar: ninguno y todavía hay otras celdas de tabla visibles en una
		// fila de la tabla; si es así, offsetWidth / Height no son confiables para usar cuando
		// determinar si un elemento se ha ocultado directamente usando
		// display: none (aún es seguro usar compensaciones si un elemento padre es
		// oculto; ponerse gafas de seguridad y ver el error # 4512 para más información).
		div.innerHTML = "<table> <tr> <td> </ td> <td> t </ td> </ tr> </ table>";
		contents = div.getElementsByTagName ("td");
		contenido [0] .style.cssText = "margen: 0; borde: 0; relleno: 0; pantalla: ninguno";
		reliableHiddenOffsetsVal = contents [0] .offsetHeight === 0;
		if (reliableHiddenOffsetsVal) {
			contenidos [0] .style.display = "";
			contenidos [1] .style.display = "ninguno";
			reliableHiddenOffsetsVal = contents [0] .offsetHeight === 0;
		}

		body.removeChild (contenedor);
	}

}) ();


// Un método para intercambiar rápidamente propiedades de entrada / salida de CSS para obtener cálculos correctos.
jQuery.swap = function (elem, options, callback, args) {
	var ret, nombre,
		viejo = {};

	// Recordar los valores anteriores e insertar los nuevos
	para (nombre en opciones) {
		old [name] = elem.style [nombre];
		elem.style [nombre] = opciones [nombre];
	}

	ret = callback.apply (elem, args || []);

	// Revertir los valores anteriores
	para (nombre en opciones) {
		elem.style [nombre] = viejo [nombre];
	}

	return ret;
};


var
		ralpha = / alpha \ ([^)] * \) / i,
	ropacity = / opacity \ s * = \ s * ([^)] *) /,

	// swappable si display es none o comienza con table excepto "table", "table-cell", o "table-caption"
	// ver aquí para ver los valores: https://developer.mozilla.org/en-US/docs/CSS/display
	rdisplayswap = /^(none|table(?!-c[ea]).+)/,
	rnumsplit = new RegExp ("^ (" + pnum + ") (. *) $", "i"),
	rrelNum = new RegExp ("^ ([+ -]) = (" + pnum + ")", "i"),

	cssShow = {position: "absolute", visibility: "hidden", display: "block"},
	cssNormalTransform = {
		letterSpacing: "0",
		fontWeight: "400"
	},

	cssPrefixes = ["Webkit", "O", "Moz", "ms"];


// devolver una propiedad css asignada a una propiedad con prefijo de un proveedor potencial
function vendorPropName (estilo, nombre) {

	// acceso directo para nombres que no tienen el prefijo del proveedor
	if (nombre en estilo) {
		nombre de regreso;
	}

	// verifica los nombres prefijados del proveedor
	var capName = name.charAt (0) .toUpperCase () + name.slice (1),
		origName = nombre,
		i = cssPrefixes.length;

	mientras yo-- ) {
		name = cssPrefixes [i] + capName;
		if (nombre en estilo) {
			nombre de regreso;
		}
	}

	devolver origName;
}

función showHide (elementos, mostrar) {
	pantalla var, elem, oculta,
		valores = [],
		índice = 0,
		longitud = elementos.length;

	for (; index <length; index ++) {
		elem = elementos [índice];
		if (! elem.style) {
			continuar;
		}

		values ​​[index] = jQuery._data (elem, "olddisplay");
		display = elem.style.display;
		if (mostrar) {
			// Restablece la visualización en línea de este elemento para saber si es
			// está oculto por reglas en cascada o no
			if (! values ​​[index] && display === "none") {
				elem.style.display = "";
			}

			// Establecer elementos que se han reemplazado con display: ninguno
			// en una hoja de estilo para cualquiera que sea el estilo de navegador predeterminado
			// para tal elemento
			if (elem.style.display === "" && isHidden (elem)) {
				values ​​[index] = jQuery._data (elem, "olddisplay", defaultDisplay (elem.nodeName));
			}
		} else {
			hidden = isHidden (elem);

			if (muestra && display! == "none" ||! hidden) {
				jQuery._data (elem, "olddisplay", hidden? display: jQuery.css (elem, "display"));
			}
		}
	}

	// Establecer la visualización de la mayoría de los elementos en un segundo ciclo
	// para evitar el reflujo constante
	for (index = 0; index <length; index ++) {
		elem = elementos [índice];
		if (! elem.style) {
			continuar;
		}
		if (! show || elem.style.display === "none" || elem.style.display === "") {
			elem.style.display = show? valores [índice] || "" : "ninguna";
		}
	}

	elementos de retorno;
}

function setPositiveNumber (elem, value, resta) {
	var matches = rnumsplit.exec (value);
	devolver partidos?
		// Protección contra "restar" indefinido, por ejemplo, cuando se usa como en cssHooks
		Math.max (0, coincide con [1] - (resta || 0)) + (coincide con [2] || "px"):
		valor;
}

function augmentWidthOrHeight (elem, name, ext ra, isBorderBox, styles) {
	var i = extra === (isBorderBox? "border": "content")?
		// Si ya tenemos la medida correcta, evite el aumento
		4:
		// De lo contrario, inicializar para propiedades horizontales o verticales
		nombre === "ancho"? 1: 0,

		val = 0;

	para (; i <4; i + = 2) {
		// ambos modelos de caja excluyen el margen, así que agrégalo si lo queremos
		if (extra === "margen") {
			val + = jQuery.css (elem, extra + cssExpand [i], true, estilos);
		}

		if (isBorderBox) {
			// border-box incluye relleno, entonces quítelo si queremos contenido
			if (extra === "contenido") {
				val - = jQuery.css (elem, "relleno" + cssExpand [i], verdadero, estilos);
			}

			// en este punto, extra no es borde ni margen, por lo tanto, eliminar el borde
			if (extra! == "margin") {
				val - = jQuery.css (elem, "borde" + cssExpand [i] + "Ancho", verdadero, estilos);
			}
		} else {
			// en este punto, extra no es contenido, así que agregue relleno
			val + = jQuery.css (elem, "relleno" + cssExpand [i], verdadero, estilos);

			// en este punto, extra no es contenido ni relleno, así que agrega borde
			if (extra! == "relleno") {
				val + = jQuery.css (elem, "borde" + cssExpand [i] + "Ancho", verdadero, estilos);
			}
		}
	}

	return val;
}

function getWidthOrHeight (elem, name, extra) {

	// Comience con la propiedad de desplazamiento, que es equivalente al valor del cuadro de borde
	var valueIsBorderBox = true,
		val = nombre === "ancho"? elem.offsetWidth: elem.offsetHeight,
		styles = getStyles (elem),
		isBorderBox = support.boxSizing && jQuery.css (elem, "boxSizing", falso, estilos) === "border-box";

	// algunos elementos que no son html devuelven undefined para offsetWidth, por lo tanto, verifique null / undefined
	// svg - https://bugzilla.mozilla.org/show_bug.cgi?id=649285
	// MathML - https://bugzilla.mozilla.org/show_bug.cgi?id=491668
	if (val <= 0 || val == null) {
		// Volvemos al css calculado y luego no procesado si es necesario
		val = curCSS (elem, nombre, estilos);
		if (val <0 || val == null) {
			val = elem.style [nombre];
		}

		// Unidad calculada no es pixeles. Parar aquí y regresar.
		if (rnumnonpx.test (val)) {
			return val;
		}

		// necesitamos el cheque de estilo en caso de que un navegador devuelva valores no confiables
		// para getComputedStyle regresa silenciosamente al elem.style confiable
		valueIsBorderBox = isBorderBox && (support.boxSizingReliable () || val === elem.style [name]);

		// Normalizar "", automático, y prepararse para extra
		val = parseFloat (val) || 0;
	}

	// usa el modelo de tamaño de caja activo para agregar / sustraer estilos irrelevantes
	regresar (val +
		augmentWidthOrHeight (
			elem,
			nombre,
			extra || (isBorderBox? "borde": "contenido"),
			valueIsBorderBox,
			estilos
		)
	) + "px";
}

jQuery.extend ({
	// Añadir en ganchos de propiedades de estilo para anular el valor predeterminado
	// comportamiento de obtener y establecer una propiedad de estilo
	cssHooks: {
		opacidad: {
			get: function (elem, computed) {
				if (calculado) {
					// Siempre deberíamos obtener un número de la opacidad
					var ret = curCSS (elem, "opacidad");
					return ret === ""? "1": ret;
				}
			}
		}
	},

	// No agregue automáticamente "px" a estas propiedades posiblemente sin unidades
	cssNumber: {
		"columnCount": verdadero,
		"fillOpacity": cierto,
		"flexGrow": cierto,
		"flexShrink": cierto,
		"fontWeight": cierto,
		"lineHeight": cierto,
		"opacidad": cierto,
		"orden": cierto,
		"huérfanos": cierto,
		"viudas": cierto,
		"zIndex": verdadero,
		"zoom": verdadero
	},

	// Agregue las propiedades cuyos nombres desea corregir antes
	// configurando u obteniendo el valor
	cssProps: {
		// normalizar la propiedad float css
		"flotar": ¿support.cssFloat? "cssFloat": "styleFloat"
	},

	// Obtener y establecer la propiedad de estilo en un nodo DOM
	estilo: función (elem, nombre, valor, extra) {
		// No establece estilos en los nodos de texto y comentario
		if (! elem || elem.nodeType === 3 || elem.nodeType === 8 ||! elem.style) {
			regreso;
		}

		// Asegúrate de que estamos trabajando con el nombre correcto
		var ret, type, hooks,
			origName = jQuery.camelCase (nombre),
			style = elem.style;

		name = jQuery.cssProps [origName] || (jQuery.cssProps [origName] = vendorPropName (style, origName));

		// obtiene gancho para la versión prefijada
		// seguido de la versión no prefijada
		hooks = jQuery.cssHooks [nombre] || jQuery.cssHooks [origName];

		// Verificamos si estamos configurando un valor
		if (value! == undefined) {
			tipo = tipo de valor;

			// convierte cadenas de números relativos (+ = o - =) en números relativos. # 7345
			if (tipo === "cadena" && (ret = rrelNum.exec (valor))) {
				value = (ret [1] + 1) * ret [2] + parseFloat (jQuery.css (elem, nombre));
				// Soluciona el bug # 9237
				tipo = "número";
			}

			// Asegúrese de que los valores nulos y NaN no estén establecidos. Ver: # 7116
			if (value == null || value! == value) {
				regreso;
			}

			// Si se pasó un número, agrega 'px' a (excepto para ciertas propiedades de CSS)
			if (tipo === "número" &&! jQuery.cssNumber [origName]) {
				valor + = "px";
			}

			// Correcciones # 8908, se puede hacer de manera más correcta especificando setters en cssHooks,
			// pero significaría definir ocho (para cada propiedad problemática) funciones idénticas
			if (! support.clearCloneStyle && value === "" && name.indexOf ("background") === 0) {
				estilo [nombre] = "heredar";
			}

			// Si se proporcionó un gancho, use ese valor; de lo contrario, simplemente configure el valor especificado
			if (! hooks ||! ("set" en ganchos) || (value = hooks.set (elem, value, extra))! == undefined) {

				// Soporte: IE
				// Tragar errores de valores de CSS 'no válidos' (# 5509)
				tratar {
					estilo [nombre] = valor;
				} catch (e) {}
			}

		} else {
			// Si se proporcionó un gancho, obtenga el valor no calculado de allí
			if (hooks && "get" en los ganchos && (ret = hooks.get (elem, false, extra))! == undefined) {
				return ret;
			}

			// De lo contrario, solo obtiene el valor del objeto de estilo
			devolver el estilo [nombre];
		}
	},

	css: function (elem, name, extra, styles) {
		var num, val, hooks,
			origName = jQuery.camelCase (nombre);

		// Asegúrate de que estamos trabajando con el nombre correcto
		name = jQuery.cssProps [origName] || (jQuery.cssProps [origName] = vendorPropName (elem.style, origName));

		// obtiene gancho para la versión prefijada
		// seguido de la versión no prefijada
		hooks = jQuery.cssHooks [nombre] || jQuery.cssHooks [origName];

		// Si se proporcionó un gancho, obtenga el valor calculado desde allí
		if (hooks && "get" en ganchos) {
			val = hooks.get (elem, true, extra);
		}

		// De lo contrario, si existe una forma de obtener el valor calculado, usa eso
		if (val === undefined) {
			val = curCSS (elem, nombre, estilos);
		}

		// convierte "normal" en valor calculado
		if (val === "normal" && name en cssNormalTransform) {
			val = cssNormalTransform [nombre];
		}

		// Devuelve, convirtiendo al número si se forzó o se proporcionó un calificador y val parece numérico
		if (extra === "" || extra) {
			num = parseFloat (val);
			devolver extra === verdadero || jQuery.isNumeric (num)? num || 0: val;
		}
		return val;
	}
});

jQuery.each (["alto", "ancho"], función (i, nombre) {
	jQuery.cssHooks [name] = {
		get: function (elem, computed, extra) {
			if (calculado) {
				// ciertos elementos pueden tener información de dimensión si los mostramos invisiblemente
				// sin embargo, debe tener un estilo de visualización actual que se beneficiaría de esto
				devuelve rdisplayswap.test (jQuery.css (elem, "display")) && elem.offsetWidth === 0?
					jQuery.swap (elem, cssShow, function () {
						return getWidthOrHeight (elem, nombre, extra);
					}):
					getWidthOrHeight (elem, name, extra);
			}
		},

		set: function (elem, value, extra) {
			var styles = extra && getStyles (elem);
			return setPositiveNumber (elem, value, extra?
				augmentWidthOrHeight (
					elem,
					nombre,
					extra,
					support.boxSizing && jQuery.css (elem, "boxSizing", falso, estilos) === "border-box",
					estilos
				): 0
			);
		}
	};
});

if (! support.opacity) {
	jQuery.cssHooks.opacity = {
		get: function (elem, computed) {
			// IE usa filtros para la opacidad
			return ropacity.test ((&& elem.currentStyle? elem.currentStyle.filter: elem.style.filter) || "")?
				(0.01 * parseFloat (RegExp. $ 1)) + "":
				calculado? "1": "";
		},

		set: function (elem, value) {
			var style = elem.style,
				currentStyle = elem.currentStyle,
				opacity = jQuery.isNumeric (valor)? "alfa (opacidad =" + valor * 100 + ")": "",
				filter = currentStyle && currentStyle.filter || style.filter || "";

			// IE tiene problemas con la opacidad si no tiene diseño
			// Force it estableciendo el nivel de zoom
			style.zoom = 1;

			// si se establece la opacidad en 1 y no existen otros filtros, intente eliminar el atributo de filtro # 6652
			// si el valor === "", luego elimina la opacidad en línea # 12685
			if ((valor> = 1 || valor === "") &&
					jQuery.trim (filter.replace (ralpha, "")) === "" &&
					style.removeAttribute) {

				// Configurando style.filter a null, "" y "" aún sale "filter:" en cssText
				// si "filter:" está presente, clearType está deshabilitado, queremos evitar esto
				// style.removeAttribute es solo IE, pero aparentemente esta es la ruta del código ...
				style.removeAttribute ("filtro");

				// si no se aplica un estilo de filtro en una regla de CSS o no se establece la opacidad en línea, hemos terminado
				if (value === "" || currentStyle &&! currentStyle.filter) {
					regreso;
				}
			}

			// de lo contrario, establezca nuevos valores de filtro
			style.filter = ralpha.test (filtro)?
				filter.replace (ralpha, opacity):
				filtro + "" + opacidad;
		}
	};
}

jQuery.cssHooks.marginRight = addGetHookIf (support.reliableMarginRight,
	función (elem, calculado) {
		if (calculado) {
			// WebKit Bug 13343 - getComputedStyle devuelve el valor incorrecto para margen-derecho
			// Se soluciona al establecer temporalmente la visualización del elemento en el bloque en línea
			return jQuery.swap (elem, {"display": "inline-block"},
				curCSS, [elem, "marginRight"]);
		}
	}
);

// Estos ganchos son usados ​​por animate para expandir propiedades
jQuery.each ({
	margen: "",
	relleno: "",
	ancho del borde"
}, función (prefijo, sufijo) {
	jQuery.cssHooks [prefix + sufijo] = {
		expandir: función (valor) {
			var i = 0,
				expandido = {},

				// asume un solo número si no es una cadena
				partes = typeof value === "string"? value.split (""): [valor];

			para (; i <4; i ++) {
				expandido [prefijo + cssExpand [i] + sufijo] =
					partes [i] || partes [i - 2] || partes [0];
			}

			regreso expandido;
		}
	};

	if (! rmargin.test (prefijo)) {
		jQuery.cssHooks [prefijo + sufijo] .set = setPositiveNumber;
	}
});

jQuery.fn.extend ({
	css: función (nombre, valor) {
		acceso de retorno (esto, función (elem, nombre, valor) {
			var estilos, len,
				map = {},
				i = 0;

			if (jQuery.isArray (name)) {
				styles = getStyles (elem);
				len = name.length;

				para (; i <len; i ++) {
					map [nombre [i]] = jQuery.css (elem, nombre [i], falso, estilos);
				}

				mapa de retorno;
			}

			valor de retorno! == indefinido?
				jQuery.style (elem, nombre, valor):
				jQuery.css (elem, nombre);
		}, nombre, valor, arguments.length> 1);
	},
	show: function () {
		return showHide (esto, verdadero);
	},
	hide: function () {
		return showHide (esto);
	},
	alternar: función (estado) {
		if (tipo de estado === "booleano") {
			estado de retorno? this.show (): this.hide ();
		}

		return this.each (function () {
			if (isHidden (this)) {
				jQuery (esto) .show ();
			} else {
				jQuery (this) .hide ();
			}
		});
	}
});


función Tween (elem, options, prop, end, easing) {
	return new Tween.prototype.init (elem, options, prop, end, easing);
}
jQuery.Tween = Tween;

Tween.prototype = {
	constructor: Tween,
	init: function (elem, options, prop, end, easing, unit) {
		this.elem = elem;
		this.prop = prop;
		this.easing = relajando || "oscilación";
		this.options = opciones;
		this.start = this.now = this.cur ();
		this.end = fin;
		this.unit = unidad || (jQuery.cssNumber [prop]? "": "px");
	},
	cur: function () {
		var hooks = Tween.propHooks [this.prop];

		return hooks && hooks.get?
			hooks.get (esto):
			Tween.propHooks._default.get (esto);
	},
	ejecutar: función (porcentaje) {
		var eased,
			hooks = Tween.propHooks [this.prop];

		if (this.options.duration) {
			this.pos = eased = jQuery.easing [this.easing] (
				percent, this.options.duration * percent, 0, 1, this.options.duration
			);
		} else {
			this.pos = eased = percent;
		}
		this.now = (this.end - this.start) * eased + this.start;

		if (this.options.step) {
			this.options.step.call (this.elem, this.now, this);
		}

		if (hooks && hooks.set) {
			hooks.set (this);
		} else {
			Tween.propHooks._default.set (this);
		}
		devuelve esto;
	}
};

Tween.prototype.init.prototype = Tween.prototype;

Tween.propHooks = {
	_defecto: {
		get: function (interpolación) {
			var resultado;

			if (tween.elem [tween.prop]! = null &&
				(! tween.elem.style || tween.elem.style [tween.prop] == null)) {
				return tween.elem [tween.prop];
			}

			// pasando una cadena vacía como un 3er parámetro a .css automáticamente
			// intento un parseFloat y un repliegue a una cadena si el parse falla
			// entonces, los valores simples como "10px" se analizan en Float.
			// los valores complejos como "girar (1rad)" se devuelven como están.
			resultado = jQuery.css (tween.elem, tween.prop, "");
			// Las cadenas vacías, nulas, indefinidas y "automáticas" se convierten a 0.
			retorno! resultado || resultado === "auto"? 0: resultado;
		},
		set: function (tween) {
			// use step hook para la compatibilidad de la espalda - use cssHook si está allí - use .style si es
			// disponible y use propiedades simples donde esté disponible
			if (jQuery.fx.step [tween.prop]) {
				jQuery.fx.step [tween.prop] (interpolación);
			} else if (tween.elem.style && (tween.elem.style [jQuery.cssProps [tween.prop]]! = null || jQuery.cssHooks [tween.prop])) {
				jQuery.style (tween.elem, tween.prop, tween.now + tween.unit);
			} else {
				tween.elem [tween.prop] = tween.now;
			}
		}
	}
};

// Soporte: IE <= 9
// Enfoque basado en pánico para configurar cosas en nodos desconectados

Tween.propHooks.scrollTop = Tween.propHooks.scrollLeft = {
	set: function (tween) {
		if (tween.elem.nodeType && tween.elem.parentNode) {
			tween.elem [tween.prop] = tween.now;
		}
	}
};

jQuery.easing = {
	lineal: función (p) {
		return p;
	},
	oscilación: función (p) {
		return 0.5 - Math.cos (p * Math.PI) / 2;
	}
};

jQuery.fx = Tween.prototype.init;

// Back Compat <punto de extensión 1.8
jQuery.fx.step = {};




var
	fxNow, timerId,
	rfxtypes = / ^ (?: toggle | show | hide) $ /,
	rfxnum = new RegExp ("^ (?: ([+ -]) = |) (" + pnum + ") ([az%] *) $", "i"),
	rrun = / queueHooks $ /,
	animationPrefilters = [defaultPrefilter],
	tweeners = {
		"*": [función (prop, valor) {
			var tween = this.createTween (prop, value),
				target = tween.cur (),
				parts = rfxnum.exec (valor),
				unidad = partes && partes [3] || (jQuery.cssNumber [prop]? "": "px"),

				// Se requiere cálculo del valor inicial para posibles desajustes de unidades
				start = (jQuery.cssNumber [prop] || unit! == "px" && + target) &&
					rfxnum.exec (jQuery.css (tween.elem, prop)),
				escala = 1,
				maxIterations = 20;

			if (start && start [3]! == unit) {
				// Unidades de confianza informadas por jQuery.css
				unidad = unidad || comenzar [3];

				// Asegúrate de actualizar las propiedades de interpolación más tarde
				partes = partes || [];

				// Aproximación iterativa desde un punto de partida distinto de cero
				start = + target || 1;

				hacer {
					// Si la iteración anterior se ha reducido a cero, duplique hasta que obtengamos * algo *
					// Usa una cadena para duplicar el factor por lo que no vemos accidentalmente la escala como sin cambios a continuación
					escala = escala || ".5";

					// Ajustar y aplicar
					inicio = inicio / escala;
					jQuery.style (tween.elem, prop, start + unit);

				// Actualizar escala, tolerando cero o NaN desde tween.cur ()
				// Y rompiendo el ciclo si la escala no cambia o es perfecta, o si acabamos de tener suficiente
				} while (scale! == (scale = tween.cur () / target) && scale! == 1 && --maxIterations);
			}

			// Actualizar las propiedades de tween
			if (partes) {
				start = tween.start = + inicio || + objetivo || 0;
				tween.unit = unidad;
				// Si se proporcionó un token + = / - =, estamos haciendo una animación relativa
				tween.end = partes [1]?
					start + (partes [1] + 1) * partes [2]:
					+ partes [2];
			}

			devolver la interpolación;
		}]
	};

// Las animaciones creadas sincrónicamente se ejecutarán sincrónicamente
function createFxNow () {
	setTimeout (function () {
		fxNow = indefinido;
	});
	return (fxNow = jQuery.now ());
}

// Genera parámetros para crear una animación estándar
función genFx (tipo, includeWidth) {
	var que,
		attrs = {height: type},
		i = 0;

	// si incluimos ancho, el valor de paso es 1 para hacer todos los valores de cssExpand,
	// si no incluimos el ancho, el valor del paso es 2 para saltar sobre Izquierda y Derecha
	includeWidth = includeWidth? 1: 0;
	para (; i <4; i + = 2 - includeWidth) {
		which = cssExpand [i];
		attrs ["margen" + que] = atributos ["relleno" + que] = tipo;
	}

	if (includeWidth) {
		attrs.opacity = attrs.width = tipo;
	}

	devolver attrs;
}

función createTween (valor, prop, animación) {
	varianza,
		collection = (tweeners [prop] || []) .concat (tweeners ["*"]),
		índice = 0,
		length = collection.length;
	for (; index <length; index ++) {
		if ((tween = colección [índice] .call (animación, prop, valor))) {

			// hemos terminado con esta propiedad
			devolver la interpolación;
		}
	}
}

función defaultPrefilter (elem, props, opts) {
	/ * jshint validthis: true * /
	var prop, value, toggle, tween, hooks, oldfire, display, checkDisplay,
		anim = esto,
		orig = {},
		style = elem.style,
		hidden = elem.nodeType && isHidden (elem),
		dataShow = jQuery._data (elem, "fxshow");

	// handle queue: promesas falsas
	if (! opts.queue) {
		hooks = jQuery._queueHooks (elem, "fx");
		if (hooks.unqueued == null) {
			hooks.unqueued = 0;
			oldfire = hooks.empty.fire;
			hooks.empty.fire = function () {
				if (! hooks.unqueued) {
					oldfire ();
				}
			};
		}
		hooks.unqueued ++;

		anim.always (function () {
			// al hacer esto, se asegura que se llamará al controlador completo
			// antes de que esto termine
			anim.always (function () {
				hooks.unqueued--;
				if (! jQuery.queue (elem, "fx") .length) {
					hooks.empty.fire ();
				}
			});
		});
	}

	// paso de desbordamiento de altura / ancho
	if (elem.nodeType === 1 && ("height" en props || "width" en props)) {
		// Asegúrate de que nada se escabulle
		// Grabe los 3 atributos de desbordamiento porque IE no lo hace
		// cambia el atributo de desbordamiento cuando overflowX y
		// overflowY se establecen en el mismo valor
		opts.overflow = [style.overflow, style.overflowX, style.overflowY];

		// Establecer propiedad de visualización en bloque en línea para alto / ancho
		// animaciones en elementos en línea que tienen animaciones de ancho / alto
		display = jQuery.css (elem, "display");

		// Prueba de visualización predeterminada si la pantalla es actualmente "ninguna"
		checkDisplay = display === "none"?
			jQuery._data (elem, "olddisplay") || defaultDisplay (elem.nodeName): visualización;

		if (checkDisplay === "inline" && jQuery.css (elem, "float") === "none") {

			// los elementos de nivel en línea aceptan inline-block;
			// los elementos de nivel de bloque deben estar alineados con el diseño
			if (! support.inlineBlockNeedsLayout || defaultDisplay (elem.nodeName) === "inline") {
				style.display = "inline-block";
			} else {
				style.zoom = 1;
			}
		}
	}

	if (opts.overflow) {
		style.overflow = "oculto";
		if (! support.shrinkWrapBlocks ()) {
			anim.always (function () {
				style.overflow = opts.overflow [0];
				style.overflowX = opts.overflow [1];
				style.overflowY = opts.overflow [2];
			});
		}
	}

	// mostrar / ocultar el pase
	para (prop in props) {
		value = props [prop];
		if (rfxtypes.exec (value)) {
			eliminar accesorios [prop];
			alternar = alternar || valor === "alternar";
			if (value === (hidden? "hide": "show")) {

				// Si hay dataShow sobrante de un hide o show detenido y vamos a continuar con el show, deberíamos pretender estar ocultos
				if (value === "show" && dataShow && dataShow [prop]! == undefined) {
					oculto = verdadero;
				} else {
					continuar;
				}
			}
			orig [prop] = dataShow && dataShow [prop] || jQuery.style (elem, prop);

		// Cualquier valor no-fx nos impide restaurar el valor de visualización original
		} else {
			display = indefinido;
		}
	}

	if (! jQuery.isEmptyObject (orig)) {
		if (dataShow) {
			if ("oculto" en dataShow) {
				hidden = dataShow.hidden;
			}
		} else {
			dataShow = jQuery._data (elem, "fxshow", {});
		}

		// store state si su alternancia - habilita .stop (). toggle () para "reverse"
		if (alternar) {
			dataShow.hidden =! hidden;
		}
		if (oculto) {
			jQuery (elem) .show ();
		} else {
			anim.done (function () {
				jQuery (elem) .hide ();
			});
		}
		anim.done (function () {
			var prop;
			jQuery._removeData (elem, "fxshow");
			para (prop en orig) {
				jQuery.style (elem, prop, orig [prop]);
			}
		});
		para (prop en orig) {
			tween = createTween (oculto? dataShow [prop]: 0, prop, anim);

			if (! (prop en dataShow)) {
				dataShow [prop] = tween.start;
				if (oculto) {
					tween.end = tween.start;
					tween.start = prop === "ancho" || prop === "altura"? 1: 0;
				}
			}
		}

	// Si esto es un nodo como .hide (). Hide (), restaura un valor de visualización sobrescrito
	} Else if ((=== pantalla "ninguna" defaultDisplay (elem.nodeName):? Pantalla) === "en línea") {
		style.display = display;
	}
}

función propFilter (props, specialEasing) {
	índice var, nombre, suavizado, valor, ganchos;

	// camelCase, specialEasing y expandir el paso cssHook
	for (index in props) {
		name = jQuery.camelCase (índice);
		easing = specialEasing [nombre];
		value = props [índice];
		if (jQuery.isArray (value)) {
			easing = valor [1];
			value = props [index] = value [0];
		}

		if (index! == nombre) {
			apoyos [nombre] = valor;
			eliminar accesorios [índice];
		}

		hooks = jQuery.cssHooks [nombre];
		if (hooks && "expand" en ganchos) {
			value = hooks.expand (valor);
			eliminar accesorios [nombre];

			// no bastante $ .extend, esto no sobrescribirá las claves ya presentes.
			// también - reutilizando 'index' desde arriba porque tenemos el "nombre" correcto
			for (index in value) {
				if (! (index in props)) {
					accesorios [índice] = valor [índice];
					specialEasing [index] = facilitación;
				}
			}
		} else {
			specialEasing [name] = easing;
		}
	}
}

función Animación (elem, propiedades, opciones) {
	var resultado,
		detenido,
		índice = 0,
		length = animationPrefilters.length,
		deferred = jQuery.Deferred (). always (function () {
			// no coincide con elem en el: selector animado
			eliminar tick.elem;
		}),
		tick = function () {
			if (detenido) {
				falso retorno;
			}
			var currentTime = fxNow || createFxNow (),
				remaining = Math.max (0, animation.startTime + animation.duration - currentTime),
				// Error de colisión arcaico no nos permitirá usar 1 - (0.5 || 0) (# 12497)
				temp = remaining / animation.duration || 0,
				porcentaje = 1 - temperatura,
				índice = 0,
				length = animation.tweens.length;

			for (; index <length; index ++) {
				animation.tweens [índice] .run (porcentaje);
			}

			deferred.notifyWith (elem, [animación, porcentaje, restante]);

			if (porcentaje <1 && length) {
				regreso restante;
			} else {
				deferred.resolveWith (elem, [animación]);
				falso retorno;
			}
		},
		animation = deferred.promise ({
			elem: elem,
			accesorios: jQuery.extend ({}, propiedades),
			opts: jQuery.extend (true, {specialEasing: {}}, opciones),
			originalProperties: propiedades,
			originalOptions: opciones,
			startTime: fxNow || createFxNow (),
			duración: options.duration,
			tweens: [],
			createTween: function (prop, end) {
				var tween = jQuery.Tween (elem, animation.opts, prop, end,
						animation.opts.specialEasing [prop] || animation.opts.easing);
				animation.tweens.push (interpolación);
				devolver la interpolación;
			},
			stop: function (gotoEnd) {
				índice var = 0,
					// si vamos al final, queremos ejecutar todos los tweens
					// de lo contrario nos salteamos esta parte
					length = gotoEnd? animation.tweens.length: 0;
				if (detenido) {
					devuelve esto;
				}
				parado = verdadero;
				for (; index <length; index ++) {
					animation.tweens [index] .run (1);
				}

				// resolvemos cuando jugamos el último frame
				// de lo contrario, rechazar
				if (gotoEnd) {
					deferred.resolveWith (elem, [animation, gotoEnd]);
				} else {
					deferred.rejectWith (elem, [animación, gotoEnd]);
				}
				devuelve esto;
			}
		}),
		props = animation.props;

	propFilter (props, animation.opts.specialEasing);

	for (; index <length; index ++) {
		result = animationPrefilters [index] .call (animación, elem, props, animation.opts);
		if (resultado) {
			resultado de devolución;
		}
	}

	jQuery.map (props, createTween, animación);

	if (jQuery.isFunction (animation.opts.start)) {
		animation.opts.start.call (elem, animación);
	}

	jQuery.fx.timer (
		jQuery.extend (tick, {
			elem: elem,
			anim: animación,
			queue: animation.opts.queue
		})
	);

	// adjuntar devoluciones de llamadas de opciones
	return animation.progress (animation.opts.progress)
		.done (animation.opts.done, animation.opts.complete)
		.fail (animation.opts.fail)
		.always (animation.opts.always);
}

jQuery.Animation = jQuery.extend (Animación, {
	tweener: function (props, callback) {
		if (jQuery.isFunction (props)) {
			devolución de llamada = accesorios;
			props = ["*"];
		} else {
			props = props.split ("");
		}

		var prop,
			índice = 0,
			length = props.length;

		for (; index <length; index ++) {
			prop = props [índice];
			tweeners [prop] = tweeners [prop] || [];
			tweeners [prop] .unshift (devolución de llamada);
		}
	},

	prefiltro: función (devolución de llamada, anteponer) {
		if (prepend) {
			animationPrefilters.unshift (devolución de llamada);
		} else {
			animationPrefilters.push (devolución de llamada);
		}
	}
});

jQuery.speed = function (speed, easing, fn) {
	var opt = speed && typeof speed === "object"? jQuery.extend ({}, velocidad): {
		completo: fn || ! fn && easing ||
			jQuery.isFunction (speed) && speed,
		duración: velocidad,
		facilitación: fn y& easing || facilitando &&! jQuery.isFunction (easing) && easing
	};

	opt.duration = jQuery.fx.off? 0: typeof opt.duration === "number"? opt.duration:
		opt.duration en jQuery.fx.speeds? jQuery.fx.speeds [opt.duration]: jQuery.fx.speeds._default;

	// normalizar opt.queue - true / undefined / null -> "fx"
	if (opt.queue == null || opt.queue === true) {
		opt.queue = "fx";
	}

	// Queueing
	opt.old = opt.complete;

	opt.complete = function () {
		if (jQuery.isFunction (opt.old)) {
			opt.old.call (esto);
		}

		if (opt.queue) {
			jQuery.dequeue (esto, opt.queue);
		}
	};

	return opt;
};

jQuery.fn.extend ({
	fadeTo: function (speed, to, easing, callback) {

		// muestra cualquier elemento oculto después de configurar la opacidad a 0
		devuelve this.filter (isHidden) .css ("opacity", 0) .show ()

			// animar al valor especificado
			.end (). animate ({opacity: to}, speed, easing, callback);
	},
	animate: function (prop, speed, easing, callback) {
		var empty = jQuery.isEmptyObject (prop),
			optall = jQuery.speed (velocidad, suavizado, devolución de llamada),
			doAnimation = function () {
				// Operar en una copia de prop para que el easing por propiedad no se pierda
				var anim = Animación (esto, jQuery.extend ({}, prop), optall);

				// Las animaciones vacías o el acabado se resuelven inmediatamente
				if (empty || jQuery._data (this, "finish")) {
					anim.stop (verdadero);
				}
			};
			doAnimation.finish = doAnimation;

		regresa vacío || optall.queue === ¿falso?
			this.each (doAnimation):
			this.queue (optall.queue, doAnimation);
	},
	stop: function (type, clearQueue, gotoEnd) {
		var stopQueue = function (hooks) {
			var stop = hooks.stop;
			eliminar hooks.stop;
			detener (gotoEnd);
		};

		if (tipo de tipo! == "cadena") {
			gotoEnd = clearQueue;
			clearQueue = tipo;
			tipo = indefinido;
		}
		if (clearQueue && type! == false) {
			this.queue (tipo || "fx", []);
		}

		return this.each (function () {
			var dequeue = true,
				index = type! = null && type + "queueHooks",
				timers = jQuery.timers,
				data = jQuery._data (this);

			if (índice) {
				if (data [index] && data [index] .stop) {
					stopQueue (datos [índice]);
				}
			} else {
				for (index in data) {
					if (data [index] && data [index] .stop && rrun.test (index)) {
						stopQueue (datos [índice]);
					}
				}
			}

			for (index = timers.length; index--;) {
				if (timers [index] .elem === this && (type == null || timers [index] .queue === type)) {
					temporizadores [index] .anim.stop (gotoEnd);
					dequeue = falso;
					timers.splice (índice, 1);
				}
			}

			// comienza el siguiente en la cola si el último paso no fue forzado
			// los temporizadores actualmente llamarán sus devoluciones de llamada completas, que dequeue
			// pero solo si fueran goto End
			if (dequeue ||! gotoEnd) {
				jQuery.dequeue (esto, tipo);
			}
		});
	},
	finalizar: función (tipo) {
		if (type! == false) {
			tipo = tipo || "fx";
		}
		return this.each (function () {
			índice var,
				data = jQuery._data (esto),
				queue = data [type + "queue"],
				hooks = data [type + "queueHooks"],
				timers = jQuery.timers,
				longitud = cola? queue.length: 0;

			// habilitar el indicador de finalización en datos privados
			data.finish = true;

			// vaciar la cola primero
			jQuery.queue (esto, tipo, []);

			if (hooks && hooks.stop) {
				hooks.stop.call (esto, verdadero);
			}

			// busca cualquier animación activa y finalízala
			for (index = timers.length; index--;) {
				if (timers [index] .elem === this && timers [index] .queue === type) {
					temporizadores [índice] .anim.stop (verdadero);
					timers.splice (índice, 1);
				}
			}

			// busca las animaciones en la cola anterior y las termina
			for (index = 0; index <length; index ++) {
				if (queue [índice] && queue [índice] .finish) {
					queue [index] .finish.call (this);
				}
			}

			// apaga la bandera de acabado
			eliminar data.finish;
		});
	}
});

jQuery.each (["alternar", "mostrar", "ocultar"], función (i, nombre) {
	var cssFn = jQuery.fn [nombre];
	jQuery.fn [name] = function (speed, easing, callback) {
		velocidad de retorno == nulo || typeof speed === "boolean"?
			cssFn.apply (esto, argumentos):
			this.animate (genFx (nombre, verdadero), velocidad, suavizado, devolución de llamada);
	};
});

// Generar atajos para animaciones personalizadas
jQuery.each ({
	slideDown: genFx ("mostrar"),
	slideUp: genFx ("ocultar"),
	slideToggle: genFx ("alternar"),
	fadeIn: {opacity: "show"},
	fadeOut: {opacity: "hide"},
	fadeToggle: {opacity: "toggle"}
}, function (name, props) {
	jQuery.fn [name] = function (speed, easing, callback) {
		devuelve this.animate (accesorios, velocidad, relajación, devolución de llamada);
	};
});

jQuery.timers = [];
jQuery.fx.tick = function () {
	temporizador var,
		timers = jQuery.timers,
		i = 0;

	fxNow = jQuery.now ();

	para (; i <timers.length; i ++) {
		timer = temporizadores [i];
		// Comprueba que el temporizador no haya sido eliminado
		if (! timer () && timers [i] === timer) {
			timers.splice (i--, 1);
		}
	}

	if (! timers.length) {
		jQuery.fx.stop ();
	}
	fxNow = indefinido;
};

jQuery.fx.timer = function (timer) {
	jQuery.timers.push (temporizador);
	if (timer ()) {
		jQuery.fx.start ();
	} else {
		jQuery.timers.pop ();
	}
};

jQuery.fx.interval = 13;

jQuery.fx.start = function () {
	if (! timerId) {
		timerId = setInterval (jQuery.fx.tick, jQuery.fx.interval);
	}
};

jQuery.fx.stop = function () {
	clearInterval (timerId);
	timerId = null;
};

jQuery.fx.speeds = {
	lento: 600,
	rápido: 200,
	// Velocidad predeterminada
	_default: 400
};


// Basado en el plugin de Clint Helfers, con permiso.
// http://blindsignals.com/index.php/2009/07/jquery-delay/
jQuery.fn.delay = function (time, type) {
	tiempo = jQuery.fx? jQuery.fx.speeds [time] || tiempo tiempo;
	tipo = tipo || "fx";

	return this.queue (type, function (next, hooks) {
		var timeout = setTimeout (next, time);
		hooks.stop = function () {
			clearTimeout (tiempo de espera);
		};
	});
};


(función () {
	// Minificado: var a, b, c, d, e
	var input, div, select, a, opt;

	// Preparar
	div = document.createElement ("div");
	div.setAttribute ("className", "t");
	div.innerHTML = "<link /> <table> </ table> <a href='/a'> a </a> <input type = 'checkbox' />";
	a = div.getElementsByTagName ("a") [0];

	// Primer lote de pruebas.
	select = document.createElement ("seleccionar");
	opt = select.appendChild (document.createElement ("opción"));
	input = div.getElementsByTagName ("entrada") [0];

	a.style.cssText = "top: 1px";

	// Prueba setAttribute en la clase camelCase. Si funciona, necesitamos attrFixes al hacer get / setAttribute (ie6 / 7)
	support.getSetAttribute = div.className! == "t";

	// Obtenga la información de estilo de getAttribute
	// (IE usa .cssText en su lugar)
	support.style = /top/.test (a.getAttribute ("estilo"));

	// Asegúrate de que las URL no estén manipuladas
	// (IE lo normaliza por defecto)
	support.hrefNormalized = a.getAttribute ("href") === "/ a";

	// Verifique el valor por defecto del checkbox / radio ("" en WebKit; "en" otro lado)
	support.checkOn = !! input.value;

	// Asegúrese de que una opción seleccionada por defecto tenga una propiedad seleccionada que funcione.
	// (WebKit se convierte en falso en lugar de verdadero, IE también, si está en un grupo de selección)
	support.optSelected = opt.selected;

	// Pruebas de compatibilidad con enctype en un formulario (# 6743)
	support.enctype = !! document.createElement ("formulario"). enctype;

	// Asegúrate de que las opciones dentro de las selecciones desactivadas no estén marcadas como deshabilitadas
	// (WebKit los marca como deshabilitados)
	select.disabled = true;
	support.optDisabled =! opt.disabled;

	// Soporte: solo IE8
	// Compruebe si podemos confiar en getAttribute ("valor")
	input = document.createElement ("entrada");
	input.setAttribute ("valor", "");
	support.input = input.getAttribute ("value") === "";

	// Verifica si una entrada mantiene su valor después de convertirse en una radio
	input.value = "t";
	input.setAttribute ("tipo", "radio");
	support.radioValue = input.value === "t";
}) ();


var rreturn = / \ r / g;

jQuery.fn.extend ({
	val: función (valor) {
		var hooks, ret, isFunction,
			elem = this [0];

		if (! arguments.length) {
			if (elem) {
				hooks = jQuery.valHooks [elem.type] || jQuery.valHooks [elem.nodeName.toLowerCase ()];

				if (hooks && "get" en hooks && (ret = hooks.get (elem, "value"))! == undefined) {
					return ret;
				}

				ret = elem.value;

				return typeof ret === "cadena"?
					// manejamos la mayoría de los casos de cuerdas comunes
					ret.replace (rreturn, ""):
					// manejar casos donde el valor es nulo / undef o número
					ret == nulo? "": ret;
			}

			regreso;
		}

		isFunction = jQuery.isFunction (valor);

		return this.each (función (i) {
			var val;

			if (this.nodeType! == 1) {
				regreso;
			}

			if (isFunction) {
				val = value.call (this, i, jQuery (this) .val ());
			} else {
				val = valor;
			}

			// Tratar nulo / indefinido como ""; convertir números a cadena
			if (val == null) {
				val = "";
			} else if (typeof val === "número") {
				val + = "";
			} else if (jQuery.isArray (val)) {
				val = jQuery.map (val, function (value) {
					valor de retorno == nulo? "": valor + "";
				});
			}

			hooks = jQuery.valHooks [this.type] || jQuery.valHooks [this.nodeName.toLowerCase ()];

			// Si el conjunto devuelve indefinido, vuelve a la configuración normal
			if (! hooks ||! ("set" en los ganchos) || hooks.set (this, val, "value") === undefined) {
				this.value = val;
			}
		});
	}
});

jQuery.extend ({
	valHooks: {
		opción: {
			get: function (elem) {
				var val = jQuery.find.attr (elem, "valor");
				return val! = null?
					Val:
					// Soporte: IE10-11 +
					// option.text arroja excepciones (# 14686, # 14858)
					jQuery.trim (jQuery.text (elem));
			}
		},
		seleccionar: {
			get: function (elem) {
				valor var, opción,
					options = elem.options,
					index = elem.selectedIndex,
					one = elem.type === "select-one" || índice <0,
					valores = uno? nulo : [],
					max = uno? índice + 1: opciones.length,
					i = índice <0?
						max:
						uno ? índice: 0;

				// Pasa por todas las opciones seleccionadas
				para (; i <max; i ++) {
					option = opciones [i];

					// oldIE no actualiza seleccionado después de restablecer el formulario (# 2551)
					if ((opción.selected || i === index) &&
							// No devuelve las opciones que están deshabilitadas o en un grupo de opciones deshabilitado
							(support.optDisabled?! option.disabled: option.getAttribute ("disabled") === null) &&
							(! option.parentNode.disabled ||! jQuery.nodeName (option.parentNode, "optgroup"))) {

						// Obtenga el valor específico para la opción
						value = jQuery (option) .val ();

						// No necesitamos una matriz para una selecciona
						si uno ) {
							valor de retorno;
						}

						// Multi-Selects devuelve una matriz
						values.push (valor);
					}
				}

				valores de retorno;
			},

			set: function (elem, value) {
				var optionSet, option,
					options = elem.options,
					values ​​= jQuery.makeArray (valor),
					i = opciones.length;

				mientras yo-- ) {
					option = opciones [i];

					if (jQuery.inArray (jQuery.valHooks.option.get (opción), values)> = 0) {

						// Soporte: IE6
						// Cuando se agrega un nuevo elemento de opción para seleccionar el cuadro, necesitamos
						// force reflow del nodo recién agregado para retrasar la solución
						// de las propiedades de inicialización
						tratar {
							option.selected = optionSet = true;

						} captura ( _ ) {

							// Se ejecutará solo en IE6
							option.scrollHeight;
						}

					} else {
						option.selected = false;
					}
				}

				// Forzar a los navegadores a comportarse de manera consistente cuando se establece un valor no coincidente
				if (! optionSet) {
					elem.selectedIndex = -1;
				}

				opciones de devolución;
			}
		}
	}
});

// Radios y casillas de verificación getter / setter
jQuery.each (["radio", "casilla de verificación"], función () {
	jQuery.valHooks [this] = {
		set: function (elem, value) {
			if (jQuery.isArray (value)) {
				return (elem.checked = jQuery.inArray (jQuery (elem) .val (), value)> = 0);
			}
		}
	};
	if (! support.checkOn) {
		jQuery.valHooks [this] .get = function (elem) {
			// Soporte: Webkit
			// "" se devuelve en lugar de "on" si no se especifica un valor
			return elem.getAttribute ("valor") === nulo? "on": elem.value;
		};
	}
});




var nodeHook, boolHook,
	attrHandle = jQuery.expr.attrHandle,
	ruseDefault = / ^ (?: checked | selected) $ / i,
	getSetAttribute = support.getSetAttribute,
	getSetInput = support.input;

jQuery.fn.extend ({
	attr: function (nombre, valor) {
		acceso de retorno (esto, jQuery.attr, nombre, valor, arguments.length> 1);
	},

	removeAttr: function (name) {
		return this.each (function () {
			jQuery.removeAttr (this, name);
		});
	}
});

jQuery.extend ({
	attr: función (elem, nombre, valor) {
		var hooks, ret,
			nType = elem.nodeType;

		// no obtiene / establece atributos en los nodos de texto, comentario y atributo
		if (! elem || nType === 3 || nType === 8 || nType === 2) {
			regreso;
		}

		// Fallback to prop cuando los atributos no son compatibles
		if (typeof elem.getAttribute === strundefined) {
			return jQuery.prop (elem, nombre, valor);
		}

		// Todos los atributos son minúsculas
		// Tomar gancho necesario si se define uno
		if (nType! == 1 ||! jQuery.isXMLDoc (elem)) {
			name = name.toLowerCase ();
			hooks = jQuery.attrHooks [nombre] ||
				(jQuery.expr.match.bool.test (name)? boolHook: nodeHook);
		}

		if (value! == undefined) {

			if (value === null) {
				jQuery.removeAttr (elem, nombre);

			} else if (hooks && "set" en hooks && (ret = hooks.set (elem, value, name))! == undefined) {
				return ret;

			} else {
				elem.setAttribute (name, value + "");
				valor de retorno;
			}

		} else if (hooks && "get" en hooks && (ret = hooks.get (elem, name))!! == null) {
			return ret;

		} else {
			ret = jQuery.find.attr (elem, nombre);

			// Los atributos inexistentes devuelven nulo, normalizamos a indefinido
			return ret == null?
				undefined:
				retirado;
		}
	},

	removeAttr: function (elem, value) {
		var nombre, propName,
			i = 0,
			attrNames = value && value.match (rnotwhite);

		if (attrNames && elem.nodeType === 1) {
			while ((name = attrNames [i ++])) {
				propName = jQuery.propFix [nombre] || nombre;

				// Los atributos booleanos reciben un trato especial (# 10870)
				if (jQuery.expr.match.bool.test (name)) {
					// Establecer propiedad correspondiente a falso
					if (getSetInput && getSetAttribute ||! ruseDefault.test (name)) {
						elem [propName] = falso;
					// Soporte: IE <9
					// También se borra el valor predeterminadoChecked / defaultSelected (si corresponde)
					} else {
						elem [jQuery.camelCase ("default-" + name)] =
							elem [propName] = falso;
					}

				// Ver # 9699 para la explicación de este enfoque (establecer primero, luego eliminar)
				} else {
					jQuery.attr (elem, name, "");
				}

				elem.removeAttribute (getSetAttribute? name: propName);
			}
		}
	},

	attrHooks: {
		tipo: {
			set: function (elem, value) {
				if (! support.radioValue && value === "radio" && jQuery.nodeName (elem, "input")) {
					// Configurar el tipo en un botón de opción después de que el valor restablece el valor en IE6-9
					// Restablece el valor predeterminado en caso de que el tipo se establezca después del valor durante la creación
					var val = elem.value;
					elem.setAttribute ("tipo", valor);
					if (val) {
						elem.value = val;
					}
					valor de retorno;
				}
			}
		}
	}
});

// Gancho para atributos booleanos
boolHook = {
	set: function (elem, value, name) {
		if (value === false) {
			// Eliminar atributos booleanos cuando se establece en falso
			jQuery.removeAttr (elem, nombre);
		} else if (getSetInput && getSetAttribute ||! ruseDefault.test (name)) {
			// IE <8 necesita el nombre * propiedad *
			elem.setAttribute (! getSetAttribute && jQuery.propFix [nombre] || nombre, nombre);

		// Usar defaultChecked y defaultSelected para oldIE
		} else {
			elem [jQuery.camelCase ("default-" + name)] = elem [name] = true;
		}

		nombre de regreso;
	}
};

// Recuperar booleanos especialmente
jQuery.each (jQuery.expr.match.bool.source.match (/ \ w + / g), función (i, nombre) {

	var getter = attrHandle [nombre] || jQuery.find.attr;

	attrHandle [nombre] = getSetInput && getSetAttribute || ! ruseDefault.test (nombre)?
		función (elem, name, isXML) {
			var ret, handle;
			if (! isXML) {
				// Evite un bucle infinito al eliminar temporalmente esta función del getter
				handle = attrHandle [nombre];
				attrHandle [nombre] = ret;
				ret = getter (elem, name, isXML)! = null?
					name.toLowerCase ():
					nulo;
				attrHandle [nombre] = manejar;
			}
			return ret;
		}:
		función (elem, name, isXML) {
			if (! isXML) {
				return elem [jQuery.camelCase ("default-" + name)]?
					name.toLowerCase ():
					nulo;
			}
		};
});

// arreglar oldIE attroperties
if (! getSetInput ||! getSetAttribute) {
	jQuery.attrHooks.value = {
		set: function (elem, value, name) {
			if (jQuery.nodeName (elem, "input")) {
				// No regresa para que también se use setAttribute
				elem.defaultValue = value;
			} else {
				// Use nodeHook si está definido (# 1954); de lo contrario, setAttribute está bien
				return nodeHook && nodeHook.set (elem, value, name);
			}
		}
	};
}

// IE6 / 7 no admite obtener / establecer algunos atributos con get / setAttribute
if (! getSetAttribute) {

	// Usa esto para cualquier atributo en IE6 / 7
	// Esto soluciona casi todos los problemas IE6 / 7
	nodeHook = {
		set: function (elem, value, name) {
			// Establecer el nodo de atributo existente o crear uno nuevo
			var ret = elem.getAttributeNode (nombre);
			if (! ret) {
				elem.setAttributeNode (
					(ret = elem.ownerDocument.createAttribute (name))
				);
			}

			ret.value = value + = "";

			// Romper asociación con elementos clonados usando también setAttribute (# 9646)
			if (name === "value" || value === elem.getAttribute (name)) {
				valor de retorno;
			}
		}
	};

	// Algunos atributos se construyen con valores de cadena vacía cuando no están definidos
	attrHandle.id = attrHandle.name = attrHandle.coords =
		función (elem, name, isXML) {
			var ret;
			if (! isXML) {
				return (ret = elem.getAttributeNode (name)) && ret.value! == ""?
					ret.value:
					nulo;
			}
		};

	// La recuperación del valor de fijación en un botón requiere este módulo
	jQuery.valHooks.button = {
		get: function (elem, name) {
			var ret = elem.getAttributeNode (nombre);
			if (ret && ret.specified) {
				return ret.value;
			}
		},
		establecer: nodeHook.set
	};

	// Establecer contenteditable a falso en las eliminaciones (# 10429)
	// Establecer en cadena vacía arroja un error como un valor no válido
	jQuery.attrHooks.contenteditable = {
		set: function (elem, value, name) {
			nodeHook.set (elem, value === ""? false: value, name);
		}
	};

	// Establecer ancho y alto en auto en lugar de 0 en una cadena vacía (Bug # 8150)
	// Esto es para mudanzas
	jQuery.each (["ancho", "alto"], función (i, nombre) {
		jQuery.attrHooks [name] = {
			set: function (elem, value) {
				if (value === "") {
					elem.setAttribute (name, "auto");
					valor de retorno;
				}
			}
		};
	});
}

if (! support.style) {
	jQuery.attrHooks.style = {
		get: function (elem) {
			// Devuelve indefinido en el caso de cadena vacía
			// Nota: IE uppercases css nombres de propiedad, pero si tuviéramos que .toLowerCase ()
			// .cssText, que destruiría la sensibilidad de los casos en las URL, como en "fondo"
			return elem.style.cssText || indefinido;
		},
		set: function (elem, value) {
			return (elem.style.cssText = value + "");
		}
	};
}




var rfocusable = / ^ (?: input | select | textarea | button | object) $ / i,
	rclickable = / ^ (?: a | área) $ / i;

jQuery.fn.extend ({
	prop: function (nombre, valor) {
		acceso de retorno (esto, jQuery.prop, name, value, arguments.length> 1);
	},

	removeProp: function (name) {
		name = jQuery.propFix [nombre] || nombre;
		return this.each (function () {
			// try / catch maneja casos donde IE se bloquea (como eliminar una propiedad en la ventana)
			tratar {
				este [nombre] = indefinido;
				eliminar este [nombre];
			} catch (e) {}
		});
	}
});

jQuery.extend ({
	propFix: {
		"para": "htmlFor",
		"clase": "className"
	},

	prop: function (elem, name, value) {
		var ret, hooks, notxml,
			nType = elem.nodeType;

		// no obtiene / establece propiedades en los nodos de texto, comentario y atributo
		if (! elem || nType === 3 || nType === 8 || nType === 2) {
			regreso;
		}

		notxml = nType! == 1 || ! jQuery.isXMLDoc (elem);

		if (notxml) {
			// arreglar el nombre y adjuntar ganchos
			name = jQuery.propFix [nombre] || nombre;
			hooks = jQuery.propHooks [nombre];
		}

		if (value! == undefined) {
			return hooks && "set" en los ganchos && (ret = hooks.set (elem, value, name))! == undefined?
				ret:
				(elem [nombre] = valor);

		} else {
			return hooks && "get" en los ganchos && (ret = hooks.get (elem, name))!! == null?
				ret:
				elem [nombre];
		}
	},

	PropHooks: {
		tabIndex: {
			get: function (elem) {
				// elem.tabIndex no siempre devuelve el valor correcto cuando no se ha establecido explícitamente
				// http://fluidproject.org/blog/2008/01/09/getting-setting-and-removing-tabindex-values-with-javascript/
				// Usa recuperación de atributos adecuada (# 12072)
				var tabindex = jQuery.find.attr (elem, "tabindex");

				regresar tabindex?
					parseInt (tabindex, 10):
					rfocusable.test (elem.nodeName) || rclickable.test (elem.nodeName) && elem.href?
						0:
						-1;
			}
		}
	}
});

// Algunos atributos requieren una llamada especial en IE
// http://msdn.microsoft.com/en-us/library/ms536429%28VS.85%29.aspx
if (! support.hrefNormalized) {
	// La propiedad href / src debería obtener la URL normalizada completa (# 10299 / # 12915)
	jQuery.each (["href", "src"], función (i, nombre) {
		jQuery.propHooks [name] = {
			get: function (elem) {
				return elem.getAttribute (nombre, 4);
			}
		};
	});
}

// Soporte: Safari, IE9 +
// reporta incorrectamente la propiedad seleccionada por defecto de una opción
// El acceso a la propiedad selectedIndex del padre lo arregla
if (! support.optSelected) {
	jQuery.propHooks.selected = {
		get: function (elem) {
			var parent = elem.parentNode;

			if (padre) {
				parent.selectedIndex;

				// Asegúrese de que también funciona con optgroups, vea # 5701
				if (parent.parentNode) {
					parent.parentNode.selectedIndex;
				}
			}
			devolver nulo;
		}
	};
}

jQuery.each ([
	"tabIndex",
	"solo lectura",
	"longitud máxima",
	"cellSpacing",
	"cellPadding",
	"rowSpan",
	"colSpan",
	"useMap",
	"Frontera del marco",
	"contentEditable"
], función () {
	jQuery.propFix [this.toLowerCase ()] = this;
});

// IE6 / 7 llamada codificación enctype
if (! support.enctype) {
	jQuery.propFix.enctype = "codificación";
}




var rclass = / [\ t \ r \ n \ f] / g;

jQuery.fn.extend ({
	addClass: function (value) {
		var clases, elem, cur, clazz, j, finalValue,
			i = 0,
			len = this.length,
			proceda = typeof value === "cadena" && value;

		if (jQuery.isFunction (value)) {
			devuelve this.each (function (j) {
				jQuery (this) .addClass (value.call (this, j, this.className));
			});
		}

		if (proceder) {
			// La disyunción aquí es para una mejor compresibilidad (ver removeClass)
			classes = (value || "") .match (rnotwhite) || [];

			para (; i <len; i ++) {
				elem = this [i];
				cur = elem.nodeType === 1 && (elem.className?
					("" + elem.className + "") .replace (rclass, ""):
					""
				);

				if (cur) {
					j = 0;
					while ((clazz = classes [j ++])) {
						if (cur.indexOf ("" + clazz + "") <0) {
							cur + = clazz + "";
						}
					}

					// solo asigna si es diferente para evitar el renderizado innecesario.
					finalValue = jQuery.trim (cur);
					if (elem.className! == finalValue) {
						elem.className = finalValue;
					}
				}
			}
		}

		devuelve esto;
	},

	removeClass: function (value) {
		var clases, elem, cur, clazz, j, finalValue,
			i = 0,
			len = this.length,
			proceed = arguments.length === 0 || typeof value === "string" && value;

		if (jQuery.isFunction (value)) {
			devuelve this.each (function (j) {
				jQuery (this) .removeClass (value.call (this, j, this.className));
			});
		}
		if (proceder) {
			classes = (value || "") .match (rnotwhite) || [];

			para (; i <len; i ++) {
				elem = this [i];
				// Esta expresión está aquí para una mejor compresibilidad (ver addClass)
				cur = elem.nodeType === 1 && (elem.className?
					("" + elem.className + "") .replace (rclass, ""):
					""
				);

				if ( cur ) {
					j = 0;
					while ( (clazz = classes[j++]) ) {
						// Remove *all* instances
						while ( cur.indexOf( " " + clazz + " " ) >= 0 ) {
							cur = cur.replace( " " + clazz + " ", " " );
						}
					}

					// only assign if different to avoid unneeded rendering.
					finalValue = value ? jQuery.trim( cur ) : "";
					if ( elem.className !== finalValue ) {
						elem.className = finalValue;
					}
				}
			}
		}

		devuelve esto;
	},

	toggleClass: function (value, stateVal) {
		var type = typeof value;

		if (typeof stateVal === "boolean" && type === "string") {
			return stateVal? this.addClass (value): this.removeClass (value);
		}

		if (jQuery.isFunction (value)) {
			return this.each (función (i) {
				jQuery (this) .toggleClass (value.call (this, i, this.className, stateVal), stateVal);
			});
		}

		return this.each (function () {
			if (tipo === "cadena") {
				// alternar nombres de clases individuales
				var className,
					i = 0,
					self = jQuery (esto),
					classNames = value.match (rnotwhite) || [];

				while ((className = classNames [i ++])) {
					// verifica cada className dado, lista separada por espacios
					if (self.hasClass (className)) {
						self.removeClass (className);
					} else {
						self.addClass (className);
					}
				}

			// Toggle whole class name
			} else if ( type === strundefined || type === "boolean" ) {
				if ( this.className ) {
					// store className if set
					jQuery._data( this, "__className__", this.className );
				}

				// If the element has a class name or if we're passed "false",
				// then remove the whole classname (if there was one, the above saved it).
				// Otherwise bring back whatever was previously saved (if anything),
				// falling back to the empty string if nothing was stored.
				this.className = this.className || value === false ? "" : jQuery._data( this, "__className__" ) || "";
			}
		});
	},

	hasClass: function( selector ) {
		var className = " " + selector + " ",
			i = 0,
			l = this.length;
		for ( ; i < l; i++ ) {
			if ( this[i].nodeType === 1 && (" " + this[i].className + " ").replace(rclass, " ").indexOf( className ) >= 0 ) {
				return true;
			}
		}

		return false;
	}
});




// Return jQuery for attributes-only inclusion


jQuery.each( ("blur focus focusin focusout load resize scroll unload click dblclick " +
	"mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave " +
	"change select submit keydown keypress keyup error contextmenu").split(" "), function( i, name ) {

	// Handle event binding
	jQuery.fn[ name ] = function( data, fn ) {
		return arguments.length > 0 ?
			this.on( name, null, data, fn ) :
			this.trigger( name );
	};
});

jQuery.fn.extend({
	hover: function( fnOver, fnOut ) {
		return this.mouseenter( fnOver ).mouseleave( fnOut || fnOver );
	},

	bind: function( types, data, fn ) {
		return this.on( types, null, data, fn );
	},
	unbind: function( types, fn ) {
		return this.off( types, null, fn );
	},

	delegate: function( selector, types, data, fn ) {
		return this.on( types, selector, data, fn );
	},
	undelegate: function( selector, types, fn ) {
		// ( namespace ) or ( selector, types [, fn] )
		return arguments.length === 1 ? this.off( selector, "**" ) : this.off( types, selector || "**", fn );
	}
});


var nonce = jQuery.now();

var rquery = (/\?/);



var rvalidtokens = /(,)|(\[|{)|(}|])|"(?:[^"\\\r\n]|\\["\\\/bfnrt]|\\u[\da-fA-F]{4})*"\s*:?|true|false|null|-?(?!0\d)\d+(?:\.\d+|)(?:[eE][+-]?\d+|)/g;

jQuery.parseJSON = function( data ) {
	// Attempt to parse using the native JSON parser first
	if ( window.JSON && window.JSON.parse ) {
		// Support: Android 2.3
		// Workaround failure to string-cast null input
		return window.JSON.parse( data + "" );
	}

	var requireNonComma,
		depth = null,
		str = jQuery.trim( data + "" );

	// Guard against invalid (and possibly dangerous) input by ensuring that nothing remains
	// after removing valid tokens
	return str && !jQuery.trim( str.replace( rvalidtokens, function( token, comma, open, close ) {

		// Force termination if we see a misplaced comma
		if ( requireNonComma && comma ) {
			depth = 0;
		}

		// Perform no more replacements after returning to outermost depth
		if ( depth === 0 ) {
			return token;
		}

		// Commas must not follow "[", "{", or ","
		requireNonComma = open || comma;

		// Determine new depth
		// array/object open ("[" or "{"): depth += true - false (increment)
		// array/object close ("]" or "}"): depth += false - true (decrement)
		// other cases ("," or primitive): depth += true - true (numeric cast)
		depth += !close - !open;

		// Remove this token
		return "";
	}) ) ?
		( Function( "return " + str ) )() :
		jQuery.error( "Invalid JSON: " + data );
};


// Cross-browser xml parsing
jQuery.parseXML = function( data ) {
	var xml, tmp;
	if ( !data || typeof data !== "string" ) {
		return null;
	}
	try {
		if ( window.DOMParser ) { // Standard
			tmp = new DOMParser();
			xml = tmp.parseFromString( data, "text/xml" );
		} else { // IE
			xml = new ActiveXObject( "Microsoft.XMLDOM" );
			xml.async = "false";
			xml.loadXML( data );
		}
	} catch( e ) {
		xml = undefined;
	}
	if ( !xml || !xml.documentElement || xml.getElementsByTagName( "parsererror" ).length ) {
		jQuery.error( "Invalid XML: " + data );
	}
	return xml;
};


var
	// Document location
	ajaxLocParts,
	ajaxLocation,

	rhash = /#.*$/,
	rts = /([?&])_=[^&]*/,
	rheaders = /^(.*?):[ \t]*([^\r\n]*)\r?$/mg, // IE leaves an \r character at EOL
	// #7653, #8125, #8152: local protocol detection
	rlocalProtocol = /^(?:about|app|app-storage|.+-extension|file|res|widget):$/,
	rnoContent = /^(?:GET|HEAD)$/,
	rprotocol = /^\/\//,
	rurl = /^([\w.+-]+:)(?:\/\/(?:[^\/?#]*@|)([^\/?#:]*)(?::(\d+)|)|)/,

	/* Prefilters
	 * 1) They are useful to introduce custom dataTypes (see ajax/jsonp.js for an example)
	 * 2) These are called:
	 *    - BEFORE asking for a transport
	 *    - AFTER param serialization (s.data is a string if s.processData is true)
	 * 3) la clave es el tipo de datos
	 * 4) el símbolo de catchall "*" se puede usar
	 * 5) la ejecución comenzará con el tipo de datos de transporte y luego continuará hasta "*" si es necesario
	 * /
	prefilters = {},

	/ * Enlaces de transporte
	 * 1) clave es el tipo de datos
	 * 2) el símbolo de catchall "*" se puede usar
	 * 3) la selección comenzará con el tipo de datos de transporte y LUEGO irá a "*" si es necesario
	 * /
	transportes = {},

	// Evitar la secuencia de comentario-prolog char (# 10098); debe aplacar la pelusa y evadir la compresión
	allTypes = "* /". concat ("*");

// # 8138, IE puede arrojar una excepción al acceder
// un campo de window.location if document.domain ha sido configurado
tratar {
	ajaxLocation = location.href;
} catch (e) {
	// Usa el atributo href de un elemento A
	// ya que IE lo modificará dado document.location
	ajaxLocation = document.createElement( "a" );
	ajaxLocation.href = "";
	ajaxLocation = ajaxLocation.href;
}

// Segment location into parts
ajaxLocParts = rurl.exec( ajaxLocation.toLowerCase() ) || [];

// Base "constructor" for jQuery.ajaxPrefilter and jQuery.ajaxTransport
función addToPrefiltersOrTransports (estructura) {

	// dataTypeExpression es opcional y su valor predeterminado es "*"
	función de retorno (dataTypeExpression, func) {

		if (typeof dataTypeExpression! == "cadena") {
			func = dataTypeExpression;
			dataTypeExpression = "*";
		}

		var dataType,
			i = 0,
			dataTypes = dataTypeExpression.toLowerCase (). match (rnotwhite) || [];

		if (jQuery.isFunction (func)) {
			// Para cada tipo de datos en dataTypeExpression
			while ((dataType = dataTypes [i ++])) {
				// Anteponer si se solicita
				if (dataType.charAt (0) === "+") {
					dataType = dataType.slice (1) || "*";
					(structure [dataType] = structure [dataType] || []). unshift (func);

				// De lo contrario, anexar
				} else {
					(structure [dataType] = structure [dataType] || []). push (func);
				}
			}
		}
	};
}

// Base inspection function for prefilters and transports
function inspectPrefiltersOrTransports( structure, options, originalOptions, jqXHR ) {

	var inspected = {},
		seekingTransport = ( structure === transports );

	function inspect( dataType ) {
		var selected;
		inspected[ dataType ] = true;
		jQuery.each( structure[ dataType ] || [], function( _, prefilterOrFactory ) {
			var dataTypeOrTransport = prefilterOrFactory( options, originalOptions, jqXHR );
			if ( typeof dataTypeOrTransport === "string" && !seekingTransport && !inspected[ dataTypeOrTransport ] ) {
				options.dataTypes.unshift( dataTypeOrTransport );
				inspect( dataTypeOrTransport );
				return false;
			} else if ( seekingTransport ) {
				return !( selected = dataTypeOrTransport );
			}
		});
		return selected;
	}

	return inspect( options.dataTypes[ 0 ] ) || !inspected[ "*" ] && inspect( "*" );
}

// A special extend for ajax options
// that takes "flat" options (not to be deep extended)
// Fixes #9887
function ajaxExtend( target, src ) {
	var deep, key,
		flatOptions = jQuery.ajaxSettings.flatOptions || {};

	for ( key in src ) {
		if ( src[ key ] !== undefined ) {
			( flatOptions[ key ] ? target : ( deep || (deep = {}) ) )[ key ] = src[ key ];
		}
	}
	if ( deep ) {
		jQuery.extend( true, target, deep );
	}

	return target;
}

/* Handles responses to an ajax request:
 * - finds the right dataType (mediates between content-type and expected dataType)
 * - returns the corresponding response
 */
function ajaxHandleResponses( s, jqXHR, responses ) {
	var firstDataType, ct, finalDataType, type,
		contents = s.contents,
		dataTypes = s.dataTypes;

	// Remove auto dataType and get content-type in the process
	while ( dataTypes[ 0 ] === "*" ) {
		dataTypes.shift();
		if ( ct === undefined ) {
			ct = s.mimeType || jqXHR.getResponseHeader("Content-Type");
		}
	}

	// Check if we're dealing with a known content-type
	if ( ct ) {
		for ( type in contents ) {
			if ( contents[ type ] && contents[ type ].test( ct ) ) {
				dataTypes.unshift( type );
				break;
			}
		}
	}

	// Check to see if we have a response for the expected dataType
	if ( dataTypes[ 0 ] in responses ) {
		finalDataType = dataTypes[ 0 ];
	} else {
		// Try convertible dataTypes
		for ( type in responses ) {
			if ( !dataTypes[ 0 ] || s.converters[ type + " " + dataTypes[0] ] ) {
				finalDataType = type;
				break;
			}
			if ( !firstDataType ) {
				firstDataType = type;
			}
		}
		// Or just use first one
		finalDataType = finalDataType || firstDataType;
	}

	// If we found a dataType
	// We add the dataType to the list if needed
	// and return the corresponding response
	if ( finalDataType ) {
		if ( finalDataType !== dataTypes[ 0 ] ) {
			dataTypes.unshift( finalDataType );
		}
		return responses[ finalDataType ];
	}
}

/* Chain conversions given the request and the original response
 * Also sets the responseXXX fields on the jqXHR instance
 */
function ajaxConvert( s, response, jqXHR, isSuccess ) {
	var conv2, current, conv, tmp, prev,
		converters = {},
		// Work with a copy of dataTypes in case we need to modify it for conversion
		dataTypes = s.dataTypes.slice();

	// Create converters map with lowercased keys
	if ( dataTypes[ 1 ] ) {
		for ( conv in s.converters ) {
			converters[ conv.toLowerCase() ] = s.converters[ conv ];
		}
	}

	current = dataTypes.shift();

	// Convert to each sequential dataType
	while ( current ) {

		if ( s.responseFields[ current ] ) {
			jqXHR[ s.responseFields[ current ] ] = response;
		}

		// Apply the dataFilter if provided
		if ( !prev && isSuccess && s.dataFilter ) {
			response = s.dataFilter( response, s.dataType );
		}

		prev = current;
		current = dataTypes.shift();

		if ( current ) {

			// There's only work to do if current dataType is non-auto
			if ( current === "*" ) {

				current = prev;

			// Convert response if prev dataType is non-auto and differs from current
			} else if ( prev !== "*" && prev !== current ) {

				// Seek a direct converter
				conv = converters[ prev + " " + current ] || converters[ "* " + current ];

				// If none found, seek a pair
				if ( !conv ) {
					for ( conv2 in converters ) {

						// If conv2 outputs current
						tmp = conv2.split( " " );
						if ( tmp[ 1 ] === current ) {

							// If prev can be converted to accepted input
							conv = converters[ prev + " " + tmp[ 0 ] ] ||
								converters[ "* " + tmp[ 0 ] ];
							if ( conv ) {
								// Condense equivalence converters
								if ( conv === true ) {
									conv = converters[ conv2 ];

								// Otherwise, insert the intermediate dataType
								} else if ( converters[ conv2 ] !== true ) {
									current = tmp[ 0 ];
									dataTypes.unshift( tmp[ 1 ] );
								}
								break;
							}
						}
					}
				}

				// Apply converter (if not an equivalence)
				if ( conv !== true ) {

					// Unless errors are allowed to bubble, catch and return them
					if ( conv && s[ "throws" ] ) {
						response = conv( response );
					} else {
						try {
							response = conv( response );
						} catch ( e ) {
							return { state: "parsererror", error: conv ? e : "No conversion from " + prev + " to " + current };
						}
					}
				}
			}
		}
	}

	return { state: "success", data: response };
}

jQuery.extend({

	// Counter for holding the number of active queries
	active: 0,

	// Last-Modified header cache for next request
	lastModified: {},
	etag: {},

	ajaxSettings: {
		url: ajaxLocation,
		type: "GET",
		isLocal: rlocalProtocol.test( ajaxLocParts[ 1 ] ),
		global: true,
		processData: true,
		async: true,
		contentType: "application/x-www-form-urlencoded; charset=UTF-8",
		/*
		timeout: 0,
		data: null,
		dataType: null,
		username: null,
		password: null,
		cache: null,
		throws: false,
		traditional: false,
		headers: {},
		*/

		accepts: {
			"*": allTypes,
			text: "text/plain",
			html: "text/html",
			xml: "application/xml, text/xml",
			json: "application/json, text/javascript"
		},

		contents: {
			xml: /xml/,
			html: /html/,
			json: /json/
		},

		responseFields: {
			xml: "responseXML",
			text: "responseText",
			json: "responseJSON"
		},

		// Data converters
		// Keys separate source (or catchall "*") and destination types with a single space
		converters: {

			// Convert anything to text
			"* text": String,

			// Text to html (true = no transformation)
			"text html": true,

			// Evaluate text as a json expression
			"text json": jQuery.parseJSON,

			// Parse text as xml
			"text xml": jQuery.parseXML
		},

		// For options that shouldn't be deep extended:
		// you can add your own custom options here if
		// and when you create one that shouldn't be
		// deep extended (see ajaxExtend)
		flatOptions: {
			url: true,
			context: true
		}
	},

	// Creates a full fledged settings object into target
	// with both ajaxSettings and settings fields.
	// If target is omitted, writes into ajaxSettings.
	ajaxSetup: function( target, settings ) {
		return settings ?

			// Building a settings object
			ajaxExtend( ajaxExtend( target, jQuery.ajaxSettings ), settings ) :

			// Extending ajaxSettings
			ajaxExtend( jQuery.ajaxSettings, target );
	},

	ajaxPrefilter: addToPrefiltersOrTransports( prefilters ),
	ajaxTransport: addToPrefiltersOrTransports( transports ),

	// Main method
	ajax: function( url, options ) {

		// If url is an object, simulate pre-1.5 signature
		if ( typeof url === "object" ) {
			options = url;
			url = undefined;
		}

		// Force options to be an object
		options = options || {};

		var // Cross-domain detection vars
			parts,
			// Loop variable
			i,
			// URL without anti-cache param
			cacheURL,
			// Response headers as string
			responseHeadersString,
			// timeout handle
			timeoutTimer,

			// To know if global events are to be dispatched
			fireGlobals,

			transport,
			// Response headers
			responseHeaders,
			// Create the final options object
			s = jQuery.ajaxSetup( {}, options ),
			// Callbacks context
			callbackContext = s.context || s,
			// Context for global events is callbackContext if it is a DOM node or jQuery collection
			globalEventContext = s.context && ( callbackContext.nodeType || callbackContext.jquery ) ?
				jQuery( callbackContext ) :
				jQuery.event,
			// Deferreds
			deferred = jQuery.Deferred(),
			completeDeferred = jQuery.Callbacks("once memory"),
			// Status-dependent callbacks
			statusCode = s.statusCode || {},
			// Headers (they are sent all at once)
			requestHeaders = {},
			requestHeadersNames = {},
			// The jqXHR state
			state = 0,
			// Default abort message
			strAbort = "canceled",
			// Fake xhr
			jqXHR = {
				readyState: 0,

				// Builds headers hashtable if needed
				getResponseHeader: function( key ) {
					var match;
					if ( state === 2 ) {
						if ( !responseHeaders ) {
							responseHeaders = {};
							while ( (match = rheaders.exec( responseHeadersString )) ) {
								responseHeaders[ match[1].toLowerCase() ] = match[ 2 ];
							}
						}
						match = responseHeaders[ key.toLowerCase() ];
					}
					return match == null ? null : match;
				},

				// Raw string
				getAllResponseHeaders: function() {
					return state === 2 ? responseHeadersString : null;
				},

				// Caches the header
				setRequestHeader: function( name, value ) {
					var lname = name.toLowerCase();
					if ( !state ) {
						name = requestHeadersNames[ lname ] = requestHeadersNames[ lname ] || name;
						requestHeaders[ name ] = value;
					}
					return this;
				},

				// Overrides response content-type header
				overrideMimeType: function( type ) {
					if ( !state ) {
						s.mimeType = type;
					}
					return this;
				},

				// Status-dependent callbacks
				statusCode: function( map ) {
					var code;
					if ( map ) {
						if ( state < 2 ) {
							for ( code in map ) {
								// Lazy-add the new callback in a way that preserves old ones
								statusCode[ code ] = [ statusCode[ code ], map[ code ] ];
							}
						} else {
							// Execute the appropriate callbacks
							jqXHR.always( map[ jqXHR.status ] );
						}
					}
					return this;
				},

				// Cancel the request
				abort: function( statusText ) {
					var finalText = statusText || strAbort;
					if ( transport ) {
						transport.abort( finalText );
					}
					done( 0, finalText );
					return this;
				}
			};

		// Attach deferreds
		deferred.promise( jqXHR ).complete = completeDeferred.add;
		jqXHR.success = jqXHR.done;
		jqXHR.error = jqXHR.fail;

		// Remove hash character (#7531: and string promotion)
		// Add protocol if not provided (#5866: IE7 issue with protocol-less urls)
		// Handle falsy url in the settings object (#10093: consistency with old signature)
		// We also use the url parameter if available
		s.url = ( ( url || s.url || ajaxLocation ) + "" ).replace( rhash, "" ).replace( rprotocol, ajaxLocParts[ 1 ] + "//" );

		// Alias method option to type as per ticket #12004
		s.type = options.method || options.type || s.method || s.type;

		// Extract dataTypes list
		s.dataTypes = jQuery.trim( s.dataType || "*" ).toLowerCase().match( rnotwhite ) || [ "" ];

		// A cross-domain request is in order when we have a protocol:host:port mismatch
		if ( s.crossDomain == null ) {
			parts = rurl.exec( s.url.toLowerCase() );
			s.crossDomain = !!( parts &&
				( parts[ 1 ] !== ajaxLocParts[ 1 ] || parts[ 2 ] !== ajaxLocParts[ 2 ] ||
					( parts[ 3 ] || ( parts[ 1 ] === "http:" ? "80" : "443" ) ) !==
						( ajaxLocParts[ 3 ] || ( ajaxLocParts[ 1 ] === "http:" ? "80" : "443" ) ) )
			);
		}

		// Convert data if not already a string
		if ( s.data && s.processData && typeof s.data !== "string" ) {
			s.data = jQuery.param( s.data, s.traditional );
		}

		// Apply prefilters
		inspectPrefiltersOrTransports( prefilters, s, options, jqXHR );

		// If request was aborted inside a prefilter, stop there
		if ( state === 2 ) {
			return jqXHR;
		}

		// We can fire global events as of now if asked to
		fireGlobals = s.global;

		// Watch for a new set of requests
		if ( fireGlobals && jQuery.active++ === 0 ) {
			jQuery.event.trigger("ajaxStart");
		}

		// Uppercase the type
		s.type = s.type.toUpperCase();

		// Determine if request has content
		s.hasContent = !rnoContent.test( s.type );

		// Save the URL in case we're toying with the If-Modified-Since
		// and/or If-None-Match header later on
		cacheURL = s.url;

		// More options handling for requests with no content
		if ( !s.hasContent ) {

			// If data is available, append data to url
			if ( s.data ) {
				cacheURL = ( s.url += ( rquery.test( cacheURL ) ? "&" : "?" ) + s.data );
				// #9682: remove data so that it's not used in an eventual retry
				delete s.data;
			}

			// Add anti-cache in url if needed
			if ( s.cache === false ) {
				s.url = rts.test( cacheURL ) ?

					// If there is already a '_' parameter, set its value
					cacheURL.replace( rts, "$1_=" + nonce++ ) :

					// Otherwise add one to the end
					cacheURL + ( rquery.test( cacheURL ) ? "&" : "?" ) + "_=" + nonce++;
			}
		}

		// Set the If-Modified-Since and/or If-None-Match header, if in ifModified mode.
		if ( s.ifModified ) {
			if ( jQuery.lastModified[ cacheURL ] ) {
				jqXHR.setRequestHeader( "If-Modified-Since", jQuery.lastModified[ cacheURL ] );
			}
			if ( jQuery.etag[ cacheURL ] ) {
				jqXHR.setRequestHeader( "If-None-Match", jQuery.etag[ cacheURL ] );
			}
		}

		// Set the correct header, if data is being sent
		if ( s.data && s.hasContent && s.contentType !== false || options.contentType ) {
			jqXHR.setRequestHeader( "Content-Type", s.contentType );
		}

		// Set the Accepts header for the server, depending on the dataType
		jqXHR.setRequestHeader(
			"Accept",
			s.dataTypes[ 0 ] && s.accepts[ s.dataTypes[0] ] ?
				s.accepts[ s.dataTypes[0] ] + ( s.dataTypes[ 0 ] !== "*" ? ", " + allTypes + "; q=0.01" : "" ) :
				s.accepts[ "*" ]
		);

		// Check for headers option
		for ( i in s.headers ) {
			jqXHR.setRequestHeader( i, s.headers[ i ] );
		}

		// Allow custom headers/mimetypes and early abort
		if ( s.beforeSend && ( s.beforeSend.call( callbackContext, jqXHR, s ) === false || state === 2 ) ) {
			// Abort if not done already and return
			return jqXHR.abort();
		}

		// aborting is no longer a cancellation
		strAbort = "abort";

		// Install callbacks on deferreds
		for ( i in { success: 1, error: 1, complete: 1 } ) {
			jqXHR[ i ]( s[ i ] );
		}

		// Get transport
		transport = inspectPrefiltersOrTransports( transports, s, options, jqXHR );

		// If no transport, we auto-abort
		if ( !transport ) {
			done( -1, "No Transport" );
		} else {
			jqXHR.readyState = 1;

			// Send global event
			if ( fireGlobals ) {
				globalEventContext.trigger( "ajaxSend", [ jqXHR, s ] );
			}
			// Timeout
			if ( s.async && s.timeout > 0 ) {
				timeoutTimer = setTimeout(function() {
					jqXHR.abort("timeout");
				}, s.timeout );
			}

			try {
				state = 1;
				transport.send( requestHeaders, done );
			} catch ( e ) {
				// Propagate exception as error if not done
				if ( state < 2 ) {
					done( -1, e );
				// Simply rethrow otherwise
				} else {
					throw e;
				}
			}
		}

		// Callback for when everything is done
		function done( status, nativeStatusText, responses, headers ) {
			var isSuccess, success, error, response, modified,
				statusText = nativeStatusText;

			// Called once
			if ( state === 2 ) {
				return;
			}

			// State is "done" now
			state = 2;

			// Clear timeout if it exists
			if ( timeoutTimer ) {
				clearTimeout( timeoutTimer );
			}

			// Dereference transport for early garbage collection
			// (no matter how long the jqXHR object will be used)
			transport = undefined;

			// Cache response headers
			responseHeadersString = headers || "";

			// Set readyState
			jqXHR.readyState = status > 0 ? 4 : 0;

			// Determine if successful
			isSuccess = status >= 200 && status < 300 || status === 304;

			// Get response data
			if ( responses ) {
				response = ajaxHandleResponses( s, jqXHR, responses );
			}

			// Convert no matter what (that way responseXXX fields are always set)
			response = ajaxConvert( s, response, jqXHR, isSuccess );

			// If successful, handle type chaining
			if ( isSuccess ) {

				// Set the If-Modified-Since and/or If-None-Match header, if in ifModified mode.
				if ( s.ifModified ) {
					modified = jqXHR.getResponseHeader("Last-Modified");
					if ( modified ) {
						jQuery.lastModified[ cacheURL ] = modified;
					}
					modified = jqXHR.getResponseHeader("etag");
					if ( modified ) {
						jQuery.etag[ cacheURL ] = modified;
					}
				}

				// if no content
				if ( status === 204 || s.type === "HEAD" ) {
					statusText = "nocontent";

				// if not modified
				} else if ( status === 304 ) {
					statusText = "notmodified";

				// If we have data, let's convert it
				} else {
					statusText = response.state;
					success = response.data;
					error = response.error;
					isSuccess = !error;
				}
			} else {
				// We extract error from statusText
				// then normalize statusText and status for non-aborts
				error = statusText;
				if ( status || !statusText ) {
					statusText = "error";
					if ( status < 0 ) {
						status = 0;
					}
				}
			}

			// Set data for the fake xhr object
			jqXHR.status = status;
			jqXHR.statusText = ( nativeStatusText || statusText ) + "";

			// Success/Error
			if ( isSuccess ) {
				deferred.resolveWith( callbackContext, [ success, statusText, jqXHR ] );
			} else {
				deferred.rejectWith( callbackContext, [ jqXHR, statusText, error ] );
			}

			// Status-dependent callbacks
			jqXHR.statusCode( statusCode );
			statusCode = undefined;

			if ( fireGlobals ) {
				globalEventContext.trigger( isSuccess ? "ajaxSuccess" : "ajaxError",
					[ jqXHR, s, isSuccess ? success : error ] );
			}

			// Complete
			completeDeferred.fireWith( callbackContext, [ jqXHR, statusText ] );

			if ( fireGlobals ) {
				globalEventContext.trigger( "ajaxComplete", [ jqXHR, s ] );
				// Handle the global AJAX counter
				if ( !( --jQuery.active ) ) {
					jQuery.event.trigger("ajaxStop");
				}
			}
		}

		return jqXHR;
	},

	getJSON: function( url, data, callback ) {
		return jQuery.get( url, data, callback, "json" );
	},

	getScript: function( url, callback ) {
		return jQuery.get( url, undefined, callback, "script" );
	}
});

jQuery.each( [ "get", "post" ], function( i, method ) {
	jQuery[ method ] = function( url, data, callback, type ) {
		// shift arguments if data argument was omitted
		if ( jQuery.isFunction( data ) ) {
			type = type || callback;
			callback = data;
			data = undefined;
		}

		return jQuery.ajax({
			url: url,
			type: method,
			dataType: type,
			data: data,
			success: callback
		});
	};
});

// Attach a bunch of functions for handling common AJAX events
jQuery.each( [ "ajaxStart", "ajaxStop", "ajaxComplete", "ajaxError", "ajaxSuccess", "ajaxSend" ], function( i, type ) {
	jQuery.fn[ type ] = function( fn ) {
		return this.on( type, fn );
	};
});


jQuery._evalUrl = function( url ) {
	return jQuery.ajax({
		url: url,
		type: "GET",
		dataType: "script",
		async: false,
		global: false,
		"throws": true
	});
};


jQuery.fn.extend({
	wrapAll: function( html ) {
		if ( jQuery.isFunction( html ) ) {
			return this.each(function(i) {
				jQuery(this).wrapAll( html.call(this, i) );
			});
		}

		if ( this[0] ) {
			// The elements to wrap the target around
			var wrap = jQuery( html, this[0].ownerDocument ).eq(0).clone(true);

			if ( this[0].parentNode ) {
				wrap.insertBefore( this[0] );
			}

			wrap.map(function() {
				var elem = this;

				while ( elem.firstChild && elem.firstChild.nodeType === 1 ) {
					elem = elem.firstChild;
				}

				return elem;
			}).append( this );
		}

		return this;
	},

	wrapInner: function( html ) {
		if ( jQuery.isFunction( html ) ) {
			return this.each(function(i) {
				jQuery(this).wrapInner( html.call(this, i) );
			});
		}

		return this.each(function() {
			var self = jQuery( this ),
				contents = self.contents();

			if ( contents.length ) {
				contents.wrapAll( html );

			} else {
				self.append( html );
			}
		});
	},

	wrap: function( html ) {
		var isFunction = jQuery.isFunction( html );

		return this.each(function(i) {
			jQuery( this ).wrapAll( isFunction ? html.call(this, i) : html );
		});
	},

	unwrap: function() {
		return this.parent().each(function() {
			if ( !jQuery.nodeName( this, "body" ) ) {
				jQuery( this ).replaceWith( this.childNodes );
			}
		}).end();
	}
});


jQuery.expr.filters.hidden = function( elem ) {
	// Support: Opera <= 12.12
	// Opera reports offsetWidths and offsetHeights less than zero on some elements
	return elem.offsetWidth <= 0 && elem.offsetHeight <= 0 ||
		(!support.reliableHiddenOffsets() &&
			((elem.style && elem.style.display) || jQuery.css( elem, "display" )) === "none");
};

jQuery.expr.filters.visible = function( elem ) {
	return !jQuery.expr.filters.hidden( elem );
};




var r20 = /%20/g,
	rbracket = /\[\]$/,
	rCRLF = /\r?\n/g,
	rsubmitterTypes = /^(?:submit|button|image|reset|file)$/i,
	rsubmittable = /^(?:input|select|textarea|keygen)/i;

function buildParams( prefix, obj, traditional, add ) {
	var name;

	if ( jQuery.isArray( obj ) ) {
		// Serialize array item.
		jQuery.each( obj, function( i, v ) {
			if ( traditional || rbracket.test( prefix ) ) {
				// Treat each array item as a scalar.
				add( prefix, v );

			} else {
				// Item is non-scalar (array or object), encode its numeric index.
				buildParams( prefix + "[" + ( typeof v === "object" ? i : "" ) + "]", v, traditional, add );
			}
		});

	} else if ( !traditional && jQuery.type( obj ) === "object" ) {
		// Serialize object item.
		for ( name in obj ) {
			buildParams( prefix + "[" + name + "]", obj[ name ], traditional, add );
		}

	} else {
		// Serialize scalar item.
		add( prefix, obj );
	}
}

// Serialize an array of form elements or a set of
// key/values into a query string
jQuery.param = function( a, traditional ) {
	var prefix,
		s = [],
		add = function( key, value ) {
			// If value is a function, invoke it and return its value
			value = jQuery.isFunction( value ) ? value() : ( value == null ? "" : value );
			s[ s.length ] = encodeURIComponent( key ) + "=" + encodeURIComponent( value );
		};

	// Set traditional to true for jQuery <= 1.3.2 behavior.
	if ( traditional === undefined ) {
		traditional = jQuery.ajaxSettings && jQuery.ajaxSettings.traditional;
	}

	// If an array was passed in, assume that it is an array of form elements.
	if ( jQuery.isArray( a ) || ( a.jquery && !jQuery.isPlainObject( a ) ) ) {
		// Serialize the form elements
		jQuery.each( a, function() {
			add( this.name, this.value );
		});

	} else {
		// If traditional, encode the "old" way (the way 1.3.2 or older
		// did it), otherwise encode params recursively.
		for ( prefix in a ) {
			buildParams( prefix, a[ prefix ], traditional, add );
		}
	}

	// Return the resulting serialization
	return s.join( "&" ).replace( r20, "+" );
};

jQuery.fn.extend({
	serialize: function() {
		return jQuery.param( this.serializeArray() );
	},
	serializeArray: function() {
		return this.map(function() {
			// Can add propHook for "elements" to filter or add form elements
			var elements = jQuery.prop( this, "elements" );
			return elements ? jQuery.makeArray( elements ) : this;
		})
		.filter(function() {
			var type = this.type;
			// Use .is(":disabled") so that fieldset[disabled] works
			return this.name && !jQuery( this ).is( ":disabled" ) &&
				rsubmittable.test( this.nodeName ) && !rsubmitterTypes.test( type ) &&
				( this.checked || !rcheckableType.test( type ) );
		})
		.map(function( i, elem ) {
			var val = jQuery( this ).val();

			return val == null ?
				null :
				jQuery.isArray( val ) ?
					jQuery.map( val, function( val ) {
						return { name: elem.name, value: val.replace( rCRLF, "\r\n" ) };
					}) :
					{ name: elem.name, value: val.replace( rCRLF, "\r\n" ) };
		}).get();
	}
});


// Create the request object
// (This is still attached to ajaxSettings for backward compatibility)
jQuery.ajaxSettings.xhr = window.ActiveXObject !== undefined ?
	// Support: IE6+
	function() {

		// XHR cannot access local files, always use ActiveX for that case
		return !this.isLocal &&

			// Support: IE7-8
			// oldIE XHR does not support non-RFC2616 methods (#13240)
			// See http://msdn.microsoft.com/en-us/library/ie/ms536648(v=vs.85).aspx
			// and http://www.w3.org/Protocols/rfc2616/rfc2616-sec9.html#sec9
			// Although this check for six methods instead of eight
			// since IE also does not support "trace" and "connect"
			/^(get|post|head|put|delete|options)$/i.test( this.type ) &&

			createStandardXHR() || createActiveXHR();
	} :
	// For all other browsers, use the standard XMLHttpRequest object
	createStandardXHR;

var xhrId = 0,
	xhrCallbacks = {},
	xhrSupported = jQuery.ajaxSettings.xhr();

// Support: IE<10
// Open requests must be manually aborted on unload (#5280)
if ( window.ActiveXObject ) {
	jQuery( window ).on( "unload", function() {
		for ( var key in xhrCallbacks ) {
			xhrCallbacks[ key ]( undefined, true );
		}
	});
}

// Determine support properties
support.cors = !!xhrSupported && ( "withCredentials" in xhrSupported );
xhrSupported = support.ajax = !!xhrSupported;

// Create transport if the browser can provide an xhr
if ( xhrSupported ) {

	jQuery.ajaxTransport(function( options ) {
		// Cross domain only allowed if supported through XMLHttpRequest
		if ( !options.crossDomain || support.cors ) {

			var callback;

			return {
				send: function( headers, complete ) {
					var i,
						xhr = options.xhr(),
						id = ++xhrId;

					// Open the socket
					xhr.open( options.type, options.url, options.async, options.username, options.password );

					// Apply custom fields if provided
					if ( options.xhrFields ) {
						for ( i in options.xhrFields ) {
							xhr[ i ] = options.xhrFields[ i ];
						}
					}

					// Override mime type if needed
					if ( options.mimeType && xhr.overrideMimeType ) {
						xhr.overrideMimeType( options.mimeType );
					}

					// X-Requested-With header
					// For cross-domain requests, seeing as conditions for a preflight are
					// akin to a jigsaw puzzle, we simply never set it to be sure.
					// (it can always be set on a per-request basis or even using ajaxSetup)
					// For same-domain requests, won't change header if already provided.
					if ( !options.crossDomain && !headers["X-Requested-With"] ) {
						headers["X-Requested-With"] = "XMLHttpRequest";
					}

					// Set headers
					for ( i in headers ) {
						// Support: IE<9
						// IE's ActiveXObject throws a 'Type Mismatch' exception when setting
						// request header to a null-value.
						//
						// To keep consistent with other XHR implementations, cast the value
						// to string and ignore `undefined`.
						if ( headers[ i ] !== undefined ) {
							xhr.setRequestHeader( i, headers[ i ] + "" );
						}
					}

					// Do send the request
					// This may raise an exception which is actually
					// handled in jQuery.ajax (so no try/catch here)
					xhr.send( ( options.hasContent && options.data ) || null );

					// Listener
					callback = function( _, isAbort ) {
						var status, statusText, responses;

						// Was never called and is aborted or complete
						if ( callback && ( isAbort || xhr.readyState === 4 ) ) {
							// Clean up
							delete xhrCallbacks[ id ];
							callback = undefined;
							xhr.onreadystatechange = jQuery.noop;

							// Abort manually if needed
							if ( isAbort ) {
								if ( xhr.readyState !== 4 ) {
									xhr.abort();
								}
							} else {
								responses = {};
								status = xhr.status;

								// Support: IE<10
								// Accessing binary-data responseText throws an exception
								// (#11426)
								if ( typeof xhr.responseText === "string" ) {
									responses.text = xhr.responseText;
								}

								// Firefox throws an exception when accessing
								// statusText for faulty cross-domain requests
								try {
									statusText = xhr.statusText;
								} catch( e ) {
									// We normalize with Webkit giving an empty statusText
									statusText = "";
								}

								// Filter status for non standard behaviors

								// If the request is local and we have data: assume a success
								// (success with no data won't get notified, that's the best we
								// can do given current implementations)
								if ( !status && options.isLocal && !options.crossDomain ) {
									status = responses.text ? 200 : 404;
								// IE - #1450: sometimes returns 1223 when it should be 204
								} else if ( status === 1223 ) {
									status = 204;
								}
							}
						}

						// Call complete if needed
						if ( responses ) {
							complete( status, statusText, responses, xhr.getAllResponseHeaders() );
						}
					};

					if ( !options.async ) {
						// if we're in sync mode we fire the callback
						callback();
					} else if ( xhr.readyState === 4 ) {
						// (IE6 & IE7) if it's in cache and has been
						// retrieved directly we need to fire the callback
						setTimeout( callback );
					} else {
						// Add to the list of active xhr callbacks
						xhr.onreadystatechange = xhrCallbacks[ id ] = callback;
					}
				},

				abort: function() {
					if ( callback ) {
						callback( undefined, true );
					}
				}
			};
		}
	});
}

// Functions to create xhrs
function createStandardXHR() {
	try {
		return new window.XMLHttpRequest();
	} catch( e ) {}
}

function createActiveXHR() {
	try {
		return new window.ActiveXObject( "Microsoft.XMLHTTP" );
	} catch( e ) {}
}




// Install script dataType
jQuery.ajaxSetup({
	accepts: {
		script: "text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"
	},
	contents: {
		script: /(?:java|ecma)script/
	},
	converters: {
		"text script": function( text ) {
			jQuery.globalEval( text );
			return text;
		}
	}
});

// Handle cache's special case and global
jQuery.ajaxPrefilter( "script", function( s ) {
	if ( s.cache === undefined ) {
		s.cache = false;
	}
	if ( s.crossDomain ) {
		s.type = "GET";
		s.global = false;
	}
});

// Bind script tag hack transport
jQuery.ajaxTransport( "script", function(s) {

	// This transport only deals with cross domain requests
	if ( s.crossDomain ) {

		var script,
			head = document.head || jQuery("head")[0] || document.documentElement;

		return {

			send: function( _, callback ) {

				script = document.createElement("script");

				script.async = true;

				if ( s.scriptCharset ) {
					script.charset = s.scriptCharset;
				}

				script.src = s.url;

				// Attach handlers for all browsers
				script.onload = script.onreadystatechange = function( _, isAbort ) {

					if ( isAbort || !script.readyState || /loaded|complete/.test( script.readyState ) ) {

						// Handle memory leak in IE
						script.onload = script.onreadystatechange = null;

						// Remove the script
						if ( script.parentNode ) {
							script.parentNode.removeChild( script );
						}

						// Dereference the script
						script = null;

						// Callback if not abort
						if ( !isAbort ) {
							callback( 200, "success" );
						}
					}
				};

				// Circumvent IE6 bugs with base elements (#2709 and #4378) by prepending
				// Use native DOM manipulation to avoid our domManip AJAX trickery
				head.insertBefore( script, head.firstChild );
			},

			abort: function() {
				if ( script ) {
					script.onload( undefined, true );
				}
			}
		};
	}
});




var oldCallbacks = [],
	rjsonp = /(=)\?(?=&|$)|\?\?/;

// Default jsonp settings
jQuery.ajaxSetup({
	jsonp: "callback",
	jsonpCallback: function() {
		var callback = oldCallbacks.pop() || ( jQuery.expando + "_" + ( nonce++ ) );
		this[ callback ] = true;
		return callback;
	}
});

// Detect, normalize options and install callbacks for jsonp requests
jQuery.ajaxPrefilter( "json jsonp", function( s, originalSettings, jqXHR ) {

	var callbackName, overwritten, responseContainer,
		jsonProp = s.jsonp !== false && ( rjsonp.test( s.url ) ?
			"url" :
			typeof s.data === "string" && !( s.contentType || "" ).indexOf("application/x-www-form-urlencoded") && rjsonp.test( s.data ) && "data"
		);

	// Handle iff the expected data type is "jsonp" or we have a parameter to set
	if ( jsonProp || s.dataTypes[ 0 ] === "jsonp" ) {

		// Get callback name, remembering preexisting value associated with it
		callbackName = s.jsonpCallback = jQuery.isFunction( s.jsonpCallback ) ?
			s.jsonpCallback() :
			s.jsonpCallback;

		// Insert callback into url or form data
		if ( jsonProp ) {
			s[ jsonProp ] = s[ jsonProp ].replace( rjsonp, "$1" + callbackName );
		} else if ( s.jsonp !== false ) {
			s.url += ( rquery.test( s.url ) ? "&" : "?" ) + s.jsonp + "=" + callbackName;
		}

		// Use data converter to retrieve json after script execution
		s.converters["script json"] = function() {
			if ( !responseContainer ) {
				jQuery.error( callbackName + " was not called" );
			}
			return responseContainer[ 0 ];
		};

		// force json dataType
		s.dataTypes[ 0 ] = "json";

		// Install callback
		overwritten = window[ callbackName ];
		window[ callbackName ] = function() {
			responseContainer = arguments;
		};

		// Clean-up function (fires after converters)
		jqXHR.always(function() {
			// Restore preexisting value
			window[ callbackName ] = overwritten;

			// Save back as free
			if ( s[ callbackName ] ) {
				// make sure that re-using the options doesn't screw things around
				s.jsonpCallback = originalSettings.jsonpCallback;

				// save the callback name for future use
				oldCallbacks.push( callbackName );
			}

			// Call if it was a function and we have a response
			if ( responseContainer && jQuery.isFunction( overwritten ) ) {
				overwritten( responseContainer[ 0 ] );
			}

			responseContainer = overwritten = undefined;
		});

		// Delegate to script
		return "script";
	}
});




// data: string of html
// context (optional): If specified, the fragment will be created in this context, defaults to document
// keepScripts (optional): If true, will include scripts passed in the html string
jQuery.parseHTML = function( data, context, keepScripts ) {
	if ( !data || typeof data !== "string" ) {
		return null;
	}
	if ( typeof context === "boolean" ) {
		keepScripts = context;
		context = false;
	}
	context = context || document;

	var parsed = rsingleTag.exec( data ),
		scripts = !keepScripts && [];

	// Single tag
	if ( parsed ) {
		return [ context.createElement( parsed[1] ) ];
	}

	parsed = jQuery.buildFragment( [ data ], context, scripts );

	if ( scripts && scripts.length ) {
		jQuery( scripts ).remove();
	}

	return jQuery.merge( [], parsed.childNodes );
};


// Keep a copy of the old load method
var _load = jQuery.fn.load;

/**
 * Load a url into a page
 */
jQuery.fn.load = function( url, params, callback ) {
	if ( typeof url !== "string" && _load ) {
		return _load.apply( this, arguments );
	}

	var selector, response, type,
		self = this,
		off = url.indexOf(" ");

	if ( off >= 0 ) {
		selector = jQuery.trim( url.slice( off, url.length ) );
		url = url.slice( 0, off );
	}

	// If it's a function
	if ( jQuery.isFunction( params ) ) {

		// We assume that it's the callback
		callback = params;
		params = undefined;

	// Otherwise, build a param string
	} else if ( params && typeof params === "object" ) {
		type = "POST";
	}

	// If we have elements to modify, make the request
	if ( self.length > 0 ) {
		jQuery.ajax({
			url: url,

			// if "type" variable is undefined, then "GET" method will be used
			type: type,
			dataType: "html",
			data: params
		}).done(function( responseText ) {

			// Save response for use in complete callback
			response = arguments;

			self.html( selector ?

				// If a selector was specified, locate the right elements in a dummy div
				// Exclude scripts to avoid IE 'Permission Denied' errors
				jQuery("<div>").append( jQuery.parseHTML( responseText ) ).find( selector ) :

				// Otherwise use the full result
				responseText );

		}).complete( callback && function( jqXHR, status ) {
			self.each( callback, response || [ jqXHR.responseText, status, jqXHR ] );
		});
	}

	return this;
};




jQuery.expr.filters.animated = function( elem ) {
	return jQuery.grep(jQuery.timers, function( fn ) {
		return elem === fn.elem;
	}).length;
};





var docElem = window.document.documentElement;

/**
 * Gets a window from an element
 */
function getWindow( elem ) {
	return jQuery.isWindow( elem ) ?
		elem :
		elem.nodeType === 9 ?
			elem.defaultView || elem.parentWindow :
			false;
}

jQuery.offset = {
	setOffset: function( elem, options, i ) {
		var curPosition, curLeft, curCSSTop, curTop, curOffset, curCSSLeft, calculatePosition,
			position = jQuery.css( elem, "position" ),
			curElem = jQuery( elem ),
			props = {};

		// set position first, in-case top/left are set even on static elem
		if ( position === "static" ) {
			elem.style.position = "relative";
		}

		curOffset = curElem.offset();
		curCSSTop = jQuery.css( elem, "top" );
		curCSSLeft = jQuery.css( elem, "left" );
		calculatePosition = ( position === "absolute" || position === "fixed" ) &&
			jQuery.inArray("auto", [ curCSSTop, curCSSLeft ] ) > -1;

		// need to be able to calculate position if either top or left is auto and position is either absolute or fixed
		if ( calculatePosition ) {
			curPosition = curElem.position();
			curTop = curPosition.top;
			curLeft = curPosition.left;
		} else {
			curTop = parseFloat( curCSSTop ) || 0;
			curLeft = parseFloat( curCSSLeft ) || 0;
		}

		if ( jQuery.isFunction( options ) ) {
			options = options.call( elem, i, curOffset );
		}

		if ( options.top != null ) {
			props.top = ( options.top - curOffset.top ) + curTop;
		}
		if ( options.left != null ) {
			props.left = ( options.left - curOffset.left ) + curLeft;
		}

		if ( "using" in options ) {
			options.using.call( elem, props );
		} else {
			curElem.css( props );
		}
	}
};

jQuery.fn.extend({
	offset: function( options ) {
		if ( arguments.length ) {
			return options === undefined ?
				this :
				this.each(function( i ) {
					jQuery.offset.setOffset( this, options, i );
				});
		}

		var docElem, win,
			box = { top: 0, left: 0 },
			elem = this[ 0 ],
			doc = elem && elem.ownerDocument;

		if ( !doc ) {
			return;
		}

		docElem = doc.documentElement;

		// Make sure it's not a disconnected DOM node
		if ( !jQuery.contains( docElem, elem ) ) {
			return box;
		}

		// If we don't have gBCR, just use 0,0 rather than error
		// BlackBerry 5, iOS 3 (original iPhone)
		if ( typeof elem.getBoundingClientRect !== strundefined ) {
			box = elem.getBoundingClientRect();
		}
		win = getWindow( doc );
		return {
			top: box.top  + ( win.pageYOffset || docElem.scrollTop )  - ( docElem.clientTop  || 0 ),
			left: box.left + ( win.pageXOffset || docElem.scrollLeft ) - ( docElem.clientLeft || 0 )
		};
	},

	position: function() {
		if ( !this[ 0 ] ) {
			return;
		}

		var offsetParent, offset,
			parentOffset = { top: 0, left: 0 },
			elem = this[ 0 ];

		// fixed elements are offset from window (parentOffset = {top:0, left: 0}, because it is its only offset parent
		if ( jQuery.css( elem, "position" ) === "fixed" ) {
			// we assume that getBoundingClientRect is available when computed position is fixed
			offset = elem.getBoundingClientRect();
		} else {
			// Get *real* offsetParent
			offsetParent = this.offsetParent();

			// Get correct offsets
			offset = this.offset();
			if ( !jQuery.nodeName( offsetParent[ 0 ], "html" ) ) {
				parentOffset = offsetParent.offset();
			}

			// Add offsetParent borders
			parentOffset.top  += jQuery.css( offsetParent[ 0 ], "borderTopWidth", true );
			parentOffset.left += jQuery.css( offsetParent[ 0 ], "borderLeftWidth", true );
		}

		// Subtract parent offsets and element margins
		// note: when an element has margin: auto the offsetLeft and marginLeft
		// are the same in Safari causing offset.left to incorrectly be 0
		return {
			top:  offset.top  - parentOffset.top - jQuery.css( elem, "marginTop", true ),
			left: offset.left - parentOffset.left - jQuery.css( elem, "marginLeft", true)
		};
	},

	offsetParent: function() {
		return this.map(function() {
			var offsetParent = this.offsetParent || docElem;

			while ( offsetParent && ( !jQuery.nodeName( offsetParent, "html" ) && jQuery.css( offsetParent, "position" ) === "static" ) ) {
				offsetParent = offsetParent.offsetParent;
			}
			return offsetParent || docElem;
		});
	}
});

// Create scrollLeft and scrollTop methods
jQuery.each( { scrollLeft: "pageXOffset", scrollTop: "pageYOffset" }, function( method, prop ) {
	var top = /Y/.test( prop );

	jQuery.fn[ method ] = function( val ) {
		return access( this, function( elem, method, val ) {
			var win = getWindow( elem );

			if ( val === undefined ) {
				return win ? (prop in win) ? win[ prop ] :
					win.document.documentElement[ method ] :
					elem[ method ];
			}

			if ( win ) {
				win.scrollTo(
					!top ? val : jQuery( win ).scrollLeft(),
					top ? val : jQuery( win ).scrollTop()
				);

			} else {
				elem[ method ] = val;
			}
		}, method, val, arguments.length, null );
	};
});

// Add the top/left cssHooks using jQuery.fn.position
// Webkit bug: https://bugs.webkit.org/show_bug.cgi?id=29084
// getComputedStyle returns percent when specified for top/left/bottom/right
// rather than make the css module depend on the offset module, we just check for it here
jQuery.each( [ "top", "left" ], function( i, prop ) {
	jQuery.cssHooks[ prop ] = addGetHookIf( support.pixelPosition,
		function( elem, computed ) {
			if ( computed ) {
				computed = curCSS( elem, prop );
				// if curCSS returns percentage, fallback to offset
				return rnumnonpx.test( computed ) ?
					jQuery( elem ).position()[ prop ] + "px" :
					computed;
			}
		}
	);
});


// Create innerHeight, innerWidth, height, width, outerHeight and outerWidth methods
jQuery.each( { Height: "height", Width: "width" }, function( name, type ) {
	jQuery.each( { padding: "inner" + name, content: type, "": "outer" + name }, function( defaultExtra, funcName ) {
		// margin is only for outerHeight, outerWidth
		jQuery.fn[ funcName ] = function( margin, value ) {
			var chainable = arguments.length && ( defaultExtra || typeof margin !== "boolean" ),
				extra = defaultExtra || ( margin === true || value === true ? "margin" : "border" );

			return access( this, function( elem, type, value ) {
				var doc;

				if ( jQuery.isWindow( elem ) ) {
					// As of 5/8/2012 this will yield incorrect results for Mobile Safari, but there
					// isn't a whole lot we can do. See pull request at this URL for discussion:
					// https://github.com/jquery/jquery/pull/764
					return elem.document.documentElement[ "client" + name ];
				}

				// Get document width or height
				if ( elem.nodeType === 9 ) {
					doc = elem.documentElement;

					// Either scroll[Width/Height] or offset[Width/Height] or client[Width/Height], whichever is greatest
					// unfortunately, this causes bug #3838 in IE6/8 only, but there is currently no good, small way to fix it.
					return Math.max(
						elem.body[ "scroll" + name ], doc[ "scroll" + name ],
						elem.body[ "offset" + name ], doc[ "offset" + name ],
						doc[ "client" + name ]
					);
				}

				return value === undefined ?
					// Get width or height on the element, requesting but not forcing parseFloat
					jQuery.css( elem, type, extra ) :

					// Set width or height on the element
					jQuery.style( elem, type, value, extra );
			}, type, chainable ? margin : undefined, chainable, null );
		};
	});
});


// The number of elements contained in the matched element set
jQuery.fn.size = function() {
	return this.length;
};

jQuery.fn.andSelf = jQuery.fn.addBack;




// Register as a named AMD module, since jQuery can be concatenated with other
// files that may use define, but not via a proper concatenation script that
// understands anonymous AMD modules. A named AMD is safest and most robust
// way to register. Lowercase jquery is used because AMD module names are
// derived from file names, and jQuery is normally delivered in a lowercase
// file name. Do this after creating the global so that if an AMD module wants
// to call noConflict to hide this version of jQuery, it will work.

// Note that for maximum portability, libraries that are not jQuery should
// declare themselves as anonymous modules, and avoid setting a global if an
// AMD loader is present. jQuery is a special case. For more information, see
// https://github.com/jrburke/requirejs/wiki/Updating-existing-libraries#wiki-anon

if ( typeof define === "function" && define.amd ) {
	define( "jquery", [], function() {
		return jQuery;
	});
}




var
	// Map over jQuery in case of overwrite
	_jQuery = window.jQuery,

	// Map over the $ in case of overwrite
	_$ = window.$;

jQuery.noConflict = function( deep ) {
	if ( window.$ === jQuery ) {
		window.$ = _$;
	}

	if ( deep && window.jQuery === jQuery ) {
		window.jQuery = _jQuery;
	}

	return jQuery;
};

// Expose jQuery and $ identifiers, even in
// AMD (#7102#comment:10, https://github.com/jquery/jquery/pull/557)
// and CommonJS for browser emulators (#13566)
if ( typeof noGlobal === strundefined ) {
	window.jQuery = window.$ = jQuery;
}




return jQuery;

}));